
#include <windows.h>
#include <process.h>
#include "myintdef.h"
#include "PowerWildCard.h"


void* (__stdcall *sszrefnewfunc)(intptr_t);
void (__stdcall *sszrefdeletefunc)(void*);

#include "../../ssz/ssz/typeid.h"
#include "../../ssz/ssz/arrayandref.hpp"
#include "../../ssz/ssz/benry.hpp"

SSZCALLBACK g_callback;
void *g_handle;//returnۑĂꍇ߂l̂֐Ăł͂ȂB

const int32_t mask_1 = (1<<1) - 1, mask_2 = (1<<2) - 1, mask_3 = (1<<3) - 1, mask_5 = (1<<5) - 1;

template<typename T> class Cubemap
{
	struct Point
	{
		int32_t x, y, z;
	};
	void * table[1<<15];
	void neodeleter(void **const p, const int n)
	{
		int i;
		for(i = 0; i < 1<<3; i++){
			if(p[i] != NULL){
				if(n > 0){
					neodeleter((void**)p[i], n-1);
				}else{
					delete (T*)p[i];
				}
			}
		}
		delete p;
	}
	void newdeleter(void **const p, const int n)
	{
		int i;
		for(i = 0; i < 1<<6; i++){
			if(p[i] != NULL){
				if(n > 0){
					newdeleter((void**)p[i], n-1);
				}else{
					neodeleter((void**)p[i], 4);
				}
			}
		}
		delete p;
	}
	void deleter(void **const p, const int n)
	{
		int i;
		for(i = 0; i < 1<<9; i++){
			if(p[i] != NULL){
				if(n > 0){
					deleter((void**)p[i], n-1);
				}else{
					newdeleter((void**)p[i], 4);
				}
			}
		}
		delete p;
	}
	inline bool find(void **&next, const int32_t x, const int32_t y, const int32_t z)
	{
		int i;
		next = &table[(x>>27&mask_5)<<10|(y>>27&mask_5)<<5|(z>>27&mask_5)];
		for(i = 24; i >= 15; i -= 3){
			if(*next == NULL) return false;
			next = &((void**)*next)[(x>>i&mask_3)<<6|(y>>i&mask_3)<<3|(z>>i&mask_3)];
		}
		for(i = 13; i >= 5; i -= 2){
			if(*next == NULL) return false;
			next = &((void**)*next)[(x>>i&mask_2)<<4|(y>>i&mask_2)<<2|(z>>i&mask_2)];
		}
		for(i = 4; i >= 0; i -= 1){
			if(*next == NULL) return false;
			next = &((void**)*next)[(x>>i&mask_1)<<2|(y>>i&mask_1)<<1|(z>>i&mask_1)];
		}
		return *next != NULL;
	}
public:
	Cubemap()
	{
		ZeroMemory(table, sizeof(table));
	}
	~Cubemap()
	{
		clear();
	}
	void clear()
	{
		int i;
		for(i = 0; i < 1<<15; i++){
			if(table[i] != NULL){
				deleter((void**)table[i], 3);
				table[i] = NULL;
			}
		}
	}
	void put(const T &item, const int32_t x, const int32_t y, const int32_t z)
	{
		int i;
		void **next;
		next = &table[(x>>27&mask_5)<<10|(y>>27&mask_5)<<5|(z>>27&mask_5)];
		for(i = 24; i >= 15; i -= 3){
			if(*next == NULL){
				*next = (void*)new void*[1<<9];
				ZeroMemory(*next, sizeof(void*)*(1<<9));
			}
			next = &((void**)*next)[(x>>i&mask_3)<<6|(y>>i&mask_3)<<3|(z>>i&mask_3)];
		}
		for(i = 13; i >= 5; i -= 2){
			if(*next == NULL){
				*next = (void*)new void*[1<<6];
				ZeroMemory(*next, sizeof(void*)*(1<<6));
			}
			next = &((void**)*next)[(x>>i&mask_2)<<4|(y>>i&mask_2)<<2|(z>>i&mask_2)];
		}
		for(i = 4; i >= 0; i -= 1){
			if(*next == NULL){
				*next = (void*)new void*[1<<3];
				ZeroMemory(*next, sizeof(void*)*(1<<3));
			}
			next = &((void**)*next)[(x>>i&mask_1)<<2|(y>>i&mask_1)<<1|(z>>i&mask_1)];
		}
		if(*next == NULL) *next = (void*)new T;
		*(T*)*next = item;
	}
	bool get(T &item, const int32_t x, const int32_t y, const int32_t z)
	{
		void **next;
		if(!find(next, x, y, z)) return false;
		item = *(T*)*next;
		return true;
	}
	bool remove(const int32_t x, const int32_t y, const int32_t z)
	{
		void **next;
		if(!find(next, x, y, z)) return false;
		delete (T*)*next;
		*next = NULL;
		return true;
	}
	bool exist(const int32_t x, const int32_t y, const int32_t z)
	{
		void **next;
		return find(next, x, y, z);
	}
};

struct RefClass
{
	Reference ref;
	intptr_t destructor;
	RefClass()
	{
		ref.init();
		destructor = 0;
	}
	~RefClass()
	{
		release();
	}
	RefClass& operator=(const RefClass &rc)
	{
		Reference r = ref;
		if(r.copy(rc.ref) != NULL) release();
		ref = r;
		destructor = rc.destructor;
		return *this;
	}
	void release()
	{
		if(destructor != 0){
			intptr_t ip = (intptr_t)&ref;
			g_callback(g_handle, destructor, &ip, sizeof(intptr_t), 0);
		}
		ref.init();
		destructor = 0;
	}
};


TUserFunc(intptr_t, CreateTable)
{
	ben->SetSSZFunc();
	return (intptr_t)new Cubemap<RefClass>;
}

TUserFunc(void, DeleteTable, Cubemap<RefClass> *pcm)
{
	ben->SetSSZFunc();
	g_callback = ben->callback;
	g_handle = ben->handle;
	delete pcm;
}

TUserFunc(void, HashPut, int32_t z, int32_t y, int32_t x, intptr_t f, Reference r, Cubemap<RefClass> *pcm)
{
	ben->SetSSZFunc();
	RefClass rc;
	rc.ref = r;
	rc.destructor = f;
	g_callback = ben->callback;
	g_handle = ben->handle;
	pcm->put(rc, x, y, z);
	rc.destructor = 0;//dv
}

TUserFunc(bool, HashGet, int32_t z, int32_t y, int32_t x, Reference *pr, Cubemap<RefClass> *pcm)
{
	ben->SetSSZFunc();
	RefClass rc;
	g_callback = ben->callback;
	g_handle = ben->handle;
	if(!pcm->get(rc, x, y, z)) return false;
	*pr = rc.ref;
	rc.destructor = 0;//dv
	return true;
}

TUserFunc(bool, HashRemove, int32_t z, int32_t y, int32_t x, Cubemap<RefClass> *pcm)
{
	ben->SetSSZFunc();
	g_callback = ben->callback;
	g_handle = ben->handle;
	return pcm->remove(x, y, z);
}

TUserFunc(bool, HashExist, int32_t z, int32_t y, int32_t x, Cubemap<RefClass> *pcm)
{
	ben->SetSSZFunc();
	g_callback = ben->callback;
	g_handle = ben->handle;
	return pcm->exist(x, y, z);
}

TUserFunc(void, HashClear, Cubemap<RefClass> *pcm)
{
	ben->SetSSZFunc();
	g_callback = ben->callback;
	g_handle = ben->handle;
	pcm->clear();
}
