
#include <windows.h>
#include <process.h>
#include <shlobj.h>
#include "SDL.h"
#pragma comment(lib, "SDL.lib")
#pragma comment(lib, "SDLmain.lib")
#include "SDL_image.h"
#pragma comment(lib, "SDL_image.lib")
#include "SDL_ttf.h"
#pragma comment(lib, "SDL_ttf.lib")

#include "myintdef.h"
#include "PowerWildCard.h"


void* (__stdcall *sszrefnewfunc)(intptr_t);
void (__stdcall *sszrefdeletefunc)(void*);

#include "../../ssz/ssz/typeid.h"
#include "../../ssz/ssz/arrayandref.hpp"
#include "../../ssz/ssz/benry.hpp"

int32_t ransuutane;
int g_w = 640, g_h = 480;

TUserFunc(void, Init, int h, int w, Reference cap, SDL_Surface **pps)
{
	PWCArray<char> tmp;
	if(SDL_Init(SDL_INIT_VIDEO) < 0){
		*pps = NULL;
	}else{
		TTF_Init();
		ben->ReftoAstr(CP_UTF8, tmp, cap);
		SDL_WM_SetCaption(tmp.GetConst(), NULL);
		*pps = SDL_SetVideoMode(w, h, 32, SDL_HWSURFACE);
	}
	g_w = w;
	g_h = h;
}

TUserFunc(void, FullScreen, bool fs, SDL_Surface **pps)
{
	*pps = SDL_SetVideoMode(g_w, g_h, 32, SDL_HWSURFACE | (fs ? SDL_FULLSCREEN : 0));
}

TUserFunc(void, End)
{
	SDL_Quit();
}

TUserFunc(bool, PollEvent, int8_t *pb)
{
	const int activeofs  =            sizeof(int32_t);
	const int keyofs     =  activeofs+sizeof(int32_t)+sizeof(uint8_t)+sizeof(uint8_t);
	const int motionofs  =     keyofs+sizeof(int32_t)+sizeof(uint8_t)+sizeof(uint8_t)+sizeof(uint8_t)+sizeof(int32_t)+sizeof(int32_t)+sizeof(uint16_t);
	const int buttonofs  =  motionofs+sizeof(int32_t)+sizeof(uint8_t)+sizeof(uint8_t)+sizeof(uint16_t)+sizeof(uint16_t)+sizeof(int16_t)+sizeof(int16_t);
	const int jaxisofs   =  buttonofs+sizeof(int32_t)+sizeof(uint8_t)+sizeof(uint8_t)+sizeof(uint8_t)+sizeof(uint16_t)+sizeof(uint16_t);
	const int jballofs   =   jaxisofs+sizeof(int32_t)+sizeof(uint8_t)+sizeof(uint8_t)+sizeof(int16_t);
	const int jhatofs    =   jballofs+sizeof(int32_t)+sizeof(uint8_t)+sizeof(uint8_t)+sizeof(int16_t)+sizeof(int16_t);
	const int jbuttonofs =    jhatofs+sizeof(int32_t)+sizeof(uint8_t)+sizeof(uint8_t)+sizeof(uint8_t);
	const int resizeofs  = jbuttonofs+sizeof(int32_t)+sizeof(uint8_t)+sizeof(uint8_t)+sizeof(uint8_t);
	const int exposeofs  =  resizeofs+sizeof(int32_t)+sizeof(int32_t)+sizeof(int32_t);
	const int quitofs    =  exposeofs+sizeof(int32_t);
	const int userofs    =    quitofs+sizeof(int32_t);
	bool ret;
	SDL_Event ev;
	ret = SDL_PollEvent(&ev) != 0;

	*(int32_t *)pb = ev.type;
	switch(ev.type){
	case SDL_ACTIVEEVENT:
		pb += activeofs;
		*(int32_t *)pb = ev.active.type;           pb += sizeof(int32_t);
		*(uint8_t *)pb = ev.active.gain;           pb += sizeof(uint8_t);
		*(uint8_t *)pb = ev.active.state;          pb += sizeof(uint8_t);
		break;
	case SDL_KEYDOWN:
	case SDL_KEYUP:
		pb += keyofs;
		*(int32_t *)pb = ev.key.type;              pb += sizeof(int32_t);
		*(uint8_t *)pb = ev.key.which;             pb += sizeof(uint8_t);
		*(uint8_t *)pb = ev.key.state;             pb += sizeof(uint8_t);
		*(uint8_t *)pb = ev.key.keysym.scancode;   pb += sizeof(uint8_t);
		*(int32_t *)pb = ev.key.keysym.sym;        pb += sizeof(int32_t);
		*(int32_t *)pb = ev.key.keysym.mod;        pb += sizeof(int32_t);
		*(uint16_t *)pb = ev.key.keysym.unicode;   pb += sizeof(uint16_t);
		break;
	case SDL_MOUSEMOTION:
		pb += motionofs;
		*(int32_t *)pb = ev.motion.type;           pb += sizeof(int32_t);
		*(uint8_t *)pb = ev.motion.which;          pb += sizeof(uint8_t);
		*(uint8_t *)pb = ev.motion.state;          pb += sizeof(uint8_t);
		*(uint16_t *)pb = ev.motion.x;             pb += sizeof(uint16_t);
		*(uint16_t *)pb = ev.motion.y;             pb += sizeof(uint16_t);
		*(int16_t *)pb = ev.motion.xrel;           pb += sizeof(int16_t);
		*(int16_t *)pb = ev.motion.yrel;           pb += sizeof(int16_t);
		break;
	case SDL_MOUSEBUTTONDOWN:
	case SDL_MOUSEBUTTONUP:
		pb += buttonofs;
		*(int32_t *)pb = ev.button.type;           pb += sizeof(int32_t);
		*(uint8_t *)pb = ev.button.which;          pb += sizeof(uint8_t);
		*(uint8_t *)pb = ev.button.button;         pb += sizeof(uint8_t);
		*(uint8_t *)pb = ev.button.state;          pb += sizeof(uint8_t);
		*(uint16_t *)pb = ev.button.x;             pb += sizeof(uint16_t);
		*(uint16_t *)pb = ev.button.y;             pb += sizeof(uint16_t);
		break;
	case SDL_JOYAXISMOTION:
		pb += jaxisofs;
		*(int32_t *)pb = ev.jaxis.type;            pb += sizeof(int32_t);
		*(uint8_t *)pb = ev.jaxis.which;           pb += sizeof(uint8_t);
		*(uint8_t *)pb = ev.jaxis.axis;            pb += sizeof(uint8_t);
		*(int16_t *)pb = ev.jaxis.value;           pb += sizeof(int16_t);
		break;
	case SDL_JOYBALLMOTION:
		pb += jballofs;
		*(int32_t *)pb = ev.jball.type;            pb += sizeof(int32_t);
		*(uint8_t *)pb = ev.jball.which;           pb += sizeof(uint8_t);
		*(uint8_t *)pb = ev.jball.ball;            pb += sizeof(uint8_t);
		*(int16_t *)pb = ev.jball.xrel;            pb += sizeof(int16_t);
		*(int16_t *)pb = ev.jball.yrel;            pb += sizeof(int16_t);
		break;
	case SDL_JOYHATMOTION:
		pb += jhatofs;
		*(int32_t *)pb = ev.jhat.type;             pb += sizeof(int32_t);
		*(uint8_t *)pb = ev.jhat.which;            pb += sizeof(uint8_t);
		*(uint8_t *)pb = ev.jhat.hat;              pb += sizeof(uint8_t);
		*(uint8_t *)pb = ev.jhat.value;            pb += sizeof(uint8_t);
		break;
	case SDL_JOYBUTTONDOWN:
	case SDL_JOYBUTTONUP:
		pb += jbuttonofs;
		*(int32_t *)pb = ev.jbutton.type;          pb += sizeof(int32_t);
		*(uint8_t *)pb = ev.jbutton.which;         pb += sizeof(uint8_t);
		*(uint8_t *)pb = ev.jbutton.button;        pb += sizeof(uint8_t);
		*(uint8_t *)pb = ev.jbutton.state;         pb += sizeof(uint8_t);
		break;
	case SDL_VIDEORESIZE:
		pb += resizeofs;
		*(int32_t *)pb = ev.resize.type;           pb += sizeof(int32_t);
		*(int32_t *)pb = ev.resize.w;              pb += sizeof(int32_t);
		*(int32_t *)pb = ev.resize.h;              pb += sizeof(int32_t);
		break;
	case SDL_VIDEOEXPOSE:
		pb += exposeofs;
		*(int32_t *)pb = ev.expose.type;           pb += sizeof(int32_t);
		break;
	case SDL_QUIT:
		pb += quitofs;
		*(int32_t *)pb = ev.quit.type;             pb += sizeof(int32_t);
		break;
	case SDL_USEREVENT:
		pb += userofs;
		*(int32_t *)pb = ev.user.type;             pb += sizeof(int32_t);
		*(int32_t *)pb = ev.user.code;             pb += sizeof(int32_t);
		*(intptr_t *)pb = (intptr_t)ev.user.data1; pb += sizeof(intptr_t);
		*(intptr_t *)pb = (intptr_t)ev.user.data2; pb += sizeof(intptr_t);
		break;
	}
	return ret;
}

TUserFunc(bool, KeyState, int32_t key)
{
	return SDL_GetKeyState(NULL)[key] == SDL_PRESSED;
}

TUserFunc(void, Fill, uint32_t color, SDL_Rect *prect, SDL_Surface *ps)
{
	SDL_FillRect(ps, prect, color);
}

TUserFunc(intptr_t, IMGLoad, Reference fn)
{
	PWCArray<char> tmp;
	ben->ReftoAstr(CP_ACP, tmp, fn);
	return (intptr_t)IMG_Load(tmp.GetConst());
}

TUserFunc(void, BlitSurfaceEx, SDL_Rect *pdstr, SDL_Surface *pdsts, SDL_Rect *psrcr, SDL_Surface *psrcs)
{
	SDL_BlitSurface(psrcs, psrcr, pdsts, pdstr);
}

TUserFunc(void, BlitSurface, SDL_Rect *prect, SDL_Surface *pdsts, SDL_Surface *psrcs)
{
	SDL_BlitSurface(psrcs, NULL, pdsts, prect);
}

TUserFunc(void, Flip, SDL_Surface *ps)
{
	SDL_Flip(ps);
}

TUserFunc(intptr_t, AllocSurface, int32_t h, int32_t w)
{
	return (intptr_t)SDL_CreateRGBSurface(SDL_SWSURFACE, w, h, 32, 0x00FF0000, 0x0000FF00, 0x000000FF, 0xFF000000);
}

TUserFunc(void, FreeSurface, SDL_Surface *ps)
{
	SDL_FreeSurface(ps);
}

TUserFunc(void, Delay, uint32_t ms)
{
	SDL_Delay(ms);
}

TUserFunc(uint32_t, GetTicks)
{
	return SDL_GetTicks();
}

TUserFunc(void, SetAlpha, uint8_t a, SDL_Surface *ps)
{
	SDL_SetAlpha(ps, SDL_SRCALPHA, a);
}

TUserFunc(intptr_t, OpenFont, int32_t size, Reference font)
{
	TTF_Font *pf;
	PWCArray<char> tmp;
	ben->ReftoAstr(CP_ACP, tmp, font);
	pf = TTF_OpenFont(tmp.GetConst(), size);
	TTF_SetFontStyle (pf, TTF_STYLE_NORMAL);
	return (intptr_t)pf;
}

TUserFunc(void, CloseFont, TTF_Font *pf)
{
	TTF_CloseFont(pf);
}

TUserFunc(void, RenderFont, SDL_Surface *ps, Reference str, int16_t y, int16_t x, bool srcalpha, SDL_Color c, TTF_Font *pf)
{
	PWCArray<wchar_t> tmp;
	SDL_Surface *psrc;
	SDL_Rect dest;
	dest.x = x;
	dest.y = y;
	ben->ReftoWstr(tmp, str);
	psrc = TTF_RenderUNICODE_Blended(pf, (Uint16*)tmp.GetConst(), c);
	SDL_SetAlpha(psrc, (srcalpha ? SDL_SRCALPHA : 0), SDL_ALPHA_OPAQUE);
	SDL_BlitSurface(psrc, NULL, ps, &dest);
	SDL_FreeSurface(psrc);
}
