
enum REGISTER{EAX = 0, ECX = 1, EDX = 2, EBX = 3, ESP = 4, EBP = 5, ESI = 6, EDI = 7};
enum REGISTER8{AL = 0, CL = 1, DL = 2, BL = 3, AH = 4, CH = 5, DH = 6, BH = 7};

inline uint8_t ModRM(uint8_t mod, uint8_t reg, uint8_t rm)
{
	return mod<<6 | reg<<3 | rm;
}
inline uint8_t SIB(uint8_t scale, REGISTER index, REGISTER base)
{
	return scale<<6 | index<<3 | base;
}


class JITer
{
	typedef SourceTree<JunkanGoroshi> SrcTree;
	SrcTree *root;
	PWCArray<wchar_t> *filename;
	intptr_t gyousuu;
	intptr_t yobunipop;
	PWCArray<uint8_t> ntvcode;
	PWCArray<intptr_t> gbladrbp;
	PWCArray<intptr_t> cadrpbp;
	PWCArray<intptr_t> cadrmbp;
	struct KuwashiiType
	{
		int32_t id;
		SrcTree *pstre;
		PWCArray<intptr_t> kwsk;
		KuwashiiType()
		{
			pstre = NULL;
		}
		KuwashiiType& operator=(const KuwashiiType &x)
		{
			id = x.id;
			pstre = x.pstre;
			kwsk = x.kwsk;
			return *this;
		}
	};
	enum AddressType
	{
		AT_LOCAL, AT_MEMBER, AT_GLOBAL, AT_SANSHOU
	};
	class Compi
	{
	protected:
		JITer *pjtr;
		int64_t castvar;
	public:
		struct ThreadStructure
		{
			void *calladr;
			void* (__stdcall *jigoshori)();
			void *argument;
			intptr_t argsize;
		};
		static unsigned __stdcall ThreadFunction(void *p)
		{
			void *parg = ((ThreadStructure*)p)->argument, *cadr = ((ThreadStructure*)p)->calladr, *pend;
			pend = (int8_t*)parg + ((ThreadStructure*)p)->argsize;
			__asm{
				mov ecx,pend
				mov edx,parg
			loop1:
				cmp edx,ecx
				jnb loop1e
				sub ecx,4
				push dword ptr [ecx]
				jmp loop1
			loop1e:
				call cadr
			}
			cadr = ((ThreadStructure*)p)->jigoshori;
			if(cadr != NULL){
				__asm{
					push edi
					push esi
					push ebx
					mov edi,parg
					call cadr
					pop ebx
					pop esi
					pop edi
				}
			}
			delete [] (int8_t*)parg;
			delete (ThreadStructure*)p;
			return 0;
		}
		static void __cdecl ThreadRun(void* (__stdcall *jgsr)(), void *calladr, intptr_t argsize, ...)
		{
			va_list ap;
			intptr_t i;
			ThreadStructure *pts = new ThreadStructure;
			pts->argsize = argsize;
			pts->calladr = calladr;
			pts->jigoshori = jgsr;
			va_start(ap, argsize);
			if(argsize > 0){
				pts->argument = new int8_t[argsize];
				for(i = 0; i < argsize; i += 4){
					*(int32_t*)(((int8_t*)pts->argument)+i) = va_arg(ap, int32_t); 
				}
			}else{
				pts->argument = NULL;
			}
			va_arg(ap, Thread*)->create(ThreadFunction, pts);
			va_end(ap);
		}
		static bool __cdecl ConstEval(MAIN_FUNC pm, SrcTree *pst, ...)
		{
			va_list ap;
			int32_t tid;
			intptr_t idx, t;
			void *p;
			Reference r;
			PWCArray<intptr_t> type, last;
			Source<JunkanGoroshi> src(pst->stat->ss);
			va_start(ap, pst);
			idx = 0;
			type = CONST_TOKEN;
			switch(tid = TokenTtoTypeId((intptr_t*)ap, idx)){
			case METHOD_TYPEID:
				idx++;
			case FUNC_TYPEID:
			case DELEGATE_TYPEID:
				type.AddTail((intptr_t*)ap, idx);
				FuncToken(type, (intptr_t*)ap, idx);
				break;
			default:
				type.AddTail((intptr_t*)ap, idx);
			}
			for(t = 0; t < idx; t++) va_arg(ap, intptr_t);
			r = va_arg(ap, Reference);
			p = va_arg(ap, void*);
			va_end(ap);
			src.Clear();
			src.source.AddTail((wchar_t*)r.atpos(), r.len()/sizeof(wchar_t));
			t = 0;
			if(!pst->ConstShiki(src, t, NULL_TOKEN, src.GetToken(t), last, NULL_TOKEN, true)
				|| src.GetToken(t) != NULL_TOKEN || !pst->ConstCaster(last, type)){
				pst->stat->ss->ErrorMessage.Clear();
				return false;
			}
			switch(tid){
			case BYTE_TYPEID:
				*(int8_t*)p = *(int8_t*)(last.GetConst()+idx+1);
				break;
			case UBYTE_TYPEID:
				*(uint8_t*)p = *(uint8_t*)(last.GetConst()+idx+1);
				break;
			case SHORT_TYPEID:
				*(int16_t*)p = *(int16_t*)(last.GetConst()+idx+1);
				break;
			case USHORT_TYPEID:
				*(uint16_t*)p = *(uint16_t*)(last.GetConst()+idx+1);
				break;
			case INT_TYPEID:
				*(int32_t*)p = *(int32_t*)(last.GetConst()+idx+1);
				break;
			case UINT_TYPEID:
				*(uint32_t*)p = *(uint32_t*)(last.GetConst()+idx+1);
				break;
			case LONG_TYPEID:
				*(int64_t*)p = *(int64_t*)(last.GetConst()+idx+1);
				break;
			case ULONG_TYPEID:
				*(uint64_t*)p = *(uint64_t*)(last.GetConst()+idx+1);
				break;
			case CHAR_TYPEID:
				*(wchar_t*)p = *(wchar_t*)(last.GetConst()+idx+1);
				break;
			case ADDRESS_TYPEID:
				*(intptr_t*)p = *(intptr_t*)(last.GetConst()+idx+1);
				break;
			case FLOAT_TYPEID:
				*(float*)p = *(float*)(last.GetConst()+idx+1);
				break;
			case DOUBLE_TYPEID:
				*(double*)p = *(double*)(last.GetConst()+idx+1);
				break;
			case BOOL_TYPEID:
				*(bool*)p = *(bool*)(last.GetConst()+idx+1);
				break;
			case FUNC_TYPEID:
			case METHOD_TYPEID:
				*(intptr_t*)p = (intptr_t)pm + pst->stat->funclist.Get(*(int32_t*)(last.GetConst()+idx+1))->byteadress;
				break;
			default:
				return false;
			}
			return true;
		}
		static void __stdcall PutGbld(SSZStatic<JunkanGoroshi> *ss, void (__stdcall *d)())
		{
			ss->gbldel += d;
		}
		static void __stdcall RunGbld(SSZStatic<JunkanGoroshi> *ss)
		{
			intptr_t i;
			for(i = ss->gbldel.GetLength()-1; i >= 0; i--) ss->gbldel.GetConst()[i]();
			ss->gbldel.Clear();
		}
		static void* __stdcall CallBack(void *pcbs, intptr_t calladr, void *phikisuu, intptr_t hikisize, intptr_t retsize)
		{
			void *pend = (int8_t*)phikisuu + hikisize;
			int32_t i32, i32_2;
			switch(retsize){
			case 0:
				__asm{
					mov ecx,pend
					mov edx,phikisuu
				loop_0:
					cmp edx,ecx
					jnb loop_0e
					sub ecx,4
					push dword ptr [ecx]
					jmp loop_0
				loop_0e:
					call calladr
				}
				break;
			case 1:
				__asm{
					mov ecx,pend
					mov edx,phikisuu
				loop_1:
					cmp edx,ecx
					jnb loop_1e
					sub ecx,4
					push dword ptr [ecx]
					jmp loop_1
				loop_1e:
					call calladr
					mov i32,eax
				}
				*(int8_t*)pcbs = (int8_t)i32;
				break;
			case 2:
				__asm{
					mov ecx,pend
					mov edx,phikisuu
				loop_2:
					cmp edx,ecx
					jnb loop_2e
					sub ecx,4
					push dword ptr [ecx]
					jmp loop_2
				loop_2e:
					call calladr
					mov i32,eax
				}
				*(int16_t*)pcbs = (int16_t)i32;
				break;
			case 4:
				__asm{
					mov ecx,pend
					mov edx,phikisuu
				loop_4:
					cmp edx,ecx
					jnb loop_4e
					sub ecx,4
					push dword ptr [ecx]
					jmp loop_4
				loop_4e:
					call calladr
					mov i32,eax
				}
				*(int32_t*)pcbs = i32;
				break;
			case 8:
				__asm{
					mov ecx,pend
					mov edx,phikisuu
				loop_8:
					cmp edx,ecx
					jnb loop_8e
					sub ecx,4
					push dword ptr [ecx]
					jmp loop_8
				loop_8e:
					call calladr
					mov i32,eax
					mov i32_2,edx
				}
				*(int64_t*)pcbs = (int64_t)i32 | ((int64_t)i32_2<<32);
				break;
			}
			return pcbs;
		}
		static void __stdcall DRDSwitch(SrcTree *pst, const int32_t id, HeapObj *const pho, MAIN_FUNC pm)
		{
			intptr_t i, calladr;
			void *p;
			if(0 <= id && id <= ENDCLASS_TYPEID && pst->stat->funclist.Get(id)->deladress > 0){
				for(i = 0; i < pho->head.datasize; ){
					p = pho->head.data + i;
					calladr = (intptr_t)pm + pst->stat->funclist.Get(id)->deladress;
					__asm{
						push edi
						push esi
						push ebx
						mov edi,p
						call calladr
						pop ebx
						pop esi
						pop edi
					}
					i +=  pst->stat->funclist.Get(id)->GetMemberSize();
				}
			}else if(-1 >= id && id >= ENDCLASS_TYPEID){
				for(i = 0; i < pho->head.datasize; i += sizeof(Thread)){
					((Thread*)(pho->head.data+i))->wait();
				}
			}
		}
		static void __stdcall DynRefDelete(SrcTree *pst, DynamicRef *pdr, MAIN_FUNC pm)
		{
			if((intptr_t)pdr->obj.pointer <= 0){
			}else if(InterlockedDecrement((LPLONG)&pdr->obj.pointer->head.refcount) != 0){
				if(0 <= pdr->typ && pdr->typ <= ENDCLASS_TYPEID &&  pst->stat->funclist.Get(pdr->typ)->IsJunkanAble()){
					pst->stat->ss->CircularGC.RefDwn(pdr->obj.pointer);
				}
			}else{
				if(pdr->obj.pointer->head.datasize > 0) DRDSwitch(pst, pdr->typ, pdr->obj.pointer, pm);
				if(0 <= pdr->typ && pdr->typ <= ENDCLASS_TYPEID &&  pst->stat->funclist.Get(pdr->typ)->IsJunkanAble()){
					pst->stat->ss->CircularGC.RefDel(pdr->obj.pointer);
				}
				pdr->obj.pointer->delet();
			}
			pdr->init();
		}
		static void __stdcall DynRefCopy(SrcTree *pst, int32_t styp, DynamicRef *pdr, MAIN_FUNC pm, Reference src)
		{
			HeapObj *ph, *oldp;
			int32_t id;
			oldp = pdr->obj.pointer;
			id = pdr->typ;
			ph = pdr->obj.copy(src);
			if(ph == NULL){
				if((intptr_t)oldp > 0 && 0 <= id && id <= ENDCLASS_TYPEID &&  pst->stat->funclist.Get(id)->IsJunkanAble()){
					pst->stat->ss->CircularGC.RefDwn(oldp);
				}
			}else{
				if(ph->head.datasize > 0) DRDSwitch(pst, id, ph, pm); 
				if(0 <= id && id <= ENDCLASS_TYPEID &&  pst->stat->funclist.Get(id)->IsJunkanAble()){
					pst->stat->ss->CircularGC.RefDel(ph);
				}
				ph->delet();
			}
			pdr->typ = styp;
		}
		static bool __stdcall DynRefGet(SrcTree *pst, int32_t typ, MAIN_FUNC pm, Reference *dst, DynamicRef src)
		{
			HeapObj *ph, *oldp;
			if(typ != src.typ) return false;
			oldp = dst->pointer;
			ph = dst->copy(src.obj);
			if(ph == NULL){
				if((intptr_t)oldp > 0 && 0 <= src.typ && src.typ <= ENDCLASS_TYPEID &&  pst->stat->funclist.Get(src.typ)->IsJunkanAble()){
					pst->stat->ss->CircularGC.RefDwn(oldp);
				}
			}else{
				if(ph->head.datasize > 0) DRDSwitch(pst, src.typ, ph, pm); 
				if(0 <= src.typ && src.typ <= ENDCLASS_TYPEID &&  pst->stat->funclist.Get(src.typ)->IsJunkanAble()){
					pst->stat->ss->CircularGC.RefDel(ph);
				}
				ph->delet();
			}
			return true;
		}
		static intptr_t __stdcall DynRefTypeSize(SrcTree *pst, DynamicRef dr)
		{
			return pst->TypeIdtoSize(dr.typ);
		}
		static intptr_t __stdcall DynRefLen(SrcTree *pst, DynamicRef dr)
		{
			return dr.obj.len() / pst->TypeIdtoSize(dr.typ);
		}
		static void __stdcall RefCntUp(Reference *r)
		{
			r->countup();
		}
		static bool __stdcall RefCntDwn(Reference *r)
		{
			if((intptr_t)r->pointer > 0 && InterlockedDecrement((LPLONG)&r->pointer->head.refcount) == 0){
				if(r->pointer->head.datasize > 0) return true;
				r->pointer->delet();
			}
			r->init();
			return false;
		}
		static bool __stdcall RefCopy(Reference *dst, Reference *src)
		{
			Reference tmp = *dst;
			HeapObj *php = dst->copy(*src);
			if(php != NULL){
				if(php->head.datasize > 0){
					*src = tmp;
					return true;
				}
				php->delet();
			}
			return false;
		}
		static void __stdcall RefDel(Reference *r)
		{
			r->pointer->delet();
			r->init();
		}
		static void __stdcall RefeNew(Reference *r, intptr_t l, intptr_t ts)
		{
			r->refnew(l, ts);
		}
		static void __stdcall ListNew(Reference *r, intptr_t l, intptr_t ts)
		{
			r->listnew(l, ts);
		}
		static int8_t* __stdcall ListIdxNew(Reference *r, intptr_t i, intptr_t ts)
		{
			return r->listnewat(i, ts);
		}
		static int8_t* __stdcall ListIdxNewZeroClear(Reference *r, intptr_t i, intptr_t ts)
		{
			intptr_t ol = r->len();
			int8_t *ret = r->listnewat(i, ts);
			ZeroMemory(r->obj()->head.data + ol, r->obj()->head.datasize - ol);
			return ret;
		}
		static int8_t* __stdcall ListIdxNewDynRefInit(Reference *r, intptr_t i, intptr_t ts)
		{
			intptr_t ol = r->len();
			int8_t *p, *pend, *ret = r->listnewat(i, ts);
			p = r->obj()->head.data + ol;
			pend = p + r->obj()->head.datasize - ol;
			for(; p < pend; p += sizeof(DynamicRef)) ((DynamicRef*)p)->init();
			return ret;
		}
		static int8_t* __stdcall ListIdxNewClass(void* (__stdcall *newer)(), Reference *r, intptr_t i, intptr_t ts)
		{
			intptr_t ol = r->len();
			int8_t *p, *pend, *ret = r->listnewat(i, ts);
			p = r->obj()->head.data + ol;
			pend = p + r->obj()->head.datasize - ol;
			for(; p < pend; p += ts){
				__asm{
					push edi
					push esi
					push ebx
					mov edi,p
					call newer
					pop ebx
					pop esi
					pop edi
				}
			}
			return ret;
		}
		static int8_t* __stdcall CircListIdxNewClass(SSZStatic<JunkanGoroshi> *ss, intptr_t rpid, void* (__stdcall *newer)(), Reference *r, intptr_t i, intptr_t ts)
		{
			intptr_t ol = r->len();
			int8_t *p, *pend, *ret;
			if(r->null()){
				ret = r->listnewat(i, ts);
				ss->CircularGC.RefNew(rpid, r->pointer);
			}else{
				ret = r->listnewat(i, ts);
			}
			p = r->obj()->head.data + ol;
			pend = p + r->obj()->head.datasize - ol;
			for(; p < pend; p += ts){
				__asm{
					push edi
					push esi
					push ebx
					mov edi,p
					call newer
					pop ebx
					pop esi
					pop edi
				}
			}
			return ret;
		}
		static bool __stdcall CircRefCntDwn(SSZStatic<JunkanGoroshi> *ss, Reference *r)
		{
			if((intptr_t)r->pointer > 0){
				if(InterlockedDecrement((LPLONG)&r->pointer->head.refcount) == 0){
					if(r->pointer->head.datasize > 0) return true;
					r->pointer->delet();
				}else{
					ss->CircularGC.RefDwn(r->pointer);
				}
			}
			r->init();
			return false;
		}
		static bool __stdcall CircRefCopy(SSZStatic<JunkanGoroshi> *ss, Reference *dst, Reference *src)
		{
			Reference tmp = *dst;
			HeapObj *php = dst->copy(*src);
			if(php != NULL){
				if(php->head.datasize > 0){
					*src = tmp;
					return true;
				}
				php->delet();
			}else if((intptr_t)tmp.pointer > 0){
				ss->CircularGC.RefDwn(tmp.pointer);
			}
			return false;
		}
		static void __stdcall CircRefDel(SSZStatic<JunkanGoroshi> *ss, Reference *r)
		{
			HeapObj *ph = r->pointer;
			ss->CircularGC.RefDel(ph);
			r->init();
			ph->delet();
		}
		static void __stdcall CircRefeNew(SSZStatic<JunkanGoroshi> *ss, intptr_t rpid, Reference *r, intptr_t l, intptr_t ts)
		{
			r->refnew(l, ts);
			ss->CircularGC.RefNew(rpid, r->pointer);
		}
		static void __stdcall CircListNew(SSZStatic<JunkanGoroshi> *ss, intptr_t rpid, Reference *r, intptr_t l, intptr_t ts)
		{
			r->listnew(l, ts);
			ss->CircularGC.RefNew(rpid, r->pointer);
		}
		static void __stdcall ListAppend(Reference *r, intptr_t size, void *p)
		{
			intptr_t idx;
			idx = r->addsize(1, size);
			memcpy(r->obj()->head.data+idx, p, size);
		}
		static void __stdcall ListAppend8(Reference *r, int8_t i8)
		{
			intptr_t idx;
			idx = r->addsize(1, sizeof(int8_t));
			*(int8_t*)(r->obj()->head.data+idx) = i8;
		}
		static void __stdcall ListAppend16(Reference *r, int16_t i16)
		{
			intptr_t idx;
			idx = r->addsize(1, sizeof(int16_t));
			*(int16_t*)(r->obj()->head.data+idx) = i16;
		}
		static void __stdcall ListAppend32(Reference *r, int32_t i32)
		{
			intptr_t idx;
			idx = r->addsize(1, sizeof(int32_t));
			*(int32_t*)(r->obj()->head.data+idx) = i32;
		}
		static void __stdcall ListAppend64(Reference *r, int64_t i64)
		{
			intptr_t idx;
			idx = r->addsize(1, sizeof(int64_t));
			*(int64_t*)(r->obj()->head.data+idx) = i64;
		}
		static void __stdcall ListAppendRef(Reference *r, Reference src)
		{
			intptr_t idx, l;
			l = src.len();//addsizeŒς̂ŕۑ
			if(l > 0){
				idx = r->addsize(l, 1);
				memcpy(r->obj()->head.data+idx, src.obj()->head.data+src.position, l);
			}
		}
		static void* __stdcall RefPos(Reference r)
		{
			return r.atpos();
		}
		static void* __stdcall RefPosNullable(Reference r)
		{
			return r.null() ? NULL : r.atpos();
		}
		static void* __stdcall RefIdx(intptr_t ts, intptr_t i, Reference r)
		{
			return r.refat(i, ts);
		}
		static void* __stdcall RefIdxS1(intptr_t i, Reference r)
		{
			return r.refat<1>(i);
		}
		static void* __stdcall RefIdxS2(intptr_t i, Reference r)
		{
			return r.refat<2>(i);
		}
		static void* __stdcall RefIdxS3(intptr_t i, Reference r)
		{
			return r.refat<3>(i);
		}
		static void* __stdcall RefIdxS4(intptr_t i, Reference r)
		{
			return r.refat<4>(i);
		}
		static void* __stdcall RefIdxS5(intptr_t i, Reference r)
		{
			return r.refat<5>(i);
		}
		static void* __stdcall RefIdxS6(intptr_t i, Reference r)
		{
			return r.refat<6>(i);
		}
		static void* __stdcall RefIdxS7(intptr_t i, Reference r)
		{
			return r.refat<7>(i);
		}
		static void* __stdcall RefIdxS8(intptr_t i, Reference r)
		{
			return r.refat<8>(i);
		}
		static void* __stdcall RefIdxS9(intptr_t i, Reference r)
		{
			return r.refat<9>(i);
		}
		static void* __stdcall RefIdxS10(intptr_t i, Reference r)
		{
			return r.refat<10>(i);
		}
		static void* __stdcall RefIdxS11(intptr_t i, Reference r)
		{
			return r.refat<11>(i);
		}
		static void* __stdcall RefIdxS12(intptr_t i, Reference r)
		{
			return r.refat<12>(i);
		}
		static void* __stdcall RefIdxS13(intptr_t i, Reference r)
		{
			return r.refat<13>(i);
		}
		static void* __stdcall RefIdxS14(intptr_t i, Reference r)
		{
			return r.refat<14>(i);
		}
		static void* __stdcall RefIdxS15(intptr_t i, Reference r)
		{
			return r.refat<15>(i);
		}
		static void* __stdcall RefIdxS16(intptr_t i, Reference r)
		{
			return r.refat<16>(i);
		}
		static void* __stdcall ListIdx(intptr_t ts, intptr_t i, Reference r)
		{
			return r.listat(i, ts);
		}
		static void* __stdcall ListIdxS1(intptr_t i, Reference r)
		{
			return r.listat<1>(i);
		}
		static void* __stdcall ListIdxS2(intptr_t i, Reference r)
		{
			return r.listat<2>(i);
		}
		static void* __stdcall ListIdxS3(intptr_t i, Reference r)
		{
			return r.listat<3>(i);
		}
		static void* __stdcall ListIdxS4(intptr_t i, Reference r)
		{
			return r.listat<4>(i);
		}
		static void* __stdcall ListIdxS5(intptr_t i, Reference r)
		{
			return r.listat<5>(i);
		}
		static void* __stdcall ListIdxS6(intptr_t i, Reference r)
		{
			return r.listat<6>(i);
		}
		static void* __stdcall ListIdxS7(intptr_t i, Reference r)
		{
			return r.listat<7>(i);
		}
		static void* __stdcall ListIdxS8(intptr_t i, Reference r)
		{
			return r.listat<8>(i);
		}
		static void* __stdcall ListIdxS9(intptr_t i, Reference r)
		{
			return r.listat<9>(i);
		}
		static void* __stdcall ListIdxS10(intptr_t i, Reference r)
		{
			return r.listat<10>(i);
		}
		static void* __stdcall ListIdxS11(intptr_t i, Reference r)
		{
			return r.listat<11>(i);
		}
		static void* __stdcall ListIdxS12(intptr_t i, Reference r)
		{
			return r.listat<12>(i);
		}
		static void* __stdcall ListIdxS13(intptr_t i, Reference r)
		{
			return r.listat<13>(i);
		}
		static void* __stdcall ListIdxS14(intptr_t i, Reference r)
		{
			return r.listat<14>(i);
		}
		static void* __stdcall ListIdxS15(intptr_t i, Reference r)
		{
			return r.listat<15>(i);
		}
		static void* __stdcall ListIdxS16(intptr_t i, Reference r)
		{
			return r.listat<16>(i);
		}
		static intptr_t __stdcall RefLen(intptr_t ts, Reference r)
		{
			return r.len() / ts;
		}
		static intptr_t __stdcall RefLenS1(Reference r)
		{
			return r.len() / 1;
		}
		static intptr_t __stdcall RefLenS2(Reference r)
		{
			return r.len() / 2;
		}
		static intptr_t __stdcall RefLenS3(Reference r)
		{
			return r.len() / 3;
		}
		static intptr_t __stdcall RefLenS4(Reference r)
		{
			return r.len() / 4;
		}
		static intptr_t __stdcall RefLenS5(Reference r)
		{
			return r.len() / 5;
		}
		static intptr_t __stdcall RefLenS6(Reference r)
		{
			return r.len() / 6;
		}
		static intptr_t __stdcall RefLenS7(Reference r)
		{
			return r.len() / 7;
		}
		static intptr_t __stdcall RefLenS8(Reference r)
		{
			return r.len() / 8;
		}
		static intptr_t __stdcall RefLenS9(Reference r)
		{
			return r.len() / 9;
		}
		static intptr_t __stdcall RefLenS10(Reference r)
		{
			return r.len() / 10;
		}
		static intptr_t __stdcall RefLenS11(Reference r)
		{
			return r.len() / 11;
		}
		static intptr_t __stdcall RefLenS12(Reference r)
		{
			return r.len() / 12;
		}
		static intptr_t __stdcall RefLenS13(Reference r)
		{
			return r.len() / 13;
		}
		static intptr_t __stdcall RefLenS14(Reference r)
		{
			return r.len() / 14;
		}
		static intptr_t __stdcall RefLenS15(Reference r)
		{
			return r.len() / 15;
		}
		static intptr_t __stdcall RefLenS16(Reference r)
		{
			return r.len() / 16;
		}
		static void __stdcall RefSlice(intptr_t ts, Reference *r, intptr_t m, intptr_t k)
		{
			r->slice(k, m, ts);
		}
		static void __stdcall RefSliceS1(Reference *r, intptr_t m, intptr_t k)
		{
			r->slice<1>(k, m);
		}
		static void __stdcall RefSliceS2(Reference *r, intptr_t m, intptr_t k)
		{
			r->slice<2>(k, m);
		}
		static void __stdcall RefSliceS3(Reference *r, intptr_t m, intptr_t k)
		{
			r->slice<3>(k, m);
		}
		static void __stdcall RefSliceS4(Reference *r, intptr_t m, intptr_t k)
		{
			r->slice<4>(k, m);
		}
		static void __stdcall RefSliceS5(Reference *r, intptr_t m, intptr_t k)
		{
			r->slice<5>(k, m);
		}
		static void __stdcall RefSliceS6(Reference *r, intptr_t m, intptr_t k)
		{
			r->slice<6>(k, m);
		}
		static void __stdcall RefSliceS7(Reference *r, intptr_t m, intptr_t k)
		{
			r->slice<7>(k, m);
		}
		static void __stdcall RefSliceS8(Reference *r, intptr_t m, intptr_t k)
		{
			r->slice<8>(k, m);
		}
		static void __stdcall RefSliceS9(Reference *r, intptr_t m, intptr_t k)
		{
			r->slice<9>(k, m);
		}
		static void __stdcall RefSliceS10(Reference *r, intptr_t m, intptr_t k)
		{
			r->slice<10>(k, m);
		}
		static void __stdcall RefSliceS11(Reference *r, intptr_t m, intptr_t k)
		{
			r->slice<11>(k, m);
		}
		static void __stdcall RefSliceS12(Reference *r, intptr_t m, intptr_t k)
		{
			r->slice<12>(k, m);
		}
		static void __stdcall RefSliceS13(Reference *r, intptr_t m, intptr_t k)
		{
			r->slice<13>(k, m);
		}
		static void __stdcall RefSliceS14(Reference *r, intptr_t m, intptr_t k)
		{
			r->slice<14>(k, m);
		}
		static void __stdcall RefSliceS15(Reference *r, intptr_t m, intptr_t k)
		{
			r->slice<15>(k, m);
		}
		static void __stdcall RefSliceS16(Reference *r, intptr_t m, intptr_t k)
		{
			r->slice<16>(k, m);
		}
		static void __stdcall RefLock(Reference *r)
		{
			r->lock();
		}
		static void __stdcall RefUnlock(Reference *r)
		{
			r->unlock();
		}
		static void __stdcall ThreadWait(Thread *t)
		{
			t->wait();
		}
		static void __stdcall RefClassDel(void* (__stdcall *deler)(), intptr_t csize, Reference *r)
		{
			int8_t *p, *endp;
			for(p = r->pointer->head.data, endp = p + r->pointer->head.datasize; p < endp; p += csize){
				__asm{
					push edi
					push esi
					push ebx
					mov edi,p
					call deler
					pop ebx
					pop esi
					pop edi
				}
			}
		}
		static void __stdcall RefClassNew(void* (__stdcall *newer)(), intptr_t csize, Reference *r)
		{
			int8_t *p, *endp;
			if(r->len() <= 0) return;
			for(p = r->pointer->head.data, endp = p + r->pointer->head.datasize; p < endp; p += csize){
				__asm{
					push edi
					push esi
					push ebx
					mov edi,p
					call newer
					pop ebx
					pop esi
					pop edi
				}
			}
		}
		static void __stdcall RefThreadWait(Reference *r)
		{
			int8_t *p = r->pointer->head.data;
			intptr_t i, l = r->pointer->head.datasize;
			for(i = 0; i < l; i += sizeof(Thread)) ((Thread*)(p+i))->wait();
		}
		static void __stdcall RefZeroClear(Reference *r)
		{
			if(r->len() <= 0) return;
			int8_t *p = r->pointer->head.data;
			intptr_t l = r->pointer->head.datasize;
			ZeroMemory(p, l);
		}
		static void __stdcall RefDynRefInit(Reference *r)
		{
			if(r->len() <= 0) return;
			int8_t *p = r->pointer->head.data;
			intptr_t i, l = r->pointer->head.datasize;
			for(i = 0; i < l; i += sizeof(DynamicRef)) ((DynamicRef*)(p+i))->init();
		}
		static void __stdcall RefRefDel(intptr_t nest, Reference *r)
		{
			int8_t *p = r->pointer->head.data;
			intptr_t i, l = r->pointer->head.datasize;
			if(nest > 0){
				for(i = 0; i < l; i += sizeof(Reference)){
					if(RefCntDwn((Reference*)(p+i))){
						RefRefDel(nest-1, (Reference*)(p+i));
						((Reference*)(p+i))->pointer->delet();
					}
				}
			}else{
				for(i = 0; i < l; i += sizeof(Reference)){
					if(RefCntDwn((Reference*)(p+i))) ((Reference*)(p+i))->pointer->delet();
				}
			}
		}
		static void __stdcall RefDynRefDel(SrcTree *pst, MAIN_FUNC pm, intptr_t nest, Reference *r)
		{
			int8_t *p = r->pointer->head.data;
			intptr_t i, l = r->pointer->head.datasize;
			if(nest > 0){
				for(i = 0; i < l; i += sizeof(Reference)){
					if(RefCntDwn((Reference*)(p+i))){
						RefDynRefDel(pst, pm, nest-1, (Reference*)(p+i));
						((Reference*)(p+i))->pointer->delet();
					}
				}
			}else{
				for(i = 0; i < l; i += sizeof(DynamicRef)) DynRefDelete(pst, (DynamicRef*)(p+i), pm);
			}
		}
		static void __stdcall RefRefThreadWait(intptr_t nest, Reference *r)
		{
			int8_t *p = r->pointer->head.data;
			intptr_t i, l = r->pointer->head.datasize;
			if(nest > 0){
				for(i = 0; i < l; i += sizeof(Reference)){
					if(RefCntDwn((Reference*)(p+i))){
						RefRefThreadWait(nest-1, (Reference*)(p+i));
						((Reference*)(p+i))->pointer->delet();
					}
				}
			}else{
				for(i = 0; i < l; i += sizeof(Reference)){
					if(RefCntDwn((Reference*)(p+i))){
						RefThreadWait((Reference*)(p+i));
						((Reference*)(p+i))->pointer->delet();
					}
				}
			}
		}
		static void __stdcall RefRefClassDel(void* (__stdcall *deler)(), intptr_t csize, intptr_t nest, Reference *r)
		{
			int8_t *p = r->pointer->head.data;
			intptr_t i, l = r->pointer->head.datasize;
			if(nest > 0){
				for(i = 0; i < l; i += sizeof(Reference)){
					if(RefCntDwn((Reference*)(p+i))){
						RefRefClassDel(deler, csize, nest-1, (Reference*)(p+i));
						((Reference*)(p+i))->pointer->delet();
					}
				}
			}else{
				for(i = 0; i < l; i += sizeof(Reference)){
					if(RefCntDwn((Reference*)(p+i))){
						RefClassDel(deler, csize, (Reference*)(p+i));
						((Reference*)(p+i))->pointer->delet();
					}
				}
			}
		}
		static void __stdcall RefCircRefClassDel(SSZStatic<JunkanGoroshi> *ss, void* (__stdcall *deler)(), intptr_t csize, intptr_t nest, Reference *r)
		{
			int8_t *p = r->pointer->head.data;
			intptr_t i, l = r->pointer->head.datasize;
			if(nest > 0){
				for(i = 0; i < l; i += sizeof(Reference)){
					if(RefCntDwn((Reference*)(p+i))){
						RefCircRefClassDel(ss, deler, csize, nest-1, (Reference*)(p+i));
						((Reference*)(p+i))->pointer->delet();
					}
				}
			}else{
				for(i = 0; i < l; i += sizeof(Reference)){
					if(RefCntDwn((Reference*)(p+i))){
						RefClassDel(deler, csize, (Reference*)(p+i));
						CircRefDel(ss, (Reference*)(p+i));
					}
				}
			}
		}
		static void __stdcall IdName(SrcTree *pst, Reference *r, int32_t id)
		{
			pst->TypeIdtoName(*r, id);
		}
		static int64_t __stdcall Wari64(int64_t i64_2, int64_t i64_1)
		{
			return i64_1 / i64_2;
		}
		static int64_t __stdcall Amari64(int64_t i64_2, int64_t i64_1)
		{
			return i64_1 % i64_2;
		}
		static uint64_t __stdcall Warui64(uint64_t ui64_2, uint64_t ui64_1)
		{
			return ui64_1 / ui64_2;
		}
		static uint64_t __stdcall Amarui64(uint64_t ui64_2, uint64_t ui64_1)
		{
			return ui64_1 % ui64_2;
		}
		void PBackpatch(PWCArray<intptr_t> &plist, const intptr_t adr)
		{
			intptr_t i;
			for(i = 0; i < plist.GetLength(); i++){
				*(int32_t*)(pjtr->ntvcode.GetConst()+plist.GetConst()[i]) += adr;
			}
			plist.Clear();
		}
		void MBackpatch(PWCArray<intptr_t> &plist, const intptr_t adr)
		{
			intptr_t i;
			for(i = 0; i < plist.GetLength(); i++){
				*(int32_t*)(pjtr->ntvcode.GetConst()+plist.GetConst()[i]) -= adr;
			}
			plist.Clear();
		}
		template<typename T> void AtaiCode(const T x)
		{
			pjtr->ntvcode.SetLength(pjtr->ntvcode.GetLength()+sizeof(T));
			*(T*)(pjtr->ntvcode.GetConst()+pjtr->ntvcode.GetLength()-sizeof(T)) = x;
		}
		////////////////////////////////////////////////////////////////////////////
		void LocalAddress(const uint8_t ro, const int32_t adr)
		{
			if(INT8_MIN <= adr+8 && adr+8 <= INT8_MAX){
				AtaiCode(ModRM(1, ro, 5));
				AtaiCode((int8_t)(adr+8));
			}else{
				AtaiCode(ModRM(2, ro, 5));
				AtaiCode((int32_t)(adr+8));
			}
		}
		void MemberAddress(const uint8_t ro, const int32_t adr)
		{
			if(adr == 0){
				AtaiCode(ModRM(0, ro, EDI));
			}else if(INT8_MIN <= adr && adr <= INT8_MAX){
				AtaiCode(ModRM(1, ro, 4));
				AtaiCode(SIB(0, ESP, EDI));
				AtaiCode((int8_t)adr);
			}else{
				AtaiCode(ModRM(2, ro, 4));
				AtaiCode(SIB(0, ESP, EDI));
				AtaiCode((int32_t)adr);
			}
		}
		void GlobalAddress(const uint8_t ro, const int32_t adr)
		{
			AtaiCode(ModRM(0, ro, 5));
			pjtr->gbladrbp += pjtr->ntvcode.GetLength();
			AtaiCode(adr);
		}
		void SanshouAddress(const uint8_t ro, const int32_t adr)
		{
			if(adr == 0){
				AtaiCode(ModRM(0, ro, ESI));
			}else if(INT8_MIN <= adr && adr <= INT8_MAX){
				AtaiCode(ModRM(1, ro, 4));
				AtaiCode(SIB(0, ESP, ESI));
				AtaiCode((int8_t)adr);
			}else{
				AtaiCode(ModRM(2, ro, 4));
				AtaiCode(SIB(0, ESP, ESI));
				AtaiCode((int32_t)adr);
			}
		}
		bool ModAddress(const uint8_t ro, const AddressType at, const int32_t adr)
		{
			switch(at){
			case AT_LOCAL:
				LocalAddress(ro, adr);
				break;
			case AT_MEMBER:
				MemberAddress(ro, adr);
				break;
			case AT_GLOBAL:
				GlobalAddress(ro, adr);
				break;
			case AT_SANSHOU:
				SanshouAddress(ro, adr);
				break;
			default:
				return false;
			}
			return true;
		}
		void StktopAddress(const uint8_t ro)
		{
			AtaiCode(ModRM(0, ro, 4));
			AtaiCode(SIB(0, ESP, ESP));
		}
		void MovRegImm(const REGISTER r, const int32_t i32)
		{
			pjtr->ntvcode += 0xB8 | r;
			AtaiCode(i32);
		}
		void MovRegReg(const REGISTER r1, const REGISTER r2)
		{
			if(r1 == r2) return;
			pjtr->ntvcode += 0x8B;
			AtaiCode(ModRM(3, r1, r2));
		}
		void MovRegFun(const REGISTER r, SrcTree &fun)
		{
			pjtr->ntvcode += 0xB8 | r;
			if(fun.byteadress == 0){
				fun.backpatch += pjtr->ntvcode.GetLength();
			}
			pjtr->cadrpbp += pjtr->ntvcode.GetLength();
			AtaiCode(fun.byteadress);
		}
		void MovRegSIB(const REGISTER r, const uint8_t sib, const int32_t disp)
		{
			pjtr->ntvcode += 0x8B;
			if(disp == 0){
				AtaiCode(ModRM(0, r, 4));
				AtaiCode(sib);
			}else if(INT8_MIN <= disp && disp <= INT8_MAX){
				AtaiCode(ModRM(1, r, 4));
				AtaiCode(sib);
				AtaiCode((int8_t)disp);
			}else{
				AtaiCode(ModRM(2, r, 4));
				AtaiCode(sib);
				AtaiCode(disp);
			}
		}
		bool MovRegAdr(const REGISTER r, const AddressType at, const int32_t adr)
		{
			if(at == AT_SANSHOU && adr == 0){
				MovRegReg(r, ESI);
				return true;
			}
			pjtr->ntvcode += 0x8D;
			return ModAddress(r, at, adr);
		}
		bool MovRegHns(const REGISTER r, const AddressType at, const int32_t adr, const bool oso)
		{
			if(oso) pjtr->ntvcode += 0x66;
			pjtr->ntvcode += 0x8B;
			return ModAddress(r, at, adr);
		}
		bool MovHnsImm(const AddressType at, const int32_t adr, const int32_t i32, const bool oso)
		{
			if(oso) pjtr->ntvcode += 0x66;
			pjtr->ntvcode += 0xC7;
			if(!ModAddress(0, at, adr)) return false;
			if(oso){
				AtaiCode((int16_t)i32);
			}else{
				AtaiCode(i32);
			}
			return true;
		}
		bool MovHnsReg(const AddressType at, const int32_t adr, const REGISTER r, const bool oso)
		{
			if(oso) pjtr->ntvcode += 0x66;
			pjtr->ntvcode += 0x89;
			return ModAddress(r, at, adr);
		}
		bool MemCopy(const AddressType at, const int32_t adr, int32_t size)
		{
			if(size <= 0) return true;
			MovRegReg(EDX, EDI);
			if((at != AT_MEMBER || adr != 0) && !MovRegAdr(EDI, at, adr)) return false;
			if(at == AT_SANSHOU) MovRegReg(EBX, ESI);
			MovRegReg(ESI, EAX);
			if(size/4 > 0){
				if(size/4 > 1){
					MovRegImm(ECX, size/4);
					pjtr->ntvcode += 0xF3;
				}
				pjtr->ntvcode += 0xA5;
			}
			if((size%4)/2 > 0){
				pjtr->ntvcode += 0x66;
				pjtr->ntvcode += 0xA5;
			}
			if((size%4)%2 > 0){
				pjtr->ntvcode += 0xA4;
			}
			if(at == AT_SANSHOU) MovRegReg(ESI, EBX);
			MovRegReg(EDI, EDX);
			return true;
		}
		void XchgRegReg(const REGISTER r1, const REGISTER r2)
		{
			if(r1 == EAX){
				pjtr->ntvcode += 0x90 | r2;
			}else if(r2 == EAX){
				pjtr->ntvcode += 0x90 | r1;
			}else{
				if(r1 == r2) return;
				pjtr->ntvcode += 0x87;
				AtaiCode(ModRM(3, r1, r2));
			}
		}
		void LeaSIB(const REGISTER r, const uint8_t sib, const int32_t disp)
		{
			pjtr->ntvcode += 0x8D;
			if(disp == 0){
				AtaiCode(ModRM(0, r, 4));
				AtaiCode(sib);
			}else if(INT8_MIN <= disp && disp <= INT8_MAX){
				AtaiCode(ModRM(1, r, 4));
				AtaiCode(sib);
				AtaiCode((int8_t)disp);
			}else{
				AtaiCode(ModRM(2, r, 4));
				AtaiCode(sib);
				AtaiCode(disp);
			}
		}
		void Cdq()
		{
			pjtr->ntvcode += 0x99;
		}
		void Cwde(const bool oso)
		{
			if(oso) pjtr->ntvcode += 0x66;
			pjtr->ntvcode += 0x98;
		}
		void PushImm(const int32_t i32)
		{
			pjtr->ntvcode += 0x68;
			AtaiCode(i32);
		}
		intptr_t PushCadr(const int32_t adr)
		{
			pjtr->ntvcode += 0x68;
			pjtr->cadrpbp += pjtr->ntvcode.GetLength();
			AtaiCode(adr);
			return pjtr->ntvcode.GetLength() - 4;
		}
		void PushFadr(SrcTree &st)
		{
			pjtr->ntvcode += 0x68;
			pjtr->cadrpbp += pjtr->ntvcode.GetLength();
			if(st.byteadress == 0){
				st.backpatch += pjtr->ntvcode.GetLength();
			}
			AtaiCode((int32_t)st.byteadress);
		}
		void PushSIB(const uint8_t sib, const int32_t disp)
		{
			pjtr->ntvcode += 0xFF;
			if(disp == 0){
				AtaiCode(ModRM(0, 6, 4));
				AtaiCode(sib);
			}else if(INT8_MIN <= disp && disp <= INT8_MAX){
				AtaiCode(ModRM(1, 6, 4));
				AtaiCode(sib);
				AtaiCode((int8_t)disp);
			}else{
				AtaiCode(ModRM(2, 6, 4));
				AtaiCode(sib);
				AtaiCode(disp);
			}
		}
		bool PushHns(const AddressType at, const int32_t adr)
		{
			pjtr->ntvcode += 0xFF;
			return ModAddress(6, at, adr);
		}
		bool PushHnsRef(const AddressType at, const int32_t adr, const bool dyn)
		{
			if(dyn && !PushHns(at, adr+12)) return false;
			return PushHns(at, adr+8) && PushHns(at, adr+4) && PushHns(at, adr);
		}
		void PushReg(const REGISTER r)
		{
			pjtr->ntvcode += 0x50 | r;
		}
		void PushFlt(bool dbl)
		{
			if(dbl){
				SubRegImm(ESP, 8);
				pjtr->ntvcode += 0xDD;
			}else{
				SubRegImm(ESP, 4);
				pjtr->ntvcode += 0xD9;
			}
			StktopAddress(3);
		}
		void PushFcw()
		{
			SubRegImm(ESP, 4);
			pjtr->ntvcode += 0xD9;
			StktopAddress(7);
		}
		bool PopHns(const AddressType at, const int32_t adr)
		{
			pjtr->ntvcode += 0x8F;
			return ModAddress(0, at, adr);
		}
		void PopReg(const REGISTER r)
		{
			pjtr->ntvcode += 0x58 | r;
		}
		void PopRadr(const REGISTER r)
		{
			pjtr->ntvcode += 0x8F;
			AtaiCode(ModRM(0, 0, r));
		}
		void PopFlt(bool dbl)
		{
			if(dbl){
				pjtr->ntvcode += 0xDD;
				StktopAddress(0);
				AddRegImm(ESP, 8);
			}else{
				pjtr->ntvcode += 0xD9;
				StktopAddress(0);
				AddRegImm(ESP, 4);
			}
		}
		void PopFcw()
		{
			pjtr->ntvcode += 0xD9;
			StktopAddress(5);
			AddRegImm(ESP, 4);
		}
		intptr_t Call(const int32_t adr)
		{
			pjtr->ntvcode += 0xE8;
			AtaiCode((int32_t)(adr - (pjtr->ntvcode.GetLength()+4)));
			return pjtr->ntvcode.GetLength() - 4;
		}
		void CallReg(const REGISTER r)
		{
			pjtr->ntvcode += 0xFF;
			AtaiCode(ModRM(3, 2, r));
		}
		void PluginCall(const void *adr)
		{
			pjtr->ntvcode += 0xE8;
			pjtr->cadrmbp += pjtr->ntvcode.GetLength();
			AtaiCode((int32_t)((int32_t)adr - (pjtr->ntvcode.GetLength()+4)));
		}
		void FuncCall(SrcTree &st)
		{
			pjtr->ntvcode += 0xE8;
			if(st.byteadress == 0){
				st.backpatch += pjtr->ntvcode.GetLength();
			}
			AtaiCode((int32_t)(st.byteadress - (pjtr->ntvcode.GetLength()+4)));
		}
		void CallStk()
		{
			PopReg(EAX);
			pjtr->ntvcode += 0xFF;
			AtaiCode(ModRM(3, 2, EAX));
		}
		void KansuStackSet(const SrcTree &stree)
		{
			intptr_t i;
			intptr_t siz, fsi;
			fsi = 0;
			for(i = stree.tpcount; i < stree.tpcount+stree.hikisuucount; i++){
				fsi += stree.funchensuu.GetConst()[i].size;
			}
			siz = 0;
			for(; i < stree.funchensuu.GetLength(); i++){
				siz += stree.funchensuu.GetConst()[i].size;
			}
			if(siz > 0){
				PopReg(EAX);
				SubRegImm(ESP, Aligner(siz));
				PushReg(EAX);
				PushReg(EBP);
				MovRegReg(EBP, ESP);
			}else if(fsi > 0){
				PushReg(EBP);
				MovRegReg(EBP, ESP);
			}
		}
		void KansuStackClear(SrcTree &stree)
		{
			intptr_t siz;
			siz = stree.GetMemberSize();
			if(pjtr->yobunipop > 0){
				AddRegImm(ESP, pjtr->yobunipop);
				pjtr->yobunipop = 0;
			}
			if(siz > 0){
				PopReg(EBP);
				PopReg(EAX);
				AddRegImm(ESP, Aligner(siz));
				PushReg(EAX);
			}
		}
		void Return(const int32_t i32, const bool bp)
		{
			if(pjtr->yobunipop > 0){
				AddRegImm(ESP, pjtr->yobunipop);
				pjtr->yobunipop = 0;
			}
			if(i32 == 0){
				pjtr->ntvcode += 0xC3;
			}else if(1 <= i32 && i32 <= INT16_MAX){
				if(bp) PopReg(EBP);
				pjtr->ntvcode += 0xC2;
				AtaiCode((int16_t)i32);
			}else{
				if(bp) PopReg(EBP);
				PopReg(EAX);
				AddRegImm(ESP, i32);
				PushReg(EAX);
				pjtr->ntvcode += 0xC3;
			}
		}
		intptr_t Jump(const int32_t i32)
		{
			pjtr->ntvcode += 0xE9;
			AtaiCode((int32_t)(i32 - (pjtr->ntvcode.GetLength()+4)));
			return pjtr->ntvcode.GetLength() - 4;
		}
		void JumpReg(const REGISTER r)
		{
			pjtr->ntvcode += 0xFF;
			AtaiCode(ModRM(3, 4, r));
		}
		intptr_t JumpIdxCadr(const uint8_t scale, const REGISTER index, const int32_t adr)
		{
			pjtr->ntvcode += 0xFF;
			AtaiCode(ModRM(0, 4, 4));
			AtaiCode(SIB(scale, index, EBP));
			pjtr->cadrpbp += pjtr->ntvcode.GetLength();
			AtaiCode(adr);
			return pjtr->ntvcode.GetLength() - 4;
		}
		intptr_t TrueJump(const int32_t i32)
		{
			pjtr->ntvcode += 0x84;
			AtaiCode(ModRM(3, AL, AL));
			pjtr->ntvcode += 0x0F; pjtr->ntvcode += 0x85;
			AtaiCode((int32_t)(i32 - (pjtr->ntvcode.GetLength()+4)));
			return pjtr->ntvcode.GetLength() - 4;
		}
		intptr_t FalseJump(const int32_t i32)
		{
			pjtr->ntvcode += 0x84;
			AtaiCode(ModRM(3, AL, AL));
			pjtr->ntvcode += 0x0F; pjtr->ntvcode += 0x84;
			AtaiCode((int32_t)(i32 - (pjtr->ntvcode.GetLength()+4)));
			return pjtr->ntvcode.GetLength() - 4;
		}
		void CmpImm(const int32_t i32, const bool oso)
		{
			if(oso) pjtr->ntvcode += 0x66;
			pjtr->ntvcode += 0x3D;
			if(oso){
				AtaiCode((int16_t)i32);
			}else{
				AtaiCode(i32);
			}
			pjtr->ntvcode += 0x9F;
		}
		void CmpRegReg(const REGISTER r1, const REGISTER r2, const bool oso)
		{
			if(oso) pjtr->ntvcode += 0x66;
			pjtr->ntvcode += 0x3B;
			AtaiCode(ModRM(3, r1, r2));
			pjtr->ntvcode += 0x9F;
		}
		void CmpStk(const bool oso)
		{
			PopReg(ECX);
			CmpRegReg(ECX, EAX, oso);
		}
		void Less()
		{
			ShrRegImm(EAX, 8, false);
			AndRegImm(EAX, 1);
		}
		void ILess()
		{
			ShrRegImm(EAX, 15, false);
			AndRegImm(EAX, 1);
		}
		void Ika()
		{
			ShrRegImm(EAX, 8, false);
			MovRegReg(ECX, EAX);
			ShrRegImm(EAX, 6, false);
			OrRegReg(EAX, ECX);
			AndRegImm(EAX, 1);
		}
		void IIka()
		{
			ShrRegImm(EAX, 14, false);
			MovRegReg(ECX, EAX);
			ShrRegImm(EAX, 1, false);
			OrRegReg(EAX, ECX);
			AndRegImm(EAX, 1);
		}
		void Over()
		{
			ShrRegImm(EAX, 8, false);
			MovRegReg(ECX, EAX);
			ShrRegImm(EAX, 6, false);
			OrRegReg(EAX, ECX);
			NotReg(EAX);
			AndRegImm(EAX, 1);
		}
		void IOver()
		{
			ShrRegImm(EAX, 14, false);
			MovRegReg(ECX, EAX);
			ShrRegImm(EAX, 1, false);
			OrRegReg(EAX, ECX);
			NotReg(EAX);
			AndRegImm(EAX, 1);
		}
		void Ijou()
		{
			ShrRegImm(EAX, 8, false);
			NotReg(EAX);
			AndRegImm(EAX, 1);
		}
		void IIjou()
		{
			ShrRegImm(EAX, 15, false);
			NotReg(EAX);
			AndRegImm(EAX, 1);
		}
		void Equal()
		{
			ShrRegImm(EAX, 14, false);
			AndRegImm(EAX, 1);
		}
		void NEqual()
		{
			ShrRegImm(EAX, 14, false);
			NotReg(EAX);
			AndRegImm(EAX, 1);
		}
		void NotReg(const REGISTER r)
		{
			pjtr->ntvcode += 0xF7;
			AtaiCode(ModRM(3, 2, r));
		}
		void NegReg(const REGISTER r)
		{
			pjtr->ntvcode += 0xF7;
			AtaiCode(ModRM(3, 3, r));
		}
		void OrRegImm(const REGISTER r, const int32_t i32)
		{
			if(i32 == 0) return;
			if(r == EAX){
				pjtr->ntvcode += 0x0D;
			}else{
				pjtr->ntvcode += 0x81;
				AtaiCode(ModRM(3, 1, r));
			}
			AtaiCode(i32);
		}
		void OrRegReg(const REGISTER r1, const REGISTER r2)
		{
			pjtr->ntvcode += 0x0B;
			AtaiCode(ModRM(3, r1, r2));
		}
		void OrStk()
		{
			PopReg(ECX);
			OrRegReg(EAX, ECX);
		}
		void XorRegImm(const REGISTER r, const int32_t i32)
		{
			if(i32 == 0) return;
			if(r == EAX){
				pjtr->ntvcode += 0x35;
			}else{
				pjtr->ntvcode += 0x81;
				AtaiCode(ModRM(3, 6, r));
			}
			AtaiCode(i32);
		}
		void XorRegReg(const REGISTER r1, const REGISTER r2)
		{
			pjtr->ntvcode += 0x33;
			AtaiCode(ModRM(3, r1, r2));
		}
		void XorStk()
		{
			PopReg(ECX);
			XorRegReg(EAX, ECX);
		}
		void AndRegImm(const REGISTER r, const int32_t i32)
		{
			if(i32 == 0){
				MovRegImm(r, 0);
				return;
			}
			if(r == EAX){
				pjtr->ntvcode += 0x25;
			}else{
				pjtr->ntvcode += 0x81;
				AtaiCode(ModRM(3, 4, r));
			}
			AtaiCode(i32);
		}
		void AndRegReg(const REGISTER r1, const REGISTER r2)
		{
			pjtr->ntvcode += 0x23;
			AtaiCode(ModRM(3, r1, r2));
		}
		void AndStk()
		{
			PopReg(ECX);
			AndRegReg(EAX, ECX);
		}
		void AddRegImm(const REGISTER r, const int32_t i32)
		{
			if(i32 == 0) return;
			if(r == EAX){
				pjtr->ntvcode += 0x05;
			}else{
				pjtr->ntvcode += 0x81;
				AtaiCode(ModRM(3, 0, r));
			}
			AtaiCode(i32);
		}
		void AddRegReg(const REGISTER r1, const REGISTER r2)
		{
			pjtr->ntvcode += 0x03;
			AtaiCode(ModRM(3, r1, r2));
		}
		void AddStk()
		{
			PopReg(ECX);
			AddRegReg(EAX, ECX);
		}
		void SubRegImm(const REGISTER r, const int32_t i32)
		{
			if(i32 == 0) return;
			if(r == EAX){
				pjtr->ntvcode += 0x2D;
			}else{
				pjtr->ntvcode += 0x81;
				AtaiCode(ModRM(3, 5, r));
			}
			AtaiCode(i32);
		}
		void SubRegReg(const REGISTER r1, const REGISTER r2)
		{
			pjtr->ntvcode += 0x2B;
			AtaiCode(ModRM(3, r1, r2));
		}
		void SubStk()
		{
			PopReg(ECX);
			XchgRegReg(EAX, ECX);
			SubRegReg(EAX, ECX);
		}
		void ShlRegImm(const REGISTER r, const int8_t i8)
		{
			if(i8 == 0) return;
			if(i8 == 1){
				pjtr->ntvcode += 0xD1;
				AtaiCode(ModRM(3, 4, r));
			}else{
				pjtr->ntvcode += 0xC1;
				AtaiCode(ModRM(3, 4, r));
				AtaiCode(i8);
			}
		}
		void ShlRegCl(const REGISTER r)
		{
			pjtr->ntvcode += 0xD3;
			AtaiCode(ModRM(3, 4, r));
		}
		void ShlStk()
		{
			PopReg(ECX);
			XchgRegReg(EAX, ECX);
			ShlRegCl(EAX);
		}
		void ShrRegImm(const REGISTER r, const uint8_t ui8, const bool oso)
		{
			if(ui8 == 0) return;
			if(oso) pjtr->ntvcode += 0x66;
			if(ui8 == 1){
				pjtr->ntvcode += 0xD1;
				AtaiCode(ModRM(3, 5, r));
			}else{
				pjtr->ntvcode += 0xC1;
				AtaiCode(ModRM(3, 5, r));
				AtaiCode(ui8);
			}
		}
		void ShrRegCl(const REGISTER r, const bool oso)
		{
			if(oso) pjtr->ntvcode += 0x66;
			pjtr->ntvcode += 0xD3;
			AtaiCode(ModRM(3, 5, r));
		}
		void ShrStk(const bool oso)
		{
			PopReg(ECX);
			XchgRegReg(EAX, ECX);
			ShrRegCl(EAX, oso);
		}
		void SarRegImm(const REGISTER r, const int8_t i8, const bool oso)
		{
			if(i8 == 0) return;
			if(oso) pjtr->ntvcode += 0x66;
			if(i8 == 1){
				pjtr->ntvcode += 0xD1;
				AtaiCode(ModRM(3, 7, r));
			}else{
				pjtr->ntvcode += 0xC1;
				AtaiCode(ModRM(3, 7, r));
				AtaiCode(i8);
			}
		}
		void SarRegCl(const REGISTER r, const bool oso)
		{
			if(oso) pjtr->ntvcode += 0x66;
			pjtr->ntvcode += 0xD3;
			AtaiCode(ModRM(3, 7, r));
		}
		void SarStk(const bool oso)
		{
			PopReg(ECX);
			XchgRegReg(EAX, ECX);
			SarRegCl(EAX, oso);
		}
		void MulReg(const REGISTER r)
		{
			pjtr->ntvcode += 0xF7;
			AtaiCode(ModRM(3, 4, r));
		}
		void MulStk()
		{
			PopReg(ECX);
			MulReg(ECX);
		}
		void DivReg(const REGISTER r, const bool oso)
		{
			MovRegImm(EDX, 0);
			if(oso) pjtr->ntvcode += 0x66;
			pjtr->ntvcode += 0xF7;
			AtaiCode(ModRM(3, 6, r));
		}
		void DivStk(const bool oso)
		{
			PopReg(ECX);
			XchgRegReg(EAX, ECX);
			DivReg(ECX, oso);
		}
		void IDivReg(const REGISTER r, const bool oso)
		{
			if(oso) pjtr->ntvcode += 0x66;
			Cdq();
			if(oso) pjtr->ntvcode += 0x66;
			pjtr->ntvcode += 0xF7;
			AtaiCode(ModRM(3, 7, r));
		}
		void IDivStk(const bool oso)
		{
			PopReg(ECX);
			XchgRegReg(EAX, ECX);
			IDivReg(ECX, oso);
		}
		void RemReg(const REGISTER r, const bool oso)
		{
			MovRegImm(EDX, 0);
			if(oso) pjtr->ntvcode += 0x66;
			pjtr->ntvcode += 0xF7;
			AtaiCode(ModRM(3, 6, r));
			MovRegReg(EAX, EDX);
		}
		void RemStk(const bool oso)
		{
			PopReg(ECX);
			XchgRegReg(EAX, ECX);
			RemReg(ECX, oso);
		}
		void IRemReg(const REGISTER r, const bool oso)
		{
			if(oso) pjtr->ntvcode += 0x66;
			Cdq();
			if(oso) pjtr->ntvcode += 0x66;
			pjtr->ntvcode += 0xF7;
			AtaiCode(ModRM(3, 7, r));
			MovRegReg(EAX, EDX);
		}
		void IRemStk(const bool oso)
		{
			PopReg(ECX);
			XchgRegReg(EAX, ECX);
			IRemReg(ECX, oso);
		}
		bool MovRegHns8(const REGISTER8 r, const AddressType at, int32_t adr)
		{
			pjtr->ntvcode += 0x8A;
			return ModAddress(r, at, adr);
		}
		bool MovHnsImm8(const AddressType at, const int32_t adr, const int8_t i8)
		{
			pjtr->ntvcode += 0xC6;
			if(!ModAddress(0, at, adr)) return false;
			AtaiCode(i8);
			return true;
		}
		bool MovHnsReg8(const AddressType at, const int32_t adr, const REGISTER8 r)
		{
			pjtr->ntvcode += 0x88;
			return ModAddress(r, at, adr);
		}
		void MovRegReg8(const REGISTER8 r1, const REGISTER8 r2)
		{
			pjtr->ntvcode += 0x8A;
			AtaiCode(ModRM(3, r1, r2));
		}
		void CmpImm8(const int8_t i8)
		{
			pjtr->ntvcode += 0x3C;
			AtaiCode(i8);
			pjtr->ntvcode += 0x9F;
		}
		void CmpRegReg8(const REGISTER8 r1, const REGISTER8 r2)
		{
			pjtr->ntvcode += 0x3A;
			AtaiCode(ModRM(3, r1, r2));
			pjtr->ntvcode += 0x9F;
		}
		void CmpStk8()
		{
			PopReg(ECX);
			CmpRegReg8(CL, AL);
		}
		void SarRegImm8(const REGISTER8 r, const int8_t i8)
		{
			if(i8 == 0) return;
			if(i8 == 1){
				pjtr->ntvcode += 0xD0;
				AtaiCode(ModRM(3, 7, r));
			}else{
				pjtr->ntvcode += 0xC0;
				AtaiCode(ModRM(3, 7, r));
				AtaiCode(i8);
			}
		}
		void SarRegCl8(const REGISTER8 r)
		{
			pjtr->ntvcode += 0xD2;
			AtaiCode(ModRM(3, 7, r));
		}
		void SarStk8()
		{
			PopReg(ECX);
			XchgRegReg(EAX, ECX);
			SarRegCl8(AL);
		}
		void ShrRegImm8(const REGISTER8 r, const uint8_t ui8)
		{
			if(ui8 == 0) return;
			if(ui8 == 1){
				pjtr->ntvcode += 0xD0;
				AtaiCode(ModRM(3, 5, r));
			}else{
				pjtr->ntvcode += 0xC0;
				AtaiCode(ModRM(3, 5, r));
				AtaiCode(ui8);
			}
		}
		void ShrRegCl8(const REGISTER8 r)
		{
			pjtr->ntvcode += 0xD2;
			AtaiCode(ModRM(3, 5, r));
		}
		void ShrStk8()
		{
			PopReg(ECX);
			XchgRegReg(EAX, ECX);
			ShrRegCl8(AL);
		}
		void DivReg8(const REGISTER8 r)
		{
			AndRegImm(EAX, 0xff);
			pjtr->ntvcode += 0xF6;
			AtaiCode(ModRM(3, 6, r));
		}
		void DivStk8()
		{
			PopReg(ECX);
			XchgRegReg(EAX, ECX);
			DivReg8(CL);
		}
		void IDivReg8(const REGISTER8 r)
		{
			Cwde(true);
			pjtr->ntvcode += 0xF6;
			AtaiCode(ModRM(3, 7, r));
		}
		void IDivStk8()
		{
			PopReg(ECX);
			XchgRegReg(EAX, ECX);
			IDivReg8(CL);
		}
		void RemReg8(const REGISTER8 r)
		{
			AndRegImm(EAX, 0xff);
			pjtr->ntvcode += 0xF6;
			AtaiCode(ModRM(3, 6, r));
			MovRegReg8(AL, AH);
		}
		void RemStk8()
		{
			PopReg(ECX);
			XchgRegReg(EAX, ECX);
			RemReg8(CL);
		}
		void IRemReg8(const REGISTER8 r)
		{
			Cwde(true);
			pjtr->ntvcode += 0xF6;
			AtaiCode(ModRM(3, 7, r));
			MovRegReg8(AL, AH);
		}
		void IRemStk8()
		{
			PopReg(ECX);
			XchgRegReg(EAX, ECX);
			IRemReg8(CL);
		}
		bool MovRegHns64(const REGISTER r1, const REGISTER r2, const AddressType at, const int32_t adr)
		{
			return MovRegHns(r1, at, adr, false) && MovRegHns(r2, at, adr+4, false);
		}
		bool MovHnsImm64(const AddressType at, const int32_t adr, int64_t i64)
		{
			return MovHnsImm(at, adr, ((int32_t*)&i64)[0], false) && MovHnsImm(at, adr+4, ((int32_t*)&i64)[1], false);
		}
		bool MovHnsReg64(const AddressType at, const int32_t adr)
		{
			return MovHnsReg(at, adr, EAX, false) && MovHnsReg(at, adr+4, EDX, false);
		}
		void LessImm64(int64_t i64)
		{
			CmpImm(((int32_t*)&i64)[0], false);
			Less();
			XchgRegReg(EAX, EDX);
			CmpImm(((int32_t*)&i64)[1], false);
			MovRegReg(EBX, EAX);
			Less();
			OrRegReg(EAX, EDX);
			XchgRegReg(EAX, EBX);
			Ika();
			AndRegReg(EAX, EBX);
		}
		void LessStk64()
		{
			PopReg(EBX);
			CmpRegReg(EBX, EAX, false);
			Less();
			XchgRegReg(EAX, EDX);
			PopReg(EBX);
			CmpRegReg(EBX, EAX, false);
			MovRegReg(EBX, EAX);
			Less();
			OrRegReg(EAX, EDX);
			XchgRegReg(EAX, EBX);
			Ika();
			AndRegReg(EAX, EBX);
		}
		void ILessImm64(int64_t i64)
		{
			CmpImm(((int32_t*)&i64)[0], false);
			ILess();
			XchgRegReg(EAX, EDX);
			CmpImm(((int32_t*)&i64)[1], false);
			MovRegReg(EBX, EAX);
			ILess();
			OrRegReg(EAX, EDX);
			XchgRegReg(EAX, EBX);
			IIka();
			AndRegReg(EAX, EBX);
		}
		void ILessStk64()
		{
			PopReg(EBX);
			CmpRegReg(EBX, EAX, false);
			ILess();
			XchgRegReg(EAX, EDX);
			PopReg(EBX);
			CmpRegReg(EBX, EAX, false);
			MovRegReg(EBX, EAX);
			ILess();
			OrRegReg(EAX, EDX);
			XchgRegReg(EAX, EBX);
			IIka();
			AndRegReg(EAX, EBX);
		}
		void IkaImm64(int64_t i64)
		{
			CmpImm(((int32_t*)&i64)[0], false);
			Ika();
			XchgRegReg(EAX, EDX);
			CmpImm(((int32_t*)&i64)[1], false);
			MovRegReg(EBX, EAX);
			Less();
			OrRegReg(EAX, EDX);
			XchgRegReg(EAX, EBX);
			Ika();
			AndRegReg(EAX, EBX);
		}
		void IkaStk64()
		{
			PopReg(EBX);
			CmpRegReg(EBX, EAX, false);
			Ika();
			XchgRegReg(EAX, EDX);
			PopReg(EBX);
			CmpRegReg(EBX, EAX, false);
			MovRegReg(EBX, EAX);
			Less();
			OrRegReg(EAX, EDX);
			XchgRegReg(EAX, EBX);
			Ika();
			AndRegReg(EAX, EBX);
		}
		void IIkaImm64(int64_t i64)
		{
			CmpImm(((int32_t*)&i64)[0], false);
			IIka();
			XchgRegReg(EAX, EDX);
			CmpImm(((int32_t*)&i64)[1], false);
			MovRegReg(EBX, EAX);
			ILess();
			OrRegReg(EAX, EDX);
			XchgRegReg(EAX, EBX);
			IIka();
			AndRegReg(EAX, EBX);
		}
		void IIkaStk64()
		{
			PopReg(EBX);
			CmpRegReg(EBX, EAX, false);
			IIka();
			XchgRegReg(EAX, EDX);
			PopReg(EBX);
			CmpRegReg(EBX, EAX, false);
			MovRegReg(EBX, EAX);
			ILess();
			OrRegReg(EAX, EDX);
			XchgRegReg(EAX, EBX);
			IIka();
			AndRegReg(EAX, EBX);
		}
		void OverImm64(int64_t i64)
		{
			CmpImm(((int32_t*)&i64)[0], false);
			Over();
			XchgRegReg(EAX, EDX);
			CmpImm(((int32_t*)&i64)[1], false);
			MovRegReg(EBX, EAX);
			Over();
			OrRegReg(EAX, EDX);
			XchgRegReg(EAX, EBX);
			Ijou();
			AndRegReg(EAX, EBX);
		}
		void OverStk64()
		{
			PopReg(EBX);
			CmpRegReg(EBX, EAX, false);
			Over();
			XchgRegReg(EAX, EDX);
			PopReg(EBX);
			CmpRegReg(EBX, EAX, false);
			MovRegReg(EBX, EAX);
			Over();
			OrRegReg(EAX, EDX);
			XchgRegReg(EAX, EBX);
			Ijou();
			AndRegReg(EAX, EBX);
		}
		void IOverImm64(int64_t i64)
		{
			CmpImm(((int32_t*)&i64)[0], false);
			IOver();
			XchgRegReg(EAX, EDX);
			CmpImm(((int32_t*)&i64)[1], false);
			MovRegReg(EBX, EAX);
			IOver();
			OrRegReg(EAX, EDX);
			XchgRegReg(EAX, EBX);
			IIjou();
			AndRegReg(EAX, EBX);
		}
		void IOverStk64()
		{
			PopReg(EBX);
			CmpRegReg(EBX, EAX, false);
			IOver();
			XchgRegReg(EAX, EDX);
			PopReg(EBX);
			CmpRegReg(EBX, EAX, false);
			MovRegReg(EBX, EAX);
			IOver();
			OrRegReg(EAX, EDX);
			XchgRegReg(EAX, EBX);
			IIjou();
			AndRegReg(EAX, EBX);
		}
		void IjouImm64(int64_t i64)
		{
			CmpImm(((int32_t*)&i64)[0], false);
			Ijou();
			XchgRegReg(EAX, EDX);
			CmpImm(((int32_t*)&i64)[1], false);
			MovRegReg(EBX, EAX);
			Over();
			OrRegReg(EAX, EDX);
			XchgRegReg(EAX, EBX);
			Ijou();
			AndRegReg(EAX, EBX);
		}
		void IjouStk64()
		{
			PopReg(EBX);
			CmpRegReg(EBX, EAX, false);
			Ijou();
			XchgRegReg(EAX, EDX);
			PopReg(EBX);
			CmpRegReg(EBX, EAX, false);
			MovRegReg(EBX, EAX);
			Over();
			OrRegReg(EAX, EDX);
			XchgRegReg(EAX, EBX);
			Ijou();
			AndRegReg(EAX, EBX);
		}
		void IIjouImm64(int64_t i64)
		{
			CmpImm(((int32_t*)&i64)[0], false);
			IIjou();
			XchgRegReg(EAX, EDX);
			CmpImm(((int32_t*)&i64)[1], false);
			MovRegReg(EBX, EAX);
			IOver();
			OrRegReg(EAX, EDX);
			XchgRegReg(EAX, EBX);
			IIjou();
			AndRegReg(EAX, EBX);
		}
		void IIjouStk64()
		{
			PopReg(EBX);
			CmpRegReg(EBX, EAX, false);
			IIjou();
			XchgRegReg(EAX, EDX);
			PopReg(EBX);
			CmpRegReg(EBX, EAX, false);
			MovRegReg(EBX, EAX);
			IOver();
			OrRegReg(EAX, EDX);
			XchgRegReg(EAX, EBX);
			IIjou();
			AndRegReg(EAX, EBX);
		}
		void EqualImm64(int64_t i64)
		{
			CmpImm(((int32_t*)&i64)[0], false);
			Equal();
			XchgRegReg(EAX, EDX);
			CmpImm(((int32_t*)&i64)[1], false);
			Equal();
			AndRegReg(EAX, EDX);
		}
		void EqualStk64()
		{
			PopReg(EBX);
			CmpRegReg(EBX, EAX, false);
			Equal();
			XchgRegReg(EAX, EDX);
			PopReg(EBX);
			CmpRegReg(EBX, EAX, false);
			Equal();
			AndRegReg(EAX, EDX);
		}
		void NEqualImm64(int64_t i64)
		{
			CmpImm(((int32_t*)&i64)[0], false);
			NEqual();
			XchgRegReg(EAX, EDX);
			CmpImm(((int32_t*)&i64)[1], false);
			NEqual();
			OrRegReg(EAX, EDX);
		}
		void NEqualStk64()
		{
			PopReg(EBX);
			CmpRegReg(EBX, EAX, false);
			NEqual();
			XchgRegReg(EAX, EDX);
			PopReg(EBX);
			CmpRegReg(EBX, EAX, false);
			NEqual();
			OrRegReg(EAX, EDX);
		}
		void OrImm64(int64_t i64)
		{
			OrRegImm(EAX, ((int32_t*)&i64)[0]);
			OrRegImm(EDX, ((int32_t*)&i64)[1]);
		}
		void Or64()
		{
			OrRegReg(EAX, ECX);
			pjtr->ntvcode += 0x0B;
			AtaiCode(ModRM(3, EDX, EBX));
		}
		void OrStk64()
		{
			PopReg(ECX);
			OrRegReg(EAX, ECX);
			PopReg(ECX);
			OrRegReg(EDX, ECX);
		}
		void XorImm64(int64_t i64)
		{
			XorRegImm(EAX, ((int32_t*)&i64)[0]);
			XorRegImm(EDX, ((int32_t*)&i64)[1]);
		}
		void Xor64()
		{
			XorRegReg(EAX, ECX);
			pjtr->ntvcode += 0x33;
			AtaiCode(ModRM(3, EDX, EBX));
		}
		void XorStk64()
		{
			PopReg(ECX);
			XorRegReg(EAX, ECX);
			PopReg(ECX);
			XorRegReg(EDX, ECX);
		}
		void AndImm64(int64_t i64)
		{
			AndRegImm(EAX, ((int32_t*)&i64)[0]);
			AndRegImm(EDX, ((int32_t*)&i64)[1]);
		}
		void And64()
		{
			AndRegReg(EAX, ECX);
			pjtr->ntvcode += 0x23;
			AtaiCode(ModRM(3, EDX, EBX));
		}
		void AndStk64()
		{
			PopReg(ECX);
			AndRegReg(EAX, ECX);
			PopReg(ECX);
			AndRegReg(EDX, ECX);
		}
		void AddImm64(int64_t i64)
		{
			if(i64 == 0) return;
			AddRegImm(EAX, ((int32_t*)&i64)[0]);
			pjtr->ntvcode += 0x81;
			AtaiCode(ModRM(3, 2, EDX));
			AtaiCode(((int32_t*)&i64)[1]);
		}
		void Add64()
		{
			AddRegReg(EAX, ECX);
			pjtr->ntvcode += 0x13;
			AtaiCode(ModRM(3, EDX, EBX));
		}
		void AddStk64()
		{
			PopReg(ECX);
			AddRegReg(EAX, ECX);
			PopReg(ECX);
			pjtr->ntvcode += 0x13;
			AtaiCode(ModRM(3, EDX, ECX));
		}
		void SubImm64(int64_t i64)
		{
			if(i64 == 0) return;
			SubRegImm(EAX, ((int32_t*)&i64)[0]);
			pjtr->ntvcode += 0x81;
			AtaiCode(ModRM(3, 3, EDX));
			AtaiCode(((int32_t*)&i64)[1]);
		}
		void Sub64()
		{
			SubRegReg(EAX, ECX);
			pjtr->ntvcode += 0x1B;
			AtaiCode(ModRM(3, EDX, EBX));
		}
		void SubStk64()
		{
			PopReg(ECX);
			XchgRegReg(EAX, ECX);
			SubRegReg(EAX, ECX);
			PopReg(ECX);
			XchgRegReg(EDX, ECX);
			pjtr->ntvcode += 0x1B;
			AtaiCode(ModRM(3, EDX, ECX));
		}
		void ShlImm64(const int8_t i8)
		{
			if(i8 == 0) return;
			if(i8 == 1){
				ShlRegImm(EAX, 1);
				pjtr->ntvcode += 0xD1;
				AtaiCode(ModRM(3, 2, EDX));
			}else if(1 <= i8 && i8 <= 31){
				ShlRegImm(EDX, i8);
				MovRegReg(ECX, EAX);
				ShrRegImm(ECX, 32-i8, false);
				OrRegReg(EDX, ECX);
				ShlRegImm(EAX, i8);
			}else{
				MovRegReg(EDX, EAX);
				ShlRegImm(EDX, i8-32);
				MovRegImm(EAX, 0);
			}
		}
		void ShlCl64()
		{
			pjtr->ntvcode += 0xD3;
			AtaiCode(ModRM(3, 0, EAX));
			ShlRegCl(EDX);
			MovRegImm(EBX, 1);
			ShlRegCl(EBX);
			SubRegImm(EBX, 1);
			MovRegReg(ESI, EBX);
			AndRegReg(EBX, EAX);
			OrRegReg(EDX, EBX);
			NotReg(ESI);
			AndRegReg(EAX, ESI);
			//
			ShrRegImm(ECX, 1, false);
			AndRegImm(ECX, 16);
			//
			for(int i = 0; i < 2; i++){
				pjtr->ntvcode += 0xD3;
				AtaiCode(ModRM(3, 0, EAX));
				ShlRegCl(EDX);
				MovRegImm(EBX, 1);
				ShlRegCl(EBX);
				SubRegImm(EBX, 1);
				MovRegReg(ESI, EBX);
				AndRegReg(EBX, EAX);
				OrRegReg(EDX, EBX);
				NotReg(ESI);
				AndRegReg(EAX, ESI);
			}
		}
		void ShlStk64()
		{
			PopReg(ECX);
			XchgRegReg(EAX, ECX);
			PopReg(EDX);
			ShlCl64();
		}
		void ShrImm64(const uint8_t ui8)
		{
			if(ui8 == 0) return;
			if(ui8 == 1){
				ShrRegImm(EDX, 1, false);
				pjtr->ntvcode += 0xD1;
				AtaiCode(ModRM(3, 3, EAX));
			}else if(1 <= ui8 && ui8 <= 31){
				ShrRegImm(EAX, ui8, false);
				MovRegReg(ECX, EDX);
				ShlRegImm(ECX, 32-ui8);
				OrRegReg(EAX, ECX);
				ShrRegImm(EDX, ui8, false);
			}else{
				MovRegReg(EAX, EDX);
				ShrRegImm(EAX, ui8-32, false);
				MovRegImm(EDX, 0);
			}
		}
		void ShrCl64()
		{
			pjtr->ntvcode += 0xD3;
			AtaiCode(ModRM(3, 1, EDX));
			ShlRegCl(EAX);
			MovRegImm(EBX, -1);
			ShrRegCl(EBX, false);
			MovRegReg(ESI, EBX);
			NotReg(EBX);
			AndRegReg(EBX, EDX);
			OrRegReg(EAX, EBX);
			AndRegReg(EDX, ESI);
			//
			ShrRegImm(ECX, 1, false);
			AndRegImm(ECX, 16);
			//
			for(int i = 0; i < 2; i++){
				pjtr->ntvcode += 0xD3;
				AtaiCode(ModRM(3, 1, EDX));
				ShlRegCl(EAX);
				MovRegImm(EBX, -1);
				ShrRegCl(EBX, false);
				MovRegReg(ESI, EBX);
				NotReg(EBX);
				AndRegReg(EBX, EDX);
				OrRegReg(EAX, EBX);
				AndRegReg(EDX, ESI);
			}
		}
		void ShrStk64()
		{
			PopReg(ECX);
			XchgRegReg(EAX, ECX);
			PopReg(EDX);
			ShrCl64();
		}
		void SarImm64(const int8_t i8)
		{
			if(i8 == 0) return;
			if(i8 == 1){
				SarRegImm(EDX, 1, false);
				pjtr->ntvcode += 0xD1;
				AtaiCode(ModRM(3, 3, EAX));
			}else if(1 <= i8 && i8 <= 31){
				ShrRegImm(EAX, i8, false);
				MovRegReg(ECX, EDX);
				ShlRegImm(ECX, 32-i8);
				OrRegReg(EAX, ECX);
				SarRegImm(EDX, i8, false);
			}else{
				MovRegReg(EAX, EDX);
				SarRegImm(EAX, i8-32, false);
				SarRegImm(EDX, 31, false);
			}
		}
		void SarCl64()
		{
			pjtr->ntvcode += 0xD3;
			AtaiCode(ModRM(3, 1, EDX));
			ShlRegCl(EAX);
			MovRegImm(EBX, -1);
			ShrRegCl(EBX, false);
			NotReg(EBX);
			AndRegReg(EBX, EDX);
			OrRegReg(EAX, EBX);
			ShlRegCl(EDX);
			SarRegCl(EDX, false);
			//
			ShrRegImm(ECX, 1, false);
			AndRegImm(ECX, 16);
			//
			for(int i = 0; i < 2; i++){
				pjtr->ntvcode += 0xD3;
				AtaiCode(ModRM(3, 1, EDX));
				ShlRegCl(EAX);
				MovRegImm(EBX, -1);
				ShrRegCl(EBX, false);
				NotReg(EBX);
				AndRegReg(EBX, EDX);
				OrRegReg(EAX, EBX);
				ShlRegCl(EDX);
				SarRegCl(EDX, false);
			}
		}
		void SarStk64()
		{
			PopReg(ECX);
			XchgRegReg(EAX, ECX);
			PopReg(EDX);
			SarCl64();
		}
		void MulStk64()
		{
			PopReg(ECX);
			XchgRegReg(EAX, ECX);
			MovRegReg(EBX, EAX);
			MulReg(EDX);
			PopReg(ESI);
			XchgRegReg(EAX, ESI);
			MulReg(ECX);
			AddRegReg(ESI, EAX);
			MovRegReg(EAX, EBX);
			MulReg(ECX);
			AddRegReg(EDX, ESI);
		}
		void DivStk64()
		{
			PushReg(EDX);
			PushReg(EAX);
			PluginCall(Warui64);
		}
		void IDivStk64()
		{
			PushReg(EDX);
			PushReg(EAX);
			PluginCall(Wari64);
		}
		void RemStk64()
		{
			PushReg(EDX);
			PushReg(EAX);
			PluginCall(Amarui64);
		}
		void IRemStk64()
		{
			PushReg(EDX);
			PushReg(EAX);
			PluginCall(Amari64);
		}
		void FtoI(const bool unsig, const bool b64)
		{
			PushFcw();
			MovRegSIB(EAX, SIB(0, ESP, ESP), 0);
			if(unsig){
				AndRegImm(EAX, 0xf3ff);
				OrRegImm(EAX, 0x0400);
			}else{
				OrRegImm(EAX, 0x0c00);
			}
			PushReg(EAX);
			PopFcw();
			if(b64){
				SubRegImm(ESP, 8);
				pjtr->ntvcode += 0xDF;
				StktopAddress(7);
				PopReg(EAX);
				PopReg(EDX);
			}else{
				SubRegImm(ESP, 4);
				pjtr->ntvcode += 0xDB;
				StktopAddress(3);
				PopReg(EAX);
			}
			PopFcw();
		}
		void ItoF(const bool unsig, const bool b64)
		{
			if(unsig && b64){
				MovRegReg(ECX, EDX);
				//
				AndRegImm(EDX, 0x7fffffff);
				PushReg(EDX);
				PushReg(EAX);
				pjtr->ntvcode += 0xDF;
				StktopAddress(5);
				AddRegImm(ESP, 8);
				//
				AndRegImm(ECX, 0x80000000);
				ShrRegImm(ECX, 1, false);
				PushReg(ECX);
				PushImm(0);
				pjtr->ntvcode += 0xDF;
				StktopAddress(5);
				AddRegImm(ESP, 8);
				//
				pjtr->ntvcode += 0xDC; pjtr->ntvcode += 0xC1;
				pjtr->ntvcode += 0xDE; pjtr->ntvcode += 0xC1;
			}else if(unsig || b64){
				if(unsig) MovRegImm(EDX, 0);
				PushReg(EDX);
				PushReg(EAX);
				pjtr->ntvcode += 0xDF;
				StktopAddress(5);
				AddRegImm(ESP, 8);
			}else{
				PushReg(EAX);
				pjtr->ntvcode += 0xDB;
				StktopAddress(0);
				AddRegImm(ESP, 4);
			}
		}
		void FltDrop()
		{
			pjtr->ntvcode += 0xDD; pjtr->ntvcode += 0xD8;
		}
		void FldStk(const bool b64)
		{
			if(b64){
				pjtr->ntvcode += 0xDD;
				StktopAddress(0);
				AddRegImm(ESP, 8);
			}else{
				pjtr->ntvcode += 0xD9;
				StktopAddress(0);
				AddRegImm(ESP, 4);
			}
		}
		bool FldAdr(const AddressType at, const int32_t adr, const bool b64)
		{
			if(b64){
				pjtr->ntvcode += 0xDD;
			}else{
				pjtr->ntvcode += 0xD9;
			}
			return ModAddress(0, at, adr);
		}
		bool FstAdr(const AddressType at, const int32_t adr, const bool b64)
		{
			if(b64){
				pjtr->ntvcode += 0xDD;
			}else{
				pjtr->ntvcode += 0xD9;
			}
			return ModAddress(2, at, adr);
		}
		void FmulStk(const bool b64)
		{
			if(b64){
				pjtr->ntvcode += 0xDC;
				StktopAddress(1);
				AddRegImm(ESP, 8);
			}else{
				pjtr->ntvcode += 0xD8;
				StktopAddress(1);
				AddRegImm(ESP, 4);
			}
		}
		bool FmulAdr(const AddressType at, const int32_t adr, const bool b64)
		{
			if(b64){
				pjtr->ntvcode += 0xDC;
			}else{
				pjtr->ntvcode += 0xD8;
			}
			return ModAddress(1, at, adr);
		}
		void FdivStk(const bool b64)
		{
			if(b64){
				pjtr->ntvcode += 0xDC;
				StktopAddress(6);
				AddRegImm(ESP, 8);
			}else{
				pjtr->ntvcode += 0xD8;
				StktopAddress(6);
				AddRegImm(ESP, 4);
			}
		}
		void FdivStkSwap(const bool b64)
		{
			FldStk(b64);
			pjtr->ntvcode += 0xD9; pjtr->ntvcode += 0xC9;
			pjtr->ntvcode += 0xDE; pjtr->ntvcode += 0xF9;
		}
		bool FdivAdr(const AddressType at, const int32_t adr, const bool b64)
		{
			if(b64){
				pjtr->ntvcode += 0xDC;
			}else{
				pjtr->ntvcode += 0xD8;
			}
			return ModAddress(6, at, adr);
		}
		void FaddStk(const bool b64)
		{
			if(b64){
				pjtr->ntvcode += 0xDC;
				StktopAddress(0);
				AddRegImm(ESP, 8);
			}else{
				pjtr->ntvcode += 0xD8;
				StktopAddress(0);
				AddRegImm(ESP, 4);
			}
		}
		bool FaddAdr(const AddressType at, const int32_t adr, const bool b64)
		{
			if(b64){
				pjtr->ntvcode += 0xDC;
			}else{
				pjtr->ntvcode += 0xD8;
			}
			return ModAddress(0, at, adr);
		}
		void FsubStk(const bool b64)
		{
			if(b64){
				pjtr->ntvcode += 0xDC;
				StktopAddress(4);
				AddRegImm(ESP, 8);
			}else{
				pjtr->ntvcode += 0xD8;
				StktopAddress(4);
				AddRegImm(ESP, 4);
			}
		}
		bool FsubAdr(const AddressType at, const int32_t adr, const bool b64)
		{
			if(b64){
				pjtr->ntvcode += 0xDC;
			}else{
				pjtr->ntvcode += 0xD8;
			}
			return ModAddress(4, at, adr);
		}
		void Fchs()
		{
			pjtr->ntvcode += 0xD9; pjtr->ntvcode += 0xE0;
		}
		void Fcomi()
		{
			pjtr->ntvcode += 0xDF; pjtr->ntvcode += 0xF1;
			FltDrop();
			pjtr->ntvcode += 0x9F;
		}
		////////////////////////////////////////////////////////////////////////////
		void SetJtr(JITer *const po)
		{
			pjtr = po;
		}
		bool Cast(const SrcTree &stree, PWCArray<int32_t> &tystack, const int32_t dtype, int32_t &typ)
		{
			if(0 <= typ && typ <= ENDCLASS_TYPEID && stree.stat->funclist.Get(typ)->selftype == ENUM_BLOCK){
				tystack.Tail() = typ = INT_TYPEID;
			}
			if(typ == dtype) return true;
			switch(dtype){
			case BYTE_TYPEID:
				if(typ == FLOAT_TYPEID || typ == DOUBLE_TYPEID){
					FtoI(false, false);
					break;
				}
			case UBYTE_TYPEID:
				switch(typ){
				case BYTE_TYPEID: case UBYTE_TYPEID: case BOOL_TYPEID: case SHORT_TYPEID:case USHORT_TYPEID: case CHAR_TYPEID:
				case INT_TYPEID: case ADDRESS_TYPEID: case UINT_TYPEID: case LONG_TYPEID: case ULONG_TYPEID:
					break;
				case FLOAT_TYPEID: case DOUBLE_TYPEID:
					FtoI(true, false);
					break;
				default:
					pjtr->root->stat->ss->ErrorMessage.Add(*pjtr->filename, pjtr->gyousuu, L"sȃLXgłB");
					return false;
				}
				break;
			case SHORT_TYPEID:
				if(typ == FLOAT_TYPEID || typ == DOUBLE_TYPEID){
					FtoI(false, false);
					break;
				}
			case USHORT_TYPEID:
			case CHAR_TYPEID:
				switch(typ){
				case BYTE_TYPEID:
					Cwde(true);
					break;
				case UBYTE_TYPEID: case BOOL_TYPEID:
					AndRegImm(EAX, 0xff);
					break;
				case SHORT_TYPEID:case USHORT_TYPEID: case CHAR_TYPEID:
				case INT_TYPEID: case ADDRESS_TYPEID: case UINT_TYPEID: case LONG_TYPEID: case ULONG_TYPEID:
					break;
				case FLOAT_TYPEID: case DOUBLE_TYPEID:
					FtoI(true, false);
					break;
				default:
					pjtr->root->stat->ss->ErrorMessage.Add(*pjtr->filename, pjtr->gyousuu, L"sȃLXgłB");
					return false;
				}
				break;
			case INT_TYPEID:
			case ADDRESS_TYPEID:
				if(typ == FLOAT_TYPEID || typ == DOUBLE_TYPEID){
					FtoI(false, false);
					break;
				}
			case UINT_TYPEID:
				switch(typ){
				case BYTE_TYPEID:
					Cwde(true);
				case SHORT_TYPEID:
					Cwde(false);
					break;
				case UBYTE_TYPEID: case BOOL_TYPEID:
					AndRegImm(EAX, 0xff);
					break;
				case USHORT_TYPEID: case CHAR_TYPEID:
					AndRegImm(EAX, 0xffff);
					break;
				case INT_TYPEID: case ADDRESS_TYPEID: case UINT_TYPEID: case LONG_TYPEID: case ULONG_TYPEID:
					break;
				case FLOAT_TYPEID: case DOUBLE_TYPEID:
					FtoI(true, false);
					break;
				default:
					pjtr->root->stat->ss->ErrorMessage.Add(*pjtr->filename, pjtr->gyousuu, L"sȃLXgłB");
					return false;
				}
				break;
			case LONG_TYPEID:
				if(typ == FLOAT_TYPEID || typ == DOUBLE_TYPEID){
					FtoI(false, true);
					break;
				}
			case ULONG_TYPEID:
				switch(typ){
				case BYTE_TYPEID:
					Cwde(true);
				case SHORT_TYPEID:
					Cwde(false);
				case INT_TYPEID: case ADDRESS_TYPEID:
					Cdq();
					break;
				case UBYTE_TYPEID: case BOOL_TYPEID:
					AndRegImm(EAX, 0xff);
					MovRegImm(EDX, 0);
					break;
				case USHORT_TYPEID: case CHAR_TYPEID:
					AndRegImm(EAX, 0xffff);
				case UINT_TYPEID:
					MovRegImm(EDX, 0);
					break;
				case LONG_TYPEID: case ULONG_TYPEID:
					break;
				case FLOAT_TYPEID: case DOUBLE_TYPEID:
					FtoI(true, true);
					break;
				default:
					pjtr->root->stat->ss->ErrorMessage.Add(*pjtr->filename, pjtr->gyousuu, L"sȃLXgłB");
					return false;
				}
				break;
			case FLOAT_TYPEID:
			case DOUBLE_TYPEID:
				if(typ == FLOAT_TYPEID || typ == DOUBLE_TYPEID) break;
				switch(typ){
				case BYTE_TYPEID:
					Cwde(true);
				case SHORT_TYPEID:
					Cwde(false);
					break;
				case UBYTE_TYPEID: case BOOL_TYPEID:
					AndRegImm(EAX, 0xff);
					break;
				case USHORT_TYPEID: case CHAR_TYPEID:
					AndRegImm(EAX, 0xffff);
					break;
				case INT_TYPEID: case ADDRESS_TYPEID: case UINT_TYPEID: case LONG_TYPEID: case ULONG_TYPEID:
					break;
				default:
					pjtr->root->stat->ss->ErrorMessage.Add(*pjtr->filename, pjtr->gyousuu, L"sȃLXgłB");
					return false;
				}
				if(typ == ULONG_TYPEID){
					ItoF(true, true);
				}else if(typ == LONG_TYPEID){
					ItoF(false, true);
				}else if(typ == UINT_TYPEID){
					ItoF(true, false);
				}else{
					ItoF(false, false);
				}
				break;
			default:
				pjtr->root->stat->ss->ErrorMessage.Add(*pjtr->filename, pjtr->gyousuu, L"sȃLXgłB");
				return false;
			}
			tystack.Tail() = typ = dtype;
			return true;
		}
		bool JidouCast(const SrcTree &stree, PWCArray<int32_t> &tystack, const int32_t dtype, int32_t &typ)
		{
			if(typ == dtype) return true;
			if( (
				(dtype == ADDRESS_TYPEID || BYTE_TYPEID >= dtype && dtype >= LONG_TYPEID)
				&& (typ == ADDRESS_TYPEID || BYTE_TYPEID >= typ && typ >= LONG_TYPEID)
				)
				|| (UBYTE_TYPEID >= dtype && dtype >= ULONG_TYPEID && UBYTE_TYPEID >= typ && typ >= ULONG_TYPEID)
				|| ((dtype == FLOAT_TYPEID || dtype == DOUBLE_TYPEID) && (typ == FLOAT_TYPEID || typ == DOUBLE_TYPEID)))
			{
				return Cast(stree, tystack, dtype, typ);
			}
			pjtr->root->stat->ss->ErrorMessage.Add(*pjtr->filename, pjtr->gyousuu, L"^G[łB");
			return false;
		}
		intptr_t Kansuu(SrcTree &stree, const intptr_t *const iap, intptr_t &i, PWCArray<int32_t> &tystack, KuwashiiType &ktype, SrcTree &st, const bool thrd)
		{
			intptr_t ii, jj, idx, sizar, bp;
			int32_t typ;
			SrcTree *retcall = NULL;
			bool refari = false;
			if(!st.kakutei) return -1;
			ii = 0;
			while(iap[i] != SHOUKAKKOCLOSE_TOKEN){
				if(ii >= st.hikisuucount){
					if(ii == 0){
						jj = tystack.GetLength();
						do{
							if(!MainSwitch(stree, iap, i, tystack, ktype, retcall)) return -1;
							i++;
						}while(iap[i] != SHOUKAKKOCLOSE_TOKEN && iap[i] != COMMA_TOKEN);
						if(jj == tystack.GetLength()) break;
					}
					return -1;
				}
				if((typ = TokenTtoTypeId(st.funchensuu.GetConst()[st.tpcount+ii].type.GetConst(), idx=0)) == UNKNOWN_TYPEID) return -1;
				tystack += typ;
				do{
					if(!MainSwitch(stree, iap, i, tystack, ktype, retcall)) return -1;
					i++;
				}while(iap[i] != SHOUKAKKOCLOSE_TOKEN && iap[i] != COMMA_TOKEN);
				if(st.funchensuu.GetConst()[st.tpcount+ii].type.GetTail() == ~DAINYUU_TOKEN){
					if(thrd){
						pjtr->root->stat->ss->ErrorMessage.Add(*pjtr->filename, pjtr->gyousuu, L"Xbhɂ͎QƓnł܂B");
						return -1;
					}
					if(tystack.GetTail() != UNKNOWN_TYPEID || ktype.id != typ) return -1;
					if(ktype.id == REF_TYPEID || ktype.id == LIST_TYPEID || ktype.id == FUNC_TYPEID || ktype.id == METHOD_TYPEID){
						SoushokuTobasi(ktype.kwsk.GetConst(), idx=0);
						if(st.funchensuu.GetConst()[st.tpcount+ii].type.GetLength()-1 > ktype.kwsk.GetLength()-idx) return -1;
						for(jj = 0; jj < st.funchensuu.GetConst()[st.tpcount+ii].type.GetLength()-1; jj++){
							if(st.funchensuu.GetConst()[st.tpcount+ii].type.GetConst()[jj] != ktype.kwsk.GetConst()[jj+idx]) return -1;
						}
					}
					ktype.id = VOID_TYPEID;
					i++;
				}else{
					if(tystack.GetTail() == UNKNOWN_TYPEID) return -1;
					if(ktype.id == REF_TYPEID || ktype.id == LIST_TYPEID || ktype.id == DYNREF_TYPEID || ktype.id == DYNLIST_TYPEID){
						if(!stree.YuruiKataCheck(ktype.kwsk, st.funchensuu.GetConst()[st.tpcount+ii].type, *pjtr->filename, pjtr->gyousuu)) return -1;
						if(thrd){
							PushReg(ESP);
							PluginCall(RefCntUp);
							refari = true;
						}
					}else if(ktype.id == FUNC_TYPEID || ktype.id == METHOD_TYPEID){
						if(!stree.YuruiKataCheck(ktype.kwsk, st.funchensuu.GetConst()[st.tpcount+ii].type, *pjtr->filename, pjtr->gyousuu)) return -1;
					}else if(ktype.id == DELEGATE_TYPEID){
						if(thrd){
							pjtr->root->stat->ss->ErrorMessage.Add(*pjtr->filename, pjtr->gyousuu, L"delegate^̓Xbhɓn܂B");
							return -1;
						}
						if(!stree.YuruiKataCheck(ktype.kwsk, st.funchensuu.GetConst()[st.tpcount+ii].type, *pjtr->filename, pjtr->gyousuu)) return -1;
					}else if(0 <= ktype.id && ktype.id <= ENDCLASS_TYPEID){
						if(!JidouCast(stree, tystack, typ, ktype.id)) return -1;
						if(stree.stat->funclist.Get(ktype.id)->selftype == CLASS_BLOCK){
							SubRegImm(ESP, Aligner(stree.stat->funclist.Get(ktype.id)->GetMemberSize()));
							MovRegReg(ESI, ESP);
							(bool)MemCopy(AT_SANSHOU, 0, stree.stat->funclist.Get(ktype.id)->GetMemberSize());
							ktype.id = VOID_TYPEID;
						}
					}else{
						if(!JidouCast(stree, tystack, typ, ktype.id)) return -1;
						ktype.id = typ;
					}
				}
				if(iap[i] == COMMA_TOKEN){
					i++;
					if(iap[i] == SHOUKAKKOCLOSE_TOKEN) return -1;
				}
				ii++;
			}
			tystack.SetLength(tystack.GetLength()-ii*2);
			if(ii != st.hikisuucount) return -1;
			if(!KTPush(ktype)) return -1;
			if((ktype.id = TokenTtoTypeId(st.rettype.GetConst(), idx=0)) == UNKNOWN_TYPEID) return -1;
			tystack += ktype.id;
			sizar = 0;
			for(jj = st.tpcount; jj < st.tpcount+st.hikisuucount; jj++){
				if(st.funchensuu.GetConst()[jj].type.GetTail() == ~DAINYUU_TOKEN){
					sizar += Aliszof<intptr_t>();
				}else{
					sizar += Aligner(stree.GetTypeSize(st.funchensuu.GetConst()[jj].type));
				}
			}
			if(thrd){
				PushImm(sizar);
				if(st.byteadress == 0){
					st.backpatch += PushCadr(0);
				}else{
					PushCadr(st.byteadress);
				}
				if(refari){
					if(st.sonota.thatoshori == 0){
						bp = Jump(0);
						st.sonota.thatoshori = pjtr->ntvcode.GetLength();
						for(jj = st.tpcount+st.hikisuucount-1; jj >= st.tpcount; jj--){
							if(st.funchensuu.GetConst()[jj].type.GetConst()[0]==REF_TOKEN || st.funchensuu.GetConst()[jj].type.GetConst()[0]==LIST_TOKEN){
								if(!RefCountDown(stree, AT_MEMBER, st.GetMemberOffset(jj) - (st.GetMemberSize() - sizar), st.funchensuu.GetConst()[jj].type, false)) return -1;
							}
						}
						Return(0, false);
						*(intptr_t *)(pjtr->ntvcode.GetConst()+bp) += pjtr->ntvcode.GetLength();
					}
					PushCadr(st.sonota.thatoshori);
				}else{
					PushImm(NULL);
				}
				PluginCall(ThreadRun);
				AddRegImm(ESP, sizar+16);
			}
			return sizar;
		}
		intptr_t KansuuPointer(SrcTree &stree, const intptr_t *const iap, intptr_t &i, PWCArray<int32_t> &tystack, KuwashiiType &ktype, const SrcTree *const pmbrstree, PWCArrayQuad< PWCArray<intptr_t> > &waketa)
		{
			intptr_t ii, jj, idx;
			int32_t typ;
			intptr_t sizee;
			SrcTree *retcall = NULL;
			if(!stree.KansuuKata(pmbrstree, ktype.kwsk, waketa)) return -1;
			ii = 0;
			while(iap[i] != KAKKOCOLOCLOSE_TOKEN){
				if(ii+1 >= waketa.GetLength()) return -1;
				typ = TokenTtoTypeId(waketa.GetConst()[ii+1].GetConst(), idx=0);
				tystack += typ;
				do{
					if(!MainSwitch(stree, iap, i, tystack, ktype, retcall)) return -1;
					i++;
				}while(iap[i] != KAKKOCOLOCLOSE_TOKEN && iap[i] != COMMA_TOKEN);
				if(typ == UNKNOWN_TYPEID) return -1;
				if(waketa.GetConst()[ii+1].GetTail() == ~DAINYUU_TOKEN){
					if(tystack.GetTail() != UNKNOWN_TYPEID || ktype.id != typ) return -1;
					if(ktype.id == REF_TYPEID || ktype.id == LIST_TYPEID || ktype.id == FUNC_TYPEID || ktype.id == METHOD_TYPEID){
						SoushokuTobasi(ktype.kwsk.GetConst(), idx=0);
						if(waketa.GetConst()[ii+1].GetLength()-1 > ktype.kwsk.GetLength()-idx) return -1;
						for(jj = 0; jj < waketa.GetConst()[ii+1].GetLength()-1; jj++){
							if(waketa.GetConst()[ii+1].GetConst()[jj] != ktype.kwsk.GetConst()[jj+idx]) return -1;
						}
					}
					ktype.id = VOID_TYPEID;
					i++;
				}else{
					if(tystack.GetTail() == UNKNOWN_TYPEID) return -1;
					if(ktype.id == REF_TYPEID || ktype.id == LIST_TYPEID || ktype.id == DYNREF_TYPEID || ktype.id == DYNLIST_TYPEID 
						|| ktype.id == FUNC_TYPEID || ktype.id == METHOD_TYPEID || ktype.id == DELEGATE_TYPEID){
						if(!stree.YuruiKataCheck(ktype.kwsk, waketa.GetConst()[ii+1], *pjtr->filename, pjtr->gyousuu)) return -1;
					}else if(0 <= ktype.id && ktype.id <= ENDCLASS_TYPEID){
						if(!JidouCast(stree, tystack, typ, ktype.id)) return -1;
						if(stree.stat->funclist.Get(ktype.id)->selftype == CLASS_BLOCK){
							SubRegImm(ESP, Aligner(stree.stat->funclist.Get(ktype.id)->GetMemberSize()));
							MovRegReg(ESI, ESP);
							(bool)MemCopy(AT_SANSHOU, 0, stree.stat->funclist.Get(ktype.id)->GetMemberSize());
							ktype.id = VOID_TYPEID;
						}
					}else{
						if(!JidouCast(stree, tystack, typ, ktype.id)) return -1;
						ktype.id = typ;
					}
				}
				if(iap[i] == COMMA_TOKEN){
					i++;
					if(iap[i] == KAKKOCOLOCLOSE_TOKEN) return -1;
				}
				ii++;
			}
			tystack.SetLength(tystack.GetLength()-ii*2);
			if(ii+1 != waketa.GetLength()) return -1;
			if(!KTPush(ktype)) return -1;
			if((ktype.id = TokenTtoTypeId(waketa.GetConst()[0].GetConst(), idx=0)) == UNKNOWN_TYPEID) return -1;
			tystack += ktype.id;
			sizee = 0;
			for(jj = 1; jj < waketa.GetLength(); jj++){
				if(waketa.GetConst()[jj].GetTail() == ~DAINYUU_TOKEN){
					sizee += Aliszof<intptr_t>();
				}else{
					sizee += Aligner(stree.GetTypeSize(waketa.GetConst()[jj]));
				}
			}
			return sizee;
		}
		bool KTPush(const KuwashiiType &ktype)
		{
			switch(ktype.id){
			case REF_TYPEID:
			case LIST_TYPEID:
			case DYNREF_TYPEID:
			case DYNLIST_TYPEID:
			case DELEGATE_TYPEID:
			case VOID_TYPEID:
				break;
			case LONG_TYPEID:
			case ULONG_TYPEID:
				PushReg(EDX);
				PushReg(EAX);
				break;
			case FLOAT_TYPEID:
				PushFlt(false);
				break;
			case DOUBLE_TYPEID:
				PushFlt(true);
				break;
			default:
				if(ktype.id < METHOD_TYPEID) return false;
				PushReg(EAX);
				break;
			}
			return true;
		}
		bool KTPop(const KuwashiiType &ktype)
		{
			switch(ktype.id){
			case REF_TYPEID:
			case LIST_TYPEID:
			case DYNREF_TYPEID:
			case DYNLIST_TYPEID:
			case DELEGATE_TYPEID:
			case VOID_TYPEID:
				break;
			case LONG_TYPEID:
			case ULONG_TYPEID:
				PopReg(EAX);
				PopReg(EDX);
				break;
			case FLOAT_TYPEID:
				PopFlt(false);
				break;
			case DOUBLE_TYPEID:
				PopFlt(true);
				break;
			default:
				if(ktype.id < METHOD_TYPEID) return false;
				PopReg(EAX);
				break;
			}
			return true;
		}
		bool KTDrop(KuwashiiType &ktype)
		{
			switch(ktype.id){
			case REF_TYPEID:
			case LIST_TYPEID:
				AddRegImm(ESP, Aliszof<Reference>());
				break;
			case DYNREF_TYPEID:
			case DYNLIST_TYPEID:
				AddRegImm(ESP, Aliszof<DynamicRef>());
				break;
			case DELEGATE_TYPEID:
				AddRegImm(ESP, Aliszof<intptr_t>()*3);
				break;
			case VOID_TYPEID:
				break;
			case FLOAT_TYPEID:
			case DOUBLE_TYPEID:
				FltDrop();
				break;
			default:
				if(ktype.id < METHOD_TYPEID) return false;
				break;
			}
			ktype.id = VOID_TYPEID;
			return true;
		}
		bool Teisuu(const SrcTree &stree, const KuwashiiType &ktype, const int32_t *const p)
		{
			switch(ktype.id){
			case BYTE_TYPEID:
			case UBYTE_TYPEID:
			case BOOL_TYPEID:
				MovRegImm(EAX, *(int8_t*)p);
				break;
			case SHORT_TYPEID:
			case USHORT_TYPEID:
			case CHAR_TYPEID:
				MovRegImm(EAX, *(int16_t*)p);
				break;
			default:
				if(ktype.id < 0 || ENDCLASS_TYPEID < ktype.id || stree.stat->funclist.Get(ktype.id)->selftype != ENUM_BLOCK) return false;
			case INT_TYPEID:
			case ADDRESS_TYPEID:
			case UINT_TYPEID:
				MovRegImm(EAX, *p);
				break;
			case LONG_TYPEID:
			case ULONG_TYPEID:
				MovRegImm(EAX, p[0]);
				MovRegImm(EDX, p[1]);
				break;
			case FLOAT_TYPEID:
				PushImm(*p);
				FldStk(false);
				break;
			case DOUBLE_TYPEID:
				PushImm(p[1]);
				PushImm(p[0]);
				FldStk(true);
				break;
			}
			return true;
		}
		bool ConstEnzan(const SrcTree &stree, PWCArray<int32_t> &tystack, KuwashiiType &ktype, int64_t cnsvar, const TokenKind tk)
		{
			switch(tk){
			case KAKERU_TOKEN:
			case KAKERUDAINYUU_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID: case UBYTE_TYPEID:
					if(*(int8_t*)&cnsvar == 1) break;
					MovRegImm(ECX, *(int8_t*)&cnsvar);
					MulReg(ECX);
					break;
				case SHORT_TYPEID: case USHORT_TYPEID: case CHAR_TYPEID:
					if(*(int16_t*)&cnsvar == 1) break;
					MovRegImm(ECX, *(int16_t*)&cnsvar);
					MulReg(ECX);
					break;
				case INT_TYPEID: case ADDRESS_TYPEID: case UINT_TYPEID:
					if(*(int32_t*)&cnsvar == 1) break;
					MovRegImm(ECX, *(int32_t*)&cnsvar);
					MulReg(ECX);
					break;
				case LONG_TYPEID: case ULONG_TYPEID:
					if(cnsvar == 1) break;
					if(!KTPush(ktype)) return false;
					if(!Teisuu(stree, ktype, (int32_t*)&cnsvar)) return false;
					MulStk64();
					break;
				case FLOAT_TYPEID:
					PushImm(*(int32_t*)&cnsvar);
					FmulStk(false);
					break;
				case DOUBLE_TYPEID:
					PushImm(((int32_t*)&cnsvar)[1]);
					PushImm(((int32_t*)&cnsvar)[0]);
					FmulStk(true);
					break;
				default:
					return false;
				}
				break;
			case WARU_TOKEN:
			case WARUDAINYUU_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID:
					if(*(int8_t*)&cnsvar == 1) break;
					MovRegImm(ECX, *(int8_t*)&cnsvar);
					IDivReg8(CL);
					break;
				case UBYTE_TYPEID:
					if(*(uint8_t*)&cnsvar == 1) break;
					MovRegImm(ECX, *(uint8_t*)&cnsvar);
					DivReg8(CL);
					break;
				case SHORT_TYPEID:
					if(*(int16_t*)&cnsvar == 1) break;
					MovRegImm(ECX, *(int16_t*)&cnsvar);
					IDivReg(ECX, true);
					break;
				case USHORT_TYPEID: case CHAR_TYPEID:
					if(*(uint16_t*)&cnsvar == 1) break;
					MovRegImm(ECX, *(uint16_t*)&cnsvar);
					DivReg(ECX, true);
					break;
				case INT_TYPEID: case ADDRESS_TYPEID:
					if(*(int32_t*)&cnsvar == 1) break;
					MovRegImm(ECX, *(int32_t*)&cnsvar);
					IDivReg(ECX, false);
					break;
				case UINT_TYPEID:
					if(*(uint32_t*)&cnsvar == 1) break;
					MovRegImm(ECX, *(uint32_t*)&cnsvar);
					DivReg(ECX, false);
					break;
				case LONG_TYPEID:
					if(cnsvar == 1) break;
					if(!KTPush(ktype)) return false;
					if(!Teisuu(stree, ktype, (int32_t*)&cnsvar)) return false;
					IDivStk64();
					break;
				case ULONG_TYPEID:
					if(cnsvar == 1) break;
					if(!KTPush(ktype)) return false;
					if(!Teisuu(stree, ktype, (int32_t*)&cnsvar)) return false;
					DivStk64();
					break;
				case FLOAT_TYPEID:
					PushImm(*(int32_t*)&cnsvar);
					FdivStk(false);
					break;
				case DOUBLE_TYPEID:
					PushImm(((int32_t*)&cnsvar)[1]);
					PushImm(((int32_t*)&cnsvar)[0]);
					FdivStk(true);
					break;
				default:
					return false;
				}
				break;
			case AMARI_TOKEN:
			case AMARIDAINYUU_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID:
					if(*(int8_t*)&cnsvar == 1){
						MovRegImm(EAX, 0);
					}else{
						MovRegImm(ECX, *(int8_t*)&cnsvar);
						IRemReg8(CL);
					}
					break;
				case UBYTE_TYPEID:
					if(*(uint8_t*)&cnsvar == 1){
						MovRegImm(EAX, 0);
					}else{
						MovRegImm(ECX, *(uint8_t*)&cnsvar);
						RemReg8(CL);
					}
					break;
				case SHORT_TYPEID:
					if(*(int16_t*)&cnsvar == 1){
						MovRegImm(EAX, 0);
					}else{
						MovRegImm(ECX, *(int16_t*)&cnsvar);
						IRemReg(ECX, true);
					}
					break;
				case USHORT_TYPEID: case CHAR_TYPEID:
					if(*(uint16_t*)&cnsvar == 1){
						MovRegImm(EAX, 0);
					}else{
						MovRegImm(ECX, *(uint16_t*)&cnsvar);
						RemReg(ECX, true);
					}
					break;
				case INT_TYPEID: case ADDRESS_TYPEID:
					if(*(int32_t*)&cnsvar == 1){
						MovRegImm(EAX, 0);
					}else{
						MovRegImm(ECX, *(int32_t*)&cnsvar);
						IRemReg(ECX, false);
					}
					break;
				case UINT_TYPEID:
					if(*(uint32_t*)&cnsvar == 1){
						MovRegImm(EAX, 0);
					}else{
						MovRegImm(ECX, *(uint32_t*)&cnsvar);
						RemReg(ECX, false);
					}
					break;
				case LONG_TYPEID:
					if(cnsvar == 1){
						MovRegImm(EAX, 0);
						MovRegImm(EDX, 0);
					}else{
						if(!KTPush(ktype)) return false;
						if(!Teisuu(stree, ktype, (int32_t*)&cnsvar)) return false;
						IRemStk64();
					}
					break;
				case ULONG_TYPEID:
					if(cnsvar == 1){
						MovRegImm(EAX, 0);
						MovRegImm(EDX, 0);
					}else{
						if(!KTPush(ktype)) return false;
						if(!Teisuu(stree, ktype, (int32_t*)&cnsvar)) return false;
						RemStk64();
					}
					break;
				default:
					return false;
				}
				break;
			case PULUS_TOKEN:
			case PULUSDAINYUU_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID: case UBYTE_TYPEID:
					AddRegImm(EAX, *(int8_t*)&cnsvar);
					break;
				case SHORT_TYPEID: case USHORT_TYPEID: case CHAR_TYPEID:
					AddRegImm(EAX, *(int16_t*)&cnsvar);
					break;
				case INT_TYPEID: case ADDRESS_TYPEID: case UINT_TYPEID:
					AddRegImm(EAX, *(int32_t*)&cnsvar);
					break;
				case LONG_TYPEID: case ULONG_TYPEID:
					AddImm64(cnsvar);
					break;
				case FLOAT_TYPEID:
					PushImm(*(int32_t*)&cnsvar);
					FaddStk(false);
					break;
				case DOUBLE_TYPEID:
					PushImm(((int32_t*)&cnsvar)[1]);
					PushImm(((int32_t*)&cnsvar)[0]);
					FaddStk(true);
					break;
				default:
					return false;
				}
				break;
			case MINUS_TOKEN:
			case MINUSDAINYUU_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID: case UBYTE_TYPEID:
					SubRegImm(EAX, *(int8_t*)&cnsvar);
					break;
				case SHORT_TYPEID: case USHORT_TYPEID: case CHAR_TYPEID:
					SubRegImm(EAX, *(int16_t*)&cnsvar);
					break;
				case INT_TYPEID: case ADDRESS_TYPEID: case UINT_TYPEID:
					SubRegImm(EAX, *(int32_t*)&cnsvar);
					break;
				case LONG_TYPEID: case ULONG_TYPEID:
					SubImm64(cnsvar);
					break;
				case FLOAT_TYPEID:
					PushImm(*(int32_t*)&cnsvar);
					FsubStk(false);
					break;
				case DOUBLE_TYPEID:
					PushImm(((int32_t*)&cnsvar)[1]);
					PushImm(((int32_t*)&cnsvar)[0]);
					FsubStk(true);
					break;
				default:
					return false;
				}
				break;
			case LSHIFT_TOKEN:
			case LSHIFTDAINYUU_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID: case UBYTE_TYPEID: case SHORT_TYPEID: case USHORT_TYPEID: case CHAR_TYPEID:
				case INT_TYPEID: case ADDRESS_TYPEID: case UINT_TYPEID:
					ShlRegImm(EAX, *(int8_t*)&cnsvar);
					break;
				case LONG_TYPEID: case ULONG_TYPEID:
					ShlImm64((int8_t)cnsvar);
					break;
				default:
					return false;
				}
				break;
			case RSHIFT_TOKEN:
			case RSHIFTDAINYUU_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID:
					SarRegImm8(AL, *(int8_t*)&cnsvar);
					break;
				case SHORT_TYPEID:
					SarRegImm(EAX, (int8_t)*(int16_t*)&cnsvar, true);
					break;
				case INT_TYPEID: case ADDRESS_TYPEID:
					SarRegImm(EAX, (int8_t)*(int32_t*)&cnsvar, false);
					break;
				case UBYTE_TYPEID:
					ShrRegImm8(AL, *(uint8_t*)&cnsvar);
					break;
				case USHORT_TYPEID: case CHAR_TYPEID:
					ShrRegImm(EAX, *(uint8_t*)&cnsvar, true);
					break;
				case UINT_TYPEID:
					ShrRegImm(EAX, *(uint8_t*)&cnsvar, false);
					break;
				case LONG_TYPEID:
					SarImm64((int8_t)cnsvar);
					break;
				case ULONG_TYPEID:
					ShrImm64((int8_t)cnsvar);
					break;
				default:
					return false;
				}
				break;
			case SHOU_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID:
					CmpImm8(*(int8_t*)&cnsvar); ILess();
					break;
				case UBYTE_TYPEID:
					CmpImm8(*(uint8_t*)&cnsvar); Less();
					break;
				case SHORT_TYPEID:
					CmpImm(*(int16_t*)&cnsvar, true); ILess();
					break;
				case USHORT_TYPEID: case CHAR_TYPEID:
					CmpImm(*(uint16_t*)&cnsvar, true); Less();
					break;
				default:
					if(ktype.id < 0 || ENDCLASS_TYPEID < ktype.id || stree.stat->funclist.Get(ktype.id)->selftype != ENUM_BLOCK) return false;
				case INT_TYPEID: case ADDRESS_TYPEID:
					CmpImm(*(int32_t*)&cnsvar, false); ILess();
					break;
				case UINT_TYPEID:
					CmpImm(*(uint32_t*)&cnsvar, false); Less();
					break;
				case LONG_TYPEID:
					ILessImm64(cnsvar);
					break;
				case ULONG_TYPEID:
					LessImm64(cnsvar);
					break;
				case FLOAT_TYPEID:
					PushImm(*(int32_t*)&cnsvar);
					FldStk(false);
					Fcomi(); Ijou();
					break;
				case DOUBLE_TYPEID:
					PushImm(((int32_t*)&cnsvar)[1]);
					PushImm(((int32_t*)&cnsvar)[0]);
					FldStk(true);
					Fcomi(); Ijou();
					break;
				}
				tystack.Tail() = ktype.id = BOOL_TYPEID;
				break;
			case SHOUOREQUAL_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID:
					CmpImm8(*(int8_t*)&cnsvar); IIka();
					break;
				case UBYTE_TYPEID:
					CmpImm8(*(uint8_t*)&cnsvar); Ika();
					break;
				case SHORT_TYPEID:
					CmpImm(*(int16_t*)&cnsvar, true); IIka();
					break;
				case USHORT_TYPEID: case CHAR_TYPEID:
					CmpImm(*(uint16_t*)&cnsvar, true); Ika();
					break;
				default:
					if(ktype.id < 0 || ENDCLASS_TYPEID < ktype.id || stree.stat->funclist.Get(ktype.id)->selftype != ENUM_BLOCK) return false;
				case INT_TYPEID: case ADDRESS_TYPEID:
					CmpImm(*(int32_t*)&cnsvar, false); IIka();
					break;
				case UINT_TYPEID:
					CmpImm(*(uint32_t*)&cnsvar, false); Ika();
					break;
				case LONG_TYPEID:
					IIkaImm64(cnsvar);
					break;
				case ULONG_TYPEID:
					IkaImm64(cnsvar);
					break;
				case FLOAT_TYPEID:
					PushImm(*(int32_t*)&cnsvar);
					FldStk(false);
					Fcomi(); Over();
					break;
				case DOUBLE_TYPEID:
					PushImm(((int32_t*)&cnsvar)[1]);
					PushImm(((int32_t*)&cnsvar)[0]);
					FldStk(true);
					Fcomi(); Over();
					break;
				}
				tystack.Tail() = ktype.id = BOOL_TYPEID;
				break;
			case DAI_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID:
					CmpImm8(*(int8_t*)&cnsvar); IOver();
					break;
				case UBYTE_TYPEID:
					CmpImm8(*(uint8_t*)&cnsvar); Over();
					break;
				case SHORT_TYPEID:
					CmpImm(*(int16_t*)&cnsvar, true); IOver();
					break;
				case USHORT_TYPEID: case CHAR_TYPEID:
					CmpImm(*(uint16_t*)&cnsvar, true); Over();
					break;
				default:
					if(ktype.id < 0 || ENDCLASS_TYPEID < ktype.id || stree.stat->funclist.Get(ktype.id)->selftype != ENUM_BLOCK) return false;
				case INT_TYPEID: case ADDRESS_TYPEID:
					CmpImm(*(int32_t*)&cnsvar, false); IOver();
					break;
				case UINT_TYPEID:
					CmpImm(*(uint32_t*)&cnsvar, false); Over();
					break;
				case LONG_TYPEID:
					IOverImm64(cnsvar);
					break;
				case ULONG_TYPEID:
					OverImm64(cnsvar);
					break;
				case FLOAT_TYPEID:
					PushImm(*(int32_t*)&cnsvar);
					FldStk(false);
					Fcomi(); Ika();
					break;
				case DOUBLE_TYPEID:
					PushImm(((int32_t*)&cnsvar)[1]);
					PushImm(((int32_t*)&cnsvar)[0]);
					FldStk(true);
					Fcomi(); Ika();
					break;
				}
				tystack.Tail() = ktype.id = BOOL_TYPEID;
				break;
			case DAIOREQUAL_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID:
					CmpImm8(*(int8_t*)&cnsvar); IIjou();
					break;
				case UBYTE_TYPEID:
					CmpImm8(*(uint8_t*)&cnsvar); Ijou();
					break;
				case SHORT_TYPEID:
					CmpImm(*(int16_t*)&cnsvar, true); IIjou();
					break;
				case USHORT_TYPEID: case CHAR_TYPEID:
					CmpImm(*(uint16_t*)&cnsvar, true); Ijou();
					break;
				default:
					if(ktype.id < 0 || ENDCLASS_TYPEID < ktype.id || stree.stat->funclist.Get(ktype.id)->selftype != ENUM_BLOCK) return false;
				case INT_TYPEID: case ADDRESS_TYPEID:
					CmpImm(*(int32_t*)&cnsvar, false); IIjou();
					break;
				case UINT_TYPEID:
					CmpImm(*(uint32_t*)&cnsvar, false); Ijou();
					break;
				case LONG_TYPEID:
					IIjouImm64(cnsvar);
					break;
				case ULONG_TYPEID:
					IjouImm64(cnsvar);
					break;
				case FLOAT_TYPEID:
					PushImm(*(int32_t*)&cnsvar);
					FldStk(false);
					Fcomi(); Less();
					break;
				case DOUBLE_TYPEID:
					PushImm(((int32_t*)&cnsvar)[1]);
					PushImm(((int32_t*)&cnsvar)[0]);
					FldStk(true);
					Fcomi(); Less();
					break;
				}
				tystack.Tail() = ktype.id = BOOL_TYPEID;
				break;
			case EQUAL_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID: case UBYTE_TYPEID: case BOOL_TYPEID:
					CmpImm8(*(int8_t*)&cnsvar); Equal();
					break;
				case SHORT_TYPEID: case USHORT_TYPEID: case CHAR_TYPEID:
					CmpImm(*(int16_t*)&cnsvar, true); Equal();
					break;
				default:
					if(ktype.id < 0 || ENDCLASS_TYPEID < ktype.id || stree.stat->funclist.Get(ktype.id)->selftype != ENUM_BLOCK) return false;
				case INT_TYPEID: case ADDRESS_TYPEID: case UINT_TYPEID: case FUNC_TYPEID: case METHOD_TYPEID:
					CmpImm(*(int32_t*)&cnsvar, false); Equal();
					break;
				case LONG_TYPEID: case ULONG_TYPEID:
					EqualImm64(cnsvar);
					break;
				case FLOAT_TYPEID:
					PushImm(*(int32_t*)&cnsvar);
					FldStk(false);
					Fcomi(); Equal();
					break;
				case DOUBLE_TYPEID:
					PushImm(((int32_t*)&cnsvar)[1]);
					PushImm(((int32_t*)&cnsvar)[0]);
					FldStk(true);
					Fcomi(); Equal();
					break;
				}
				tystack.Tail() = ktype.id = BOOL_TYPEID;
				break;
			case NOTEQUAL_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID: case UBYTE_TYPEID: case BOOL_TYPEID:
					CmpImm8(*(int8_t*)&cnsvar); NEqual();
					break;
				case SHORT_TYPEID: case USHORT_TYPEID: case CHAR_TYPEID:
					CmpImm(*(int16_t*)&cnsvar, true); NEqual();
					break;
				default:
					if(ktype.id < 0 || ENDCLASS_TYPEID < ktype.id || stree.stat->funclist.Get(ktype.id)->selftype != ENUM_BLOCK) return false;
				case INT_TYPEID: case ADDRESS_TYPEID: case UINT_TYPEID: case FUNC_TYPEID: case METHOD_TYPEID:
					CmpImm(*(int32_t*)&cnsvar, false); NEqual();
					break;
				case LONG_TYPEID: case ULONG_TYPEID:
					NEqualImm64(cnsvar);
					break;
				case FLOAT_TYPEID:
					PushImm(*(int32_t*)&cnsvar);
					FldStk(false);
					Fcomi(); NEqual();
					break;
				case DOUBLE_TYPEID:
					PushImm(((int32_t*)&cnsvar)[1]);
					PushImm(((int32_t*)&cnsvar)[0]);
					FldStk(true);
					Fcomi(); NEqual();
					break;
				}
				tystack.Tail() = ktype.id = BOOL_TYPEID;
				break;
			case AND_TOKEN:
			case ANDDAINYUU_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID: case UBYTE_TYPEID: case BOOL_TYPEID:
					AndRegImm(EAX, *(int8_t*)&cnsvar);
					break;
				case SHORT_TYPEID: case USHORT_TYPEID: case CHAR_TYPEID:
					AndRegImm(EAX, *(int16_t*)&cnsvar);
					break;
				case INT_TYPEID: case ADDRESS_TYPEID: case UINT_TYPEID:
					AndRegImm(EAX, *(int32_t*)&cnsvar);
					break;
				case LONG_TYPEID: case ULONG_TYPEID:
					AndImm64(cnsvar);
					break;
				default:
					return false;
				}
				break;
			case XOR_TOKEN:
			case XORDAINYUU_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID: case UBYTE_TYPEID: case BOOL_TYPEID:
					XorRegImm(EAX, *(int8_t*)&cnsvar);
					break;
				case SHORT_TYPEID: case USHORT_TYPEID: case CHAR_TYPEID:
					XorRegImm(EAX, *(int16_t*)&cnsvar);
					break;
				case INT_TYPEID: case ADDRESS_TYPEID: case UINT_TYPEID:
					XorRegImm(EAX, *(int32_t*)&cnsvar);
					break;
				case LONG_TYPEID: case ULONG_TYPEID:
					XorImm64(cnsvar);
					break;
				default:
					return false;
				}
				break;
			case OR_TOKEN:
			case ORDAINYUU_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID: case UBYTE_TYPEID: case BOOL_TYPEID:
					OrRegImm(EAX, *(int8_t*)&cnsvar);
					break;
				case SHORT_TYPEID: case USHORT_TYPEID: case CHAR_TYPEID:
					OrRegImm(EAX, *(int16_t*)&cnsvar);
					break;
				case INT_TYPEID: case ADDRESS_TYPEID: case UINT_TYPEID:
					OrRegImm(EAX, *(int32_t*)&cnsvar);
					break;
				case LONG_TYPEID: case ULONG_TYPEID:
					OrImm64(cnsvar);
					break;
				default:
					return false;
				}
				break;
			default:
				return false;
			}
			return true;
		}
		bool HensuuEnzan(const SrcTree &stree, PWCArray<int32_t> &tystack, KuwashiiType &ktype, const AddressType at, const intptr_t ofs, const TokenKind tk)
		{
			switch(tk){
			case KAKERU_TOKEN:
			case KAKERUDAINYUU_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID: case UBYTE_TYPEID:
					if(!MovRegHns8(CL, at, ofs)) return false;
					MulReg(ECX);
					break;
				case SHORT_TYPEID: case USHORT_TYPEID: case CHAR_TYPEID:
					if(!MovRegHns(ECX, at, ofs, true)) return false;
					MulReg(ECX);
					break;
				case INT_TYPEID: case ADDRESS_TYPEID: case UINT_TYPEID:
					if(!MovRegHns(ECX, at, ofs, false)) return false;
					MulReg(ECX);
					break;
				case LONG_TYPEID: case ULONG_TYPEID:
					if(at == AT_SANSHOU) PushReg(ESI);
					if(!KTPush(ktype)) return false;
					if(!MovRegHns64(EAX, EDX, at, ofs)) return false;
					MulStk64();
					if(at == AT_SANSHOU) PopReg(ESI);
					break;
				case FLOAT_TYPEID:
					if(!FmulAdr(at, ofs, false)) return false;
					break;
				case DOUBLE_TYPEID:
					if(!FmulAdr(at, ofs, true)) return false;
					break;
				default:
					return false;
				}
				break;
			case WARU_TOKEN:
			case WARUDAINYUU_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID:
					if(!MovRegHns8(CL, at, ofs)) return false;
					IDivReg8(CL);
					break;
				case UBYTE_TYPEID:
					if(!MovRegHns8(CL, at, ofs)) return false;
					DivReg8(CL);
					break;
				case SHORT_TYPEID:
					if(!MovRegHns(ECX, at, ofs, true)) return false;
					IDivReg(ECX, true);
					break;
				case USHORT_TYPEID: case CHAR_TYPEID:
					if(!MovRegHns(ECX, at, ofs, true)) return false;
					DivReg(ECX, true);
					break;
				case INT_TYPEID: case ADDRESS_TYPEID:
					if(!MovRegHns(ECX, at, ofs, false)) return false;
					IDivReg(ECX, false);
					break;
				case UINT_TYPEID:
					if(!MovRegHns(ECX, at, ofs, false)) return false;
					DivReg(ECX, false);
					break;
				case LONG_TYPEID:
					if(!KTPush(ktype)) return false;
					if(!MovRegHns64(EAX, EDX, at, ofs)) return false;
					IDivStk64();
					break;
				case ULONG_TYPEID:
					if(!KTPush(ktype)) return false;
					if(!MovRegHns64(EAX, EDX, at, ofs)) return false;
					DivStk64();
					break;
				case FLOAT_TYPEID:
					if(!FdivAdr(at, ofs, false)) return false;
					break;
				case DOUBLE_TYPEID:
					if(!FdivAdr(at, ofs, true)) return false;
					break;
				default:
					return false;
				}
				break;
			case AMARI_TOKEN:
			case AMARIDAINYUU_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID:
					if(!MovRegHns8(CL, at, ofs)) return false;
					IRemReg8(CL);
					break;
				case UBYTE_TYPEID:
					if(!MovRegHns8(CL, at, ofs)) return false;
					RemReg8(CL);
					break;
				case SHORT_TYPEID:
					if(!MovRegHns(ECX, at, ofs, true)) return false;
					IRemReg(ECX, true);
					break;
				case USHORT_TYPEID: case CHAR_TYPEID:
					if(!MovRegHns(ECX, at, ofs, true)) return false;
					RemReg(ECX, true);
					break;
				case INT_TYPEID: case ADDRESS_TYPEID:
					if(!MovRegHns(ECX, at, ofs, false)) return false;
					IRemReg(ECX, false);
					break;
				case UINT_TYPEID:
					if(!MovRegHns(ECX, at, ofs, false)) return false;
					RemReg(ECX, false);
					break;
				case LONG_TYPEID:
					if(!KTPush(ktype)) return false;
					if(!MovRegHns64(EAX, EDX, at, ofs)) return false;
					IRemStk64();
					break;
				case ULONG_TYPEID:
					if(!KTPush(ktype)) return false;
					if(!MovRegHns64(EAX, EDX, at, ofs)) return false;
					RemStk64();
					break;
				default:
					return false;
				}
				break;
			case PULUS_TOKEN:
			case PULUSDAINYUU_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID: case UBYTE_TYPEID:
					if(!MovRegHns8(CL, at, ofs)) return false;
					AddRegReg(EAX, ECX);
					break;
				case SHORT_TYPEID: case USHORT_TYPEID: case CHAR_TYPEID:
					if(!MovRegHns(ECX, at, ofs, true)) return false;
					AddRegReg(EAX, ECX);
					break;
				case INT_TYPEID: case ADDRESS_TYPEID: case UINT_TYPEID:
					if(!MovRegHns(ECX, at, ofs, false)) return false;
					AddRegReg(EAX, ECX);
					break;
				case LONG_TYPEID: case ULONG_TYPEID:
					if(!MovRegHns64(ECX, EBX, at, ofs)) return false;
					Add64();
					break;
				case FLOAT_TYPEID:
					if(!FaddAdr(at, ofs, false)) return false;
					break;
				case DOUBLE_TYPEID:
					if(!FaddAdr(at, ofs, true)) return false;
					break;
				default:
					return false;
				}
				break;
			case MINUS_TOKEN:
			case MINUSDAINYUU_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID: case UBYTE_TYPEID:
					if(!MovRegHns8(CL, at, ofs)) return false;
					SubRegReg(EAX, ECX);
					break;
				case SHORT_TYPEID: case USHORT_TYPEID: case CHAR_TYPEID:
					if(!MovRegHns(ECX, at, ofs, true)) return false;
					SubRegReg(EAX, ECX);
					break;
				case INT_TYPEID: case ADDRESS_TYPEID: case UINT_TYPEID:
					if(!MovRegHns(ECX, at, ofs, false)) return false;
					SubRegReg(EAX, ECX);
					break;
				case LONG_TYPEID: case ULONG_TYPEID:
					if(!MovRegHns64(ECX, EBX, at, ofs)) return false;
					Sub64();
					break;
				case FLOAT_TYPEID:
					if(!FsubAdr(at, ofs, false)) return false;
					break;
				case DOUBLE_TYPEID:
					if(!FsubAdr(at, ofs, true)) return false;
					break;
				default:
					return false;
				}
				break;
			case LSHIFT_TOKEN:
			case LSHIFTDAINYUU_TOKEN:
				if(!MovRegHns8(CL, at, ofs)) return false;
				switch(ktype.id){
				case BYTE_TYPEID: case UBYTE_TYPEID: case SHORT_TYPEID: case USHORT_TYPEID: case CHAR_TYPEID:
				case INT_TYPEID: case ADDRESS_TYPEID: case UINT_TYPEID:
					ShlRegCl(EAX);
					break;
				case LONG_TYPEID: case ULONG_TYPEID:
					if(at == AT_SANSHOU) PushReg(ESI);
					ShlCl64();
					if(at == AT_SANSHOU) PopReg(ESI);
					break;
				default:
					return false;
				}
				break;
			case RSHIFT_TOKEN:
			case RSHIFTDAINYUU_TOKEN:
				if(!MovRegHns8(CL, at, ofs)) return false;
				switch(ktype.id){
				case BYTE_TYPEID:
					SarRegCl8(AL);
					break;
				case SHORT_TYPEID:
					SarRegCl(EAX, true);
					break;
				case INT_TYPEID: case ADDRESS_TYPEID:
					SarRegCl(EAX, false);
					break;
				case UBYTE_TYPEID:
					ShrRegCl8(AL);
					break;
				case USHORT_TYPEID:case CHAR_TYPEID:
					ShrRegCl(EAX, true);
					break;
				case UINT_TYPEID:
					ShrRegCl(EAX, false);
					break;
				case LONG_TYPEID:
					if(at == AT_SANSHOU) PushReg(ESI);
					SarCl64();
					if(at == AT_SANSHOU) PopReg(ESI);
					break;
				case ULONG_TYPEID:
					if(at == AT_SANSHOU) PushReg(ESI);
					ShrCl64();
					if(at == AT_SANSHOU) PopReg(ESI);
					break;
				default:
					return false;
				}
				break;
			case SHOU_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID:
					if(!MovRegHns8(CL, at, ofs)) return false;
					CmpRegReg8(AL, CL); ILess();
					break;
				case UBYTE_TYPEID:
					if(!MovRegHns8(CL, at, ofs)) return false;
					CmpRegReg8(AL, CL); Less();
					break;
				case SHORT_TYPEID:
					if(!MovRegHns(ECX, at, ofs, true)) return false;
					CmpRegReg(EAX, ECX, true); ILess();
					break;
				case USHORT_TYPEID: case CHAR_TYPEID:
					if(!MovRegHns(ECX, at, ofs, true)) return false;
					CmpRegReg(EAX, ECX, true); Less();
					break;
				default:
					if(ktype.id < 0 || ENDCLASS_TYPEID < ktype.id || stree.stat->funclist.Get(ktype.id)->selftype != ENUM_BLOCK) return false;
				case INT_TYPEID: case ADDRESS_TYPEID:
					if(!MovRegHns(ECX, at, ofs, false)) return false;
					CmpRegReg(EAX, ECX, false); ILess();
					break;
				case UINT_TYPEID:
					if(!MovRegHns(ECX, at, ofs, false)) return false;
					CmpRegReg(EAX, ECX, false); Less();
					break;
				case LONG_TYPEID:
					if(!KTPush(ktype)) return false;
					if(!MovRegHns64(EAX, EDX, at, ofs)) return false;
					ILessStk64();
					break;
				case ULONG_TYPEID:
					if(!KTPush(ktype)) return false;
					if(!MovRegHns64(EAX, EDX, at, ofs)) return false;
					LessStk64();
					break;
				case FLOAT_TYPEID:
					if(!FldAdr(at, ofs, false)) return false;
					Fcomi(); Ijou();
					break;
				case DOUBLE_TYPEID:
					if(!FldAdr(at, ofs, true)) return false;
					Fcomi(); Ijou();
					break;
				}
				tystack.Tail() = ktype.id = BOOL_TYPEID;
				break;
			case SHOUOREQUAL_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID:
					if(!MovRegHns8(CL, at, ofs)) return false;
					CmpRegReg8(AL, CL); IIka();
					break;
				case UBYTE_TYPEID:
					if(!MovRegHns8(CL, at, ofs)) return false;
					CmpRegReg8(AL, CL); Ika();
					break;
				case SHORT_TYPEID:
					if(!MovRegHns(ECX, at, ofs, true)) return false;
					CmpRegReg(EAX, ECX, true); IIka();
					break;
				case USHORT_TYPEID: case CHAR_TYPEID:
					if(!MovRegHns(ECX, at, ofs, true)) return false;
					CmpRegReg(EAX, ECX, true); Ika();
					break;
				default:
					if(ktype.id < 0 || ENDCLASS_TYPEID < ktype.id || stree.stat->funclist.Get(ktype.id)->selftype != ENUM_BLOCK) return false;
				case INT_TYPEID: case ADDRESS_TYPEID:
					if(!MovRegHns(ECX, at, ofs, false)) return false;
					CmpRegReg(EAX, ECX, false); IIka();
					break;
				case UINT_TYPEID:
					if(!MovRegHns(ECX, at, ofs, false)) return false;
					CmpRegReg(EAX, ECX, false); Ika();
					break;
				case LONG_TYPEID:
					if(!KTPush(ktype)) return false;
					if(!MovRegHns64(EAX, EDX, at, ofs)) return false;
					IIkaStk64();
					break;
				case ULONG_TYPEID:
					if(!KTPush(ktype)) return false;
					if(!MovRegHns64(EAX, EDX, at, ofs)) return false;
					IkaStk64();
					break;
				case FLOAT_TYPEID:
					if(!FldAdr(at, ofs, false)) return false;
					Fcomi(); Over();
					break;
				case DOUBLE_TYPEID:
					if(!FldAdr(at, ofs, true)) return false;
					Fcomi(); Over();
					break;
				}
				tystack.Tail() = ktype.id = BOOL_TYPEID;
				break;
			case DAI_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID:
					if(!MovRegHns8(CL, at, ofs)) return false;
					CmpRegReg8(AL, CL); IOver();
					break;
				case UBYTE_TYPEID:
					if(!MovRegHns8(CL, at, ofs)) return false;
					CmpRegReg8(AL, CL); Over();
					break;
				case SHORT_TYPEID:
					if(!MovRegHns(ECX, at, ofs, true)) return false;
					CmpRegReg(EAX, ECX, true); IOver();
					break;
				case USHORT_TYPEID: case CHAR_TYPEID:
					if(!MovRegHns(ECX, at, ofs, true)) return false;
					CmpRegReg(EAX, ECX, true); Over();
					break;
				default:
					if(ktype.id < 0 || ENDCLASS_TYPEID < ktype.id || stree.stat->funclist.Get(ktype.id)->selftype != ENUM_BLOCK) return false;
				case INT_TYPEID: case ADDRESS_TYPEID:
					if(!MovRegHns(ECX, at, ofs, false)) return false;
					CmpRegReg(EAX, ECX, false); IOver();
					break;
				case UINT_TYPEID:
					if(!MovRegHns(ECX, at, ofs, false)) return false;
					CmpRegReg(EAX, ECX, false); Over();
					break;
				case LONG_TYPEID:
					if(!KTPush(ktype)) return false;
					if(!MovRegHns64(EAX, EDX, at, ofs)) return false;
					IOverStk64();
					break;
				case ULONG_TYPEID:
					if(!KTPush(ktype)) return false;
					if(!MovRegHns64(EAX, EDX, at, ofs)) return false;
					OverStk64();
					break;
				case FLOAT_TYPEID:
					if(!FldAdr(at, ofs, false)) return false;
					Fcomi(); Ika();
					break;
				case DOUBLE_TYPEID:
					if(!FldAdr(at, ofs, true)) return false;
					Fcomi(); Ika();
					break;
				}
				tystack.Tail() = ktype.id = BOOL_TYPEID;
				break;
			case DAIOREQUAL_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID:
					if(!MovRegHns8(CL, at, ofs)) return false;
					CmpRegReg8(AL, CL); IIjou();
					break;
				case UBYTE_TYPEID:
					if(!MovRegHns8(CL, at, ofs)) return false;
					CmpRegReg8(AL, CL); Ijou();
					break;
				case SHORT_TYPEID:
					if(!MovRegHns(ECX, at, ofs, true)) return false;
					CmpRegReg(EAX, ECX, true); IIjou();
					break;
				case USHORT_TYPEID: case CHAR_TYPEID:
					if(!MovRegHns(ECX, at, ofs, true)) return false;
					CmpRegReg(EAX, ECX, true); Ijou();
					break;
				default:
					if(ktype.id < 0 || ENDCLASS_TYPEID < ktype.id || stree.stat->funclist.Get(ktype.id)->selftype != ENUM_BLOCK) return false;
				case INT_TYPEID: case ADDRESS_TYPEID:
					if(!MovRegHns(ECX, at, ofs, false)) return false;
					CmpRegReg(EAX, ECX, false); IIjou();
					break;
				case UINT_TYPEID:
					if(!MovRegHns(ECX, at, ofs, false)) return false;
					CmpRegReg(EAX, ECX, false); Ijou();
					break;
				case LONG_TYPEID:
					if(!KTPush(ktype)) return false;
					if(!MovRegHns64(EAX, EDX, at, ofs)) return false;
					IIjouStk64();
					break;
				case ULONG_TYPEID:
					if(!KTPush(ktype)) return false;
					if(!MovRegHns64(EAX, EDX, at, ofs)) return false;
					IjouStk64();
					break;
				case FLOAT_TYPEID:
					if(!FldAdr(at, ofs, false)) return false;
					Fcomi(); Less();
					break;
				case DOUBLE_TYPEID:
					if(!FldAdr(at, ofs, true)) return false;
					Fcomi(); Less();
					break;
				}
				tystack.Tail() = ktype.id = BOOL_TYPEID;
				break;
			case EQUAL_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID: case UBYTE_TYPEID: case BOOL_TYPEID:
					if(!MovRegHns8(CL, at, ofs)) return false;
					CmpRegReg8(AL, CL); Equal();
					break;
				case SHORT_TYPEID: case USHORT_TYPEID: case CHAR_TYPEID:
					if(!MovRegHns(ECX, at, ofs, true)) return false;
					CmpRegReg(EAX, ECX, true); Equal();
					break;
				default:
					if(ktype.id < 0 || ENDCLASS_TYPEID < ktype.id || stree.stat->funclist.Get(ktype.id)->selftype != ENUM_BLOCK) return false;
				case INT_TYPEID: case ADDRESS_TYPEID: case UINT_TYPEID: case FUNC_TYPEID: case METHOD_TYPEID:
					if(!MovRegHns(ECX, at, ofs, false)) return false;
					CmpRegReg(EAX, ECX, false); Equal();
					break;
				case LONG_TYPEID: case ULONG_TYPEID:
					if(!KTPush(ktype)) return false;
					if(!MovRegHns64(EAX, EDX, at, ofs)) return false;
					EqualStk64();
					break;
				case FLOAT_TYPEID:
					if(!FldAdr(at, ofs, false)) return false;
					Fcomi(); Equal();
					break;
				case DOUBLE_TYPEID:
					if(!FldAdr(at, ofs, true)) return false;
					Fcomi(); Equal();
					break;
				case REF_TYPEID:
				case LIST_TYPEID:
					PluginCall(RefPosNullable);
					MovRegReg(ECX, EAX);
					PushHnsRef(at, ofs, false);
					PluginCall(RefPosNullable);
					CmpRegReg(EAX, ECX, false); Equal();
					break;
				case DYNREF_TYPEID:
				case DYNLIST_TYPEID:
					PluginCall(RefPosNullable);
					AddRegImm(ESP, 4);
					MovRegReg(ECX, EAX);
					PushHnsRef(at, ofs, false);
					PluginCall(RefPosNullable);
					CmpRegReg(EAX, ECX, false); Equal();
					break;
				}
				tystack.Tail() = ktype.id = BOOL_TYPEID;
				break;
			case NOTEQUAL_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID: case UBYTE_TYPEID: case BOOL_TYPEID:
					if(!MovRegHns8(CL, at, ofs)) return false;
					CmpRegReg8(AL, CL); NEqual();
					break;
				case SHORT_TYPEID: case USHORT_TYPEID: case CHAR_TYPEID:
					if(!MovRegHns(ECX, at, ofs, true)) return false;
					CmpRegReg(EAX, ECX, true); NEqual();
					break;
				default:
					if(ktype.id < 0 || ENDCLASS_TYPEID < ktype.id || stree.stat->funclist.Get(ktype.id)->selftype != ENUM_BLOCK) return false;
				case INT_TYPEID: case ADDRESS_TYPEID: case UINT_TYPEID: case FUNC_TYPEID: case METHOD_TYPEID:
					if(!MovRegHns(ECX, at, ofs, false)) return false;
					CmpRegReg(EAX, ECX, false); NEqual();
					break;
				case LONG_TYPEID: case ULONG_TYPEID:
					if(!KTPush(ktype)) return false;
					if(!MovRegHns64(EAX, EDX, at, ofs)) return false;
					NEqualStk64();
					break;
				case FLOAT_TYPEID:
					if(!FldAdr(at, ofs, false)) return false;
					Fcomi(); NEqual();
					break;
				case DOUBLE_TYPEID:
					if(!FldAdr(at, ofs, true)) return false;
					Fcomi(); NEqual();
					break;
				case REF_TYPEID:
				case LIST_TYPEID:
					PluginCall(RefPosNullable);
					MovRegReg(ECX, EAX);
					PushHnsRef(at, ofs, false);
					PluginCall(RefPosNullable);
					CmpRegReg(EAX, ECX, false); NEqual();
					break;
				case DYNREF_TYPEID:
				case DYNLIST_TYPEID:
					PluginCall(RefPosNullable);
					AddRegImm(ESP, 4);
					MovRegReg(ECX, EAX);
					PushHnsRef(at, ofs, false);
					PluginCall(RefPosNullable);
					CmpRegReg(EAX, ECX, false); NEqual();
					break;
				}
				tystack.Tail() = ktype.id = BOOL_TYPEID;
				break;
			case AND_TOKEN:
			case ANDDAINYUU_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID: case UBYTE_TYPEID: case BOOL_TYPEID:
					if(!MovRegHns8(CL, at, ofs)) return false;
					AndRegReg(EAX, ECX);
					break;
				case SHORT_TYPEID: case USHORT_TYPEID: case CHAR_TYPEID:
					if(!MovRegHns(ECX, at, ofs, true)) return false;
					AndRegReg(EAX, ECX);
					break;
				case INT_TYPEID: case ADDRESS_TYPEID: case UINT_TYPEID:
					if(!MovRegHns(ECX, at, ofs, false)) return false;
					AndRegReg(EAX, ECX);
					break;
				case LONG_TYPEID: case ULONG_TYPEID:
					if(!MovRegHns64(ECX, EBX, at, ofs)) return false;
					And64();
					break;
				default:
					return false;
				}
				break;
			case XOR_TOKEN:
			case XORDAINYUU_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID: case UBYTE_TYPEID: case BOOL_TYPEID:
					if(!MovRegHns8(CL, at, ofs)) return false;
					XorRegReg(EAX, ECX);
					break;
				case SHORT_TYPEID: case USHORT_TYPEID: case CHAR_TYPEID:
					if(!MovRegHns(ECX, at, ofs, true)) return false;
					XorRegReg(EAX, ECX);
					break;
				case INT_TYPEID: case ADDRESS_TYPEID: case UINT_TYPEID:
					if(!MovRegHns(ECX, at, ofs, false)) return false;
					XorRegReg(EAX, ECX);
					break;
				case LONG_TYPEID: case ULONG_TYPEID:
					if(!MovRegHns64(ECX, EBX, at, ofs)) return false;
					Xor64();
					break;
				default:
					return false;
				}
				break;
			case OR_TOKEN:
			case ORDAINYUU_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID: case UBYTE_TYPEID: case BOOL_TYPEID:
					if(!MovRegHns8(CL, at, ofs)) return false;
					OrRegReg(EAX, ECX);
					break;
				case SHORT_TYPEID: case USHORT_TYPEID: case CHAR_TYPEID:
					if(!MovRegHns(ECX, at, ofs, true)) return false;
					OrRegReg(EAX, ECX);
					break;
				case INT_TYPEID: case ADDRESS_TYPEID: case UINT_TYPEID:
					if(!MovRegHns(ECX, at, ofs, false)) return false;
					OrRegReg(EAX, ECX);
					break;
				case LONG_TYPEID: case ULONG_TYPEID:
					if(!MovRegHns64(ECX, EBX, at, ofs)) return false;
					Or64();
					break;
				default:
					return false;
				}
				break;
			default:
				return false;
			}
			return true;
		}
		bool StackEnzan(const SrcTree &stree, PWCArray<int32_t> &tystack, KuwashiiType &ktype, const TokenKind tk)
		{
			ktype.id = tystack.GetConst()[tystack.GetLength()-2];
			if(!JidouCast(stree, tystack, ktype.id, tystack.Pop())) return false;
			switch(tk){
			case KAKERU_TOKEN:
			case KAKERUDAINYUU_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID: case UBYTE_TYPEID: case SHORT_TYPEID: case USHORT_TYPEID: case CHAR_TYPEID:
				case INT_TYPEID: case ADDRESS_TYPEID: case UINT_TYPEID:
					MulStk();
					break;
				case LONG_TYPEID: case ULONG_TYPEID:
					MulStk64();
					break;
				case FLOAT_TYPEID:
					FmulStk(false);
					break;
				case DOUBLE_TYPEID:
					FmulStk(true);
					break;
				default:
					return false;
				}
				break;
			case WARU_TOKEN:
			case WARUDAINYUU_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID:
					IDivStk8();
					break;
				case UBYTE_TYPEID:
					DivStk8();
					break;
				case SHORT_TYPEID:
					IDivStk(true);
					break;
				case USHORT_TYPEID: case CHAR_TYPEID:
					DivStk(true);
					break;
				case INT_TYPEID: case ADDRESS_TYPEID:
					IDivStk(false);
					break;
				case UINT_TYPEID:
					DivStk(false);
					break;
				case LONG_TYPEID:
					IDivStk64();
					break;
				case ULONG_TYPEID:
					DivStk64();
					break;
				case FLOAT_TYPEID:
					FdivStkSwap(false);
					break;
				case DOUBLE_TYPEID:
					FdivStkSwap(true);
					break;
				default:
					return false;
				}
				break;
			case AMARI_TOKEN:
			case AMARIDAINYUU_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID:
					IRemStk8();
					break;
				case UBYTE_TYPEID:
					RemStk8();
					break;
				case SHORT_TYPEID:
					IRemStk(true);
					break;
				case USHORT_TYPEID: case CHAR_TYPEID:
					RemStk(true);
					break;
				case INT_TYPEID: case ADDRESS_TYPEID:
					IRemStk(false);
					break;
				case UINT_TYPEID:
					RemStk(false);
					break;
				case LONG_TYPEID:
					IRemStk64();
					break;
				case ULONG_TYPEID:
					RemStk64();
					break;
				default:
					return false;
				}
				break;
			case PULUS_TOKEN:
			case PULUSDAINYUU_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID: case UBYTE_TYPEID: case SHORT_TYPEID: case USHORT_TYPEID: case CHAR_TYPEID:
				case INT_TYPEID: case ADDRESS_TYPEID: case UINT_TYPEID:
					AddStk();
					break;
				case LONG_TYPEID: case ULONG_TYPEID:
					AddStk64();
					break;
				case FLOAT_TYPEID:
					FaddStk(false);
					break;
				case DOUBLE_TYPEID:
					FaddStk(true);
					break;
				default:
					return false;
				}
				break;
			case MINUS_TOKEN:
			case MINUSDAINYUU_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID: case UBYTE_TYPEID: case SHORT_TYPEID: case USHORT_TYPEID: case CHAR_TYPEID:
				case INT_TYPEID: case ADDRESS_TYPEID: case UINT_TYPEID:
					SubStk();
					break;
				case LONG_TYPEID: case ULONG_TYPEID:
					SubStk64();
					break;
				case FLOAT_TYPEID:
					Fchs();
					FaddStk(false);
					break;
				case DOUBLE_TYPEID:
					Fchs();
					FaddStk(true);
					break;
				default:
					return false;
				}
				break;
			case LSHIFT_TOKEN:
			case LSHIFTDAINYUU_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID: case UBYTE_TYPEID: case SHORT_TYPEID: case USHORT_TYPEID: case CHAR_TYPEID:
				case INT_TYPEID: case ADDRESS_TYPEID: case UINT_TYPEID:
					ShlStk();
					break;
				case LONG_TYPEID: case ULONG_TYPEID:
					ShlStk64();
					break;
				default:
					return false;
				}
				break;
			case RSHIFT_TOKEN:
			case RSHIFTDAINYUU_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID:
					SarStk8();
					break;
				case SHORT_TYPEID:
					SarStk(true);
					break;
				case INT_TYPEID: case ADDRESS_TYPEID:
					SarStk(false);
					break;
				case UBYTE_TYPEID:
					ShrStk8();
					break;
				case USHORT_TYPEID: case CHAR_TYPEID:
					ShrStk(true);
					break;
				case UINT_TYPEID:
					ShrStk(false);
					break;
				case LONG_TYPEID:
					SarStk64();
					break;
				case ULONG_TYPEID:
					ShrStk64();
					break;
				default:
					return false;
				}
				break;
			case SHOU_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID:
					CmpStk8(); ILess();
					break;
				case UBYTE_TYPEID:
					CmpStk8(); Less();
					break;
				case SHORT_TYPEID:
					CmpStk(true); ILess();
					break;
				case USHORT_TYPEID: case CHAR_TYPEID:
					CmpStk(true); Less();
					break;
				default:
					if(ktype.id < 0 || ENDCLASS_TYPEID < ktype.id || stree.stat->funclist.Get(ktype.id)->selftype != ENUM_BLOCK) return false;
				case INT_TYPEID: case ADDRESS_TYPEID:
					CmpStk(false); ILess();
					break;
				case UINT_TYPEID:
					CmpStk(false); Less();
					break;
				case LONG_TYPEID:
					ILessStk64();
					break;
				case ULONG_TYPEID:
					LessStk64();
					break;
				case FLOAT_TYPEID:
					FldStk(false);
					Fcomi(); Less();
					break;
				case DOUBLE_TYPEID:
					FldStk(true);
					Fcomi(); Less();
					break;
				}
				tystack.Tail() = ktype.id = BOOL_TYPEID;
				break;
			case SHOUOREQUAL_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID:
					CmpStk8(); IIka();
					break;
				case UBYTE_TYPEID:
					CmpStk8(); Ika();
					break;
				case SHORT_TYPEID:
					CmpStk(true); IIka();
					break;
				case USHORT_TYPEID: case CHAR_TYPEID:
					CmpStk(true); Ika();
					break;
				default:
					if(ktype.id < 0 || ENDCLASS_TYPEID < ktype.id || stree.stat->funclist.Get(ktype.id)->selftype != ENUM_BLOCK) return false;
				case INT_TYPEID: case ADDRESS_TYPEID:
					CmpStk(false); IIka();
					break;
				case UINT_TYPEID:
					CmpStk(false); Ika();
					break;
				case LONG_TYPEID:
					IIkaStk64();
					break;
				case ULONG_TYPEID:
					IkaStk64();
					break;
				case FLOAT_TYPEID:
					FldStk(false);
					Fcomi(); Ika();
					break;
				case DOUBLE_TYPEID:
					FldStk(true);
					Fcomi(); Ika();
					break;
				}
				tystack.Tail() = ktype.id = BOOL_TYPEID;
				break;
			case DAI_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID:
					CmpStk8(); IOver();
					break;
				case UBYTE_TYPEID:
					CmpStk8(); Over();
					break;
				case SHORT_TYPEID:
					CmpStk(true); IOver();
					break;
				case USHORT_TYPEID: case CHAR_TYPEID:
					CmpStk(true); Over();
					break;
				default:
					if(ktype.id < 0 || ENDCLASS_TYPEID < ktype.id || stree.stat->funclist.Get(ktype.id)->selftype != ENUM_BLOCK) return false;
				case INT_TYPEID: case ADDRESS_TYPEID:
					CmpStk(false); IOver();
					break;
				case UINT_TYPEID:
					CmpStk(false); Over();
					break;
				case LONG_TYPEID:
					IOverStk64();
					break;
				case ULONG_TYPEID:
					OverStk64();
					break;
				case FLOAT_TYPEID:
					FldStk(false);
					Fcomi(); Over();
					break;
				case DOUBLE_TYPEID:
					FldStk(true);
					Fcomi(); Over();
					break;
				}
				tystack.Tail() = ktype.id = BOOL_TYPEID;
				break;
			case DAIOREQUAL_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID:
					CmpStk8(); IIjou();
					break;
				case UBYTE_TYPEID:
					CmpStk8(); Ijou();
					break;
				case SHORT_TYPEID:
					CmpStk(true); IIjou();
					break;
				case USHORT_TYPEID: case CHAR_TYPEID:
					CmpStk(true); Ijou();
					break;
				default:
					if(ktype.id < 0 || ENDCLASS_TYPEID < ktype.id || stree.stat->funclist.Get(ktype.id)->selftype != ENUM_BLOCK) return false;
				case INT_TYPEID: case ADDRESS_TYPEID:
					CmpStk(false); IIjou();
					break;
				case UINT_TYPEID:
					CmpStk(false); Ijou();
					break;
				case LONG_TYPEID:
					IIjouStk64();
					break;
				case ULONG_TYPEID:
					IjouStk64();
					break;
				case FLOAT_TYPEID:
					FldStk(false);
					Fcomi(); Ijou();
					break;
				case DOUBLE_TYPEID:
					FldStk(true);
					Fcomi(); Ijou();
					break;
				}
				tystack.Tail() = ktype.id = BOOL_TYPEID;
				break;
			case EQUAL_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID: case UBYTE_TYPEID: case BOOL_TYPEID:
					CmpStk8(); Equal();
					break;
				case SHORT_TYPEID: case USHORT_TYPEID: case CHAR_TYPEID:
					CmpStk(true); Equal();
					break;
				default:
					if(ktype.id < 0 || ENDCLASS_TYPEID < ktype.id || stree.stat->funclist.Get(ktype.id)->selftype != ENUM_BLOCK) return false;
				case INT_TYPEID: case ADDRESS_TYPEID: case UINT_TYPEID: case FUNC_TYPEID: case METHOD_TYPEID:
					CmpStk(false); Equal();
					break;
				case LONG_TYPEID: case ULONG_TYPEID:
					EqualStk64();
					break;
				case FLOAT_TYPEID:
					FldStk(false);
					Fcomi(); Equal();
					break;
				case DOUBLE_TYPEID:
					FldStk(true);
					Fcomi(); Equal();
					break;
				case REF_TYPEID:
				case LIST_TYPEID:
					PluginCall(RefPosNullable);
					MovRegReg(ECX, EAX);
					PluginCall(RefPosNullable);
					CmpRegReg(EAX, ECX, false); Equal();
					break;
				case DYNREF_TYPEID:
				case DYNLIST_TYPEID:
					PluginCall(RefPosNullable);
					AddRegImm(ESP, 4);
					MovRegReg(ECX, EAX);
					PluginCall(RefPosNullable);
					AddRegImm(ESP, 4);
					CmpRegReg(EAX, ECX, false); Equal();
					break;
				}
				tystack.Tail() = ktype.id = BOOL_TYPEID;
				break;
			case NOTEQUAL_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID: case UBYTE_TYPEID: case BOOL_TYPEID:
					CmpStk8(); NEqual();
					break;
				case SHORT_TYPEID: case USHORT_TYPEID: case CHAR_TYPEID:
					CmpStk(true); NEqual();
					break;
				default:
					if(ktype.id < 0 || ENDCLASS_TYPEID < ktype.id || stree.stat->funclist.Get(ktype.id)->selftype != ENUM_BLOCK) return false;
				case INT_TYPEID: case ADDRESS_TYPEID: case UINT_TYPEID: case FUNC_TYPEID: case METHOD_TYPEID:
					CmpStk(false); NEqual();
					break;
				case LONG_TYPEID: case ULONG_TYPEID:
					NEqualStk64();
					break;
				case FLOAT_TYPEID:
					FldStk(false);
					Fcomi(); NEqual();
					break;
				case DOUBLE_TYPEID:
					FldStk(true);
					Fcomi(); NEqual();
					break;
				case REF_TYPEID:
				case LIST_TYPEID:
					PluginCall(RefPosNullable);
					MovRegReg(ECX, EAX);
					PluginCall(RefPosNullable);
					CmpRegReg(EAX, ECX, false); NEqual();
					break;
				case DYNREF_TYPEID:
				case DYNLIST_TYPEID:
					PluginCall(RefPosNullable);
					AddRegImm(ESP, 4);
					MovRegReg(ECX, EAX);
					PluginCall(RefPosNullable);
					AddRegImm(ESP, 4);
					CmpRegReg(EAX, ECX, false); NEqual();
					break;
				}
				tystack.Tail() = ktype.id = BOOL_TYPEID;
				break;
			case AND_TOKEN:
			case ANDDAINYUU_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID: case UBYTE_TYPEID: case SHORT_TYPEID: case USHORT_TYPEID: case CHAR_TYPEID:
				case INT_TYPEID: case ADDRESS_TYPEID: case UINT_TYPEID: case BOOL_TYPEID:
					AndStk();
					break;
				case LONG_TYPEID: case ULONG_TYPEID:
					AndStk64();
					break;
				default:
					return false;
				}
				break;
			case XOR_TOKEN:
			case XORDAINYUU_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID: case UBYTE_TYPEID: case SHORT_TYPEID: case USHORT_TYPEID: case CHAR_TYPEID:
				case INT_TYPEID: case ADDRESS_TYPEID: case UINT_TYPEID: case BOOL_TYPEID:
					XorStk();
					break;
				case LONG_TYPEID: case ULONG_TYPEID:
					XorStk64();
					break;
				default:
					return false;
				}
				break;
			case OR_TOKEN:
			case ORDAINYUU_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID: case UBYTE_TYPEID: case SHORT_TYPEID: case USHORT_TYPEID: case CHAR_TYPEID:
				case INT_TYPEID: case ADDRESS_TYPEID: case UINT_TYPEID: case BOOL_TYPEID:
					OrStk();
					break;
				case LONG_TYPEID: case ULONG_TYPEID:
					OrStk64();
					break;
				default:
					return false;
				}
				break;
			default:
				return false;
			}
			return true;
		}
		bool AAOO(SrcTree &stree, const intptr_t *const iap, intptr_t &i, PWCArray<int32_t> &tystack, KuwashiiType &ktype)
		{
			intptr_t bp;
			SrcTree *retcall = NULL;
			if(ktype.id != BOOL_TYPEID) return false;
			switch(iap[i]){
			case ANDAND_TOKEN:
				bp = FalseJump(0);
				break;
			case OROR_TOKEN:
				bp = TrueJump(0);
				break;
			default:
				return false;
			}
			tystack.Tail() = BOOL_TYPEID;
			ktype.id = VOID_TYPEID;
			for(i++; !(iap[i] == ANDAND_TOKEN || iap[i] == OROR_TOKEN); i++){
				if(!MainSwitch(stree, iap, i, tystack, ktype, retcall)) return false;
			}
			if(ktype.id != BOOL_TYPEID) return false;
			tystack.Pop();
			*(intptr_t*)(pjtr->ntvcode.GetConst()+bp) += pjtr->ntvcode.GetLength();
			return true;
		}
		bool Sankou(SrcTree &stree, const intptr_t *const iap, intptr_t &i, PWCArray<int32_t> &tystack, KuwashiiType &ktype)
		{
			intptr_t bp1, bp2;
			KuwashiiType typ;
			SrcTree *retcall = NULL;
			if(ktype.id != BOOL_TYPEID) return false;
			bp1 = FalseJump(0);
			tystack.Pop();
			ktype.id = VOID_TYPEID;
			tystack += WILDCARD_TYPEID;
			for(i++; !(iap[i] == QUESTION_TOKEN || iap[i] == COLON_TOKEN); i++){
				if(!MainSwitch(stree, iap, i, tystack, ktype, retcall)) return false;
			}
			if(iap[i] == QUESTION_TOKEN) return false;
			typ = ktype;
			bp2 = Jump(0);
			tystack.SetLength(tystack.GetLength()-2);
			*(intptr_t *)(pjtr->ntvcode.GetConst()+bp1) += pjtr->ntvcode.GetLength();
			ktype.id = VOID_TYPEID;
			tystack += typ.id;
			for(i++; !(iap[i] == QUESTION_TOKEN || iap[i] == COLON_TOKEN); i++){
				if(!MainSwitch(stree, iap, i, tystack, ktype, retcall)) return false;
			}
			if(iap[i] == COLON_TOKEN) return false;
			if(typ.id == REF_TYPEID || typ.id == LIST_TYPEID){
				if(ktype.id != REF_TYPEID && ktype.id != LIST_TYPEID) return false;
				if(!stree.YuruiKataCheck(ktype.kwsk, typ.kwsk, *pjtr->filename, pjtr->gyousuu)){
					if(!stree.YuruiKataCheck(typ.kwsk, ktype.kwsk, *pjtr->filename, pjtr->gyousuu)) return false;
					ktype = typ;
				}
			}else if(typ.id == FUNC_TYPEID || typ.id == METHOD_TYPEID){
				if(ktype.id != FUNC_TYPEID && ktype.id != METHOD_TYPEID) return false;
				if(!stree.YuruiKataCheck(ktype.kwsk, typ.kwsk, *pjtr->filename, pjtr->gyousuu)){
					if(!stree.YuruiKataCheck(typ.kwsk, ktype.kwsk, *pjtr->filename, pjtr->gyousuu)) return false;
					ktype = typ;
				}
			}else{
				if(!JidouCast(stree, tystack, typ.id, ktype.id)) return false;
				ktype = typ;
			}
			*(intptr_t *)(pjtr->ntvcode.GetConst()+bp2) += pjtr->ntvcode.GetLength();
			tystack.Pop();
			return true;
		}
		bool DainyuuTeisuu(const SrcTree &stree, KuwashiiType &ktype, const AddressType at, const intptr_t ofs, const void *const p)
		{
			if(at == AT_SANSHOU) PopReg(ESI);
			switch(ktype.id){
			case BYTE_TYPEID:
			case UBYTE_TYPEID:
			case BOOL_TYPEID:
				if(!MovHnsImm8(at, ofs, *(int8_t*)p)) return false;
				break;
			case SHORT_TYPEID:
			case USHORT_TYPEID:
			case CHAR_TYPEID:
				if(!MovHnsImm(at, ofs, *(int16_t*)p, true)) return false;
				break;
			default:
				if(ktype.id < 0 || ENDCLASS_TYPEID < ktype.id || stree.stat->funclist.Get(ktype.id)->selftype != ENUM_BLOCK) return false;
			case INT_TYPEID:
			case ADDRESS_TYPEID:
			case UINT_TYPEID:
			case FUNC_TYPEID:
			case FLOAT_TYPEID:
				if(!MovHnsImm(at, ofs, *(int32_t*)p, false)) return false;
				break;
			case LONG_TYPEID:
			case ULONG_TYPEID:
			case DOUBLE_TYPEID:
				if(!MovHnsImm64(at, ofs, *(int64_t*)p)) return false;
				break;
			}
			return true;
		}
		bool DainyuuReg(const SrcTree &stree, KuwashiiType &ktype, const AddressType at, const intptr_t ofs)
		{
			if(at == AT_SANSHOU) PopReg(ESI);
			switch(ktype.id){
			case BYTE_TYPEID:
			case UBYTE_TYPEID:
			case BOOL_TYPEID:
				if(!MovHnsReg8(at, ofs, AL)) return false;
				break;
			case SHORT_TYPEID:
			case USHORT_TYPEID:
			case CHAR_TYPEID:
				if(!MovHnsReg(at, ofs, EAX, true)) return false;
				break;
			default:
				if(ktype.id < 0 || ENDCLASS_TYPEID < ktype.id) return false;
				if(stree.stat->funclist.Get(ktype.id)->selftype == CLASS_BLOCK){
					if(!stree.stat->funclist.Get(ktype.id)->IsOpen()){
						pjtr->root->stat->ss->ErrorMessage.Add(*pjtr->filename, pjtr->gyousuu, L"ŃRs[łȂNXłB");
						return false;
					}
					if(!MemCopy(at, ofs, stree.stat->funclist.Get(ktype.id)->GetMemberSize())) return false;
					break;
				}
				if(stree.stat->funclist.Get(ktype.id)->selftype != ENUM_BLOCK) return false;
			case INT_TYPEID:
			case ADDRESS_TYPEID:
			case UINT_TYPEID:
			case FUNC_TYPEID:
			case METHOD_TYPEID:
				if(!MovHnsReg(at, ofs, EAX, false)) return false;
				break;
			case LONG_TYPEID:
			case ULONG_TYPEID:
				if(!MovHnsReg64(at, ofs)) return false;
				break;
			case FLOAT_TYPEID:
				if(!FstAdr(at, ofs, false)) return false;
				break;
			case DOUBLE_TYPEID:
				if(!FstAdr(at, ofs, true)) return false;
				break;
			}
			return true;
		}
		bool Dainyuu(SrcTree &stree, const intptr_t *const iap, intptr_t &i, PWCArray<int32_t> &tystack, KuwashiiType &ktype, const KuwashiiType &oktype, const AddressType at, const intptr_t ofs)
		{
			int32_t did, idx;
			SrcTree *pst;
			SrcTree *retcall = NULL;
			if(
				iap[i] == DAINYUU_TOKEN ? oktype.id == VOID_TYPEID || (ENDTHREAD_TYPEID <= oktype.id && oktype.id < 0) : (
					oktype.id <= ENDCLASS_TYPEID ? true : (
						ANDDAINYUU_TOKEN <= iap[i] && iap[i] <= ORDAINYUU_TOKEN ?
						oktype.id == FLOAT_TYPEID || oktype.id == DOUBLE_TYPEID : oktype.id == BOOL_TYPEID || (
							iap[i] == LSHIFTDAINYUU_TOKEN || iap[i] == RSHIFTDAINYUU_TOKEN ?
							oktype.id == FLOAT_TYPEID || oktype.id == DOUBLE_TYPEID : false
						)
					)
				))
			{
				return false;
			}
			if(oktype.kwsk.GetLength() == 2 &&
				oktype.kwsk.GetConst()[0] == REF_TOKEN && oktype.kwsk.GetConst()[1] == OTHERKIND_TOKEN && iap[i+1] == COMMA_TOKEN){
				i++;
				return true;
			}
			if(!KTPush(ktype)) return false;
			ktype.id = VOID_TYPEID;
			if(oktype.id == DELEGATE_TYPEID){
				if(at != AT_LOCAL) return false;
			}if(iap[i] != DAINYUU_TOKEN){
				if(!LoadHensuu(stree, oktype, at, ofs)) return false;
				ktype.id = oktype.id;
				tystack += ktype.id;
			}else if(iap[i+1] == COMMA_TOKEN){
				if(!MovRegAdr(ESI, at, ofs)) return false;
				PushReg(ESI);
				tystack += UNKNOWN_TYPEID;
				ktype = oktype;
				return true;
			}
			if(at == AT_SANSHOU) PushReg(ESI);
			tystack += oktype.id;
			ktype.pstre = NULL;
			for(i++; !(DAINYUU_TOKEN <= iap[i] && iap[i] <= TENDAINYUU_TOKEN); i++){
				if(!MainSwitch(stree, iap, i, tystack, ktype, retcall)) return false;
			}
			did = REF_TYPEID;//tOOFF
			switch(oktype.id){
			case REF_TYPEID:
			case LIST_TYPEID:
				if((ktype.id != REF_TYPEID && ktype.id != LIST_TYPEID) || !stree.YuruiKataCheck(ktype.kwsk, oktype.kwsk, *pjtr->filename, pjtr->gyousuu)) return false;
				break;
			case DYNREF_TYPEID:
				if(ktype.id == REF_TYPEID || ktype.id == LIST_TYPEID){
					SoushokuTobasi(ktype.kwsk.GetConst(), idx=0);
					if(ktype.kwsk.GetConst()[idx] != REF_TOKEN && ktype.kwsk.GetConst()[idx] != LIST_TOKEN) return false;
					idx++;
					did = TokenTtoTypeId(ktype.kwsk.GetConst(), idx);
					if(did == REF_TYPEID || did == LIST_TYPEID || did == DYNREF_TYPEID || did == DYNLIST_TYPEID){
						pjtr->root->stat->ss->ErrorMessage.Add(*pjtr->filename, pjtr->gyousuu, L"^G[łB");
						return false;
					}
				}else if(ktype.id != DYNREF_TYPEID && ktype.id != DYNLIST_TYPEID){
					pjtr->root->stat->ss->ErrorMessage.Add(*pjtr->filename, pjtr->gyousuu, L"^G[łB");
					return false;
				}
				break;
			case DYNLIST_TYPEID:
				if(ktype.id == LIST_TYPEID){
					SoushokuTobasi(ktype.kwsk.GetConst(), idx=0);
					if(ktype.kwsk.GetConst()[idx] != LIST_TOKEN) return false;
					idx++;
					did = TokenTtoTypeId(ktype.kwsk.GetConst(), idx);
					if(did == REF_TYPEID || did == LIST_TYPEID || did == DYNREF_TYPEID || did == DYNLIST_TYPEID){
						pjtr->root->stat->ss->ErrorMessage.Add(*pjtr->filename, pjtr->gyousuu, L"^G[łB");
						return false;
					}
				}else if(ktype.id != DYNLIST_TYPEID){
					pjtr->root->stat->ss->ErrorMessage.Add(*pjtr->filename, pjtr->gyousuu, L"^G[łB");
					return false;
				}
				break;
			case FUNC_TYPEID:
			case METHOD_TYPEID:
				if((ktype.id != FUNC_TYPEID && ktype.id != METHOD_TYPEID) || !stree.YuruiKataCheck(ktype.kwsk, oktype.kwsk, *pjtr->filename, pjtr->gyousuu)) return false;
				break;
			case DELEGATE_TYPEID:
				if(ktype.id != DELEGATE_TYPEID || !stree.YuruiKataCheck(ktype.kwsk, oktype.kwsk, *pjtr->filename, pjtr->gyousuu)) return false;
				pst = oktype.pstre;
				while(pst != ktype.pstre){
					if(pst == NULL){
						pjtr->root->stat->ss->ErrorMessage.Add(*pjtr->filename, pjtr->gyousuu, L"qubNŐ錾ꂽdelegate^͐eubN̕ϐɑł܂B");
						return false;
					}
					pst = pst->parent;
				}
				break;
			default:
				if(!JidouCast(stree, tystack, oktype.id, ktype.id)) return false;
				break;
			}
			ktype.id = oktype.id;
			ktype.kwsk = oktype.kwsk;
			switch(iap[i]){
			case PULUSDAINYUU_TOKEN:
			case MINUSDAINYUU_TOKEN:
			case KAKERUDAINYUU_TOKEN:
			case WARUDAINYUU_TOKEN:
			case AMARIDAINYUU_TOKEN:
			case ANDDAINYUU_TOKEN:
			case XORDAINYUU_TOKEN:
			case ORDAINYUU_TOKEN:
			case LSHIFTDAINYUU_TOKEN:
			case RSHIFTDAINYUU_TOKEN:
				if(ktype.pstre != (SrcTree*)~NULL){
					if(!StackEnzan(stree, tystack, ktype, (TokenKind)iap[i])) return false;
				}else{
					ktype.pstre = NULL;
				}
			case DAINYUU_TOKEN:
				if(ktype.id == REF_TYPEID || ktype.id == LIST_TYPEID){
					if(at == AT_SANSHOU) MovRegSIB(ESI, SIB(0, ESP, ESP), 12);
					if(!RefCountDown(stree, at, ofs, ktype.kwsk, true)) return false;
					if(at == AT_SANSHOU) AddRegImm(ESP, 4);
				}else if(ktype.id == DYNREF_TYPEID || ktype.id == DYNLIST_TYPEID){
					if(did != REF_TYPEID){
						if(at == AT_SANSHOU) MovRegSIB(ESI, SIB(0, ESP, ESP), 12);
						PushCadr(0);
						if(!MovRegAdr(ESI, at, ofs)) return false;
						PushReg(ESI);
						PushImm(did);
						PushImm((int32_t)pjtr->root);
						PluginCall(DynRefCopy);
						if(at == AT_SANSHOU) AddRegImm(ESP, 4);
					}else{
						if(at == AT_SANSHOU) MovRegSIB(ESI, SIB(0, ESP, ESP), 16);
						if(!RefCountDown(stree, at, ofs, ktype.kwsk, true)) return false;
						if(at == AT_SANSHOU) AddRegImm(ESP, 4);
					}
				}else if(ktype.id == DELEGATE_TYPEID){
					if(at == AT_SANSHOU) MovRegSIB(ESI, SIB(0, ESP, ESP), 12);
					PopHns(at, ofs);
					PopHns(at, ofs+4);
					PopHns(at, ofs+8);
					if(at == AT_SANSHOU) AddRegImm(ESP, 4);
				}else{
					if(ktype.pstre != (SrcTree*)~NULL){
						if(!DainyuuReg(stree, ktype, at, ofs)) return false;
					}else{
						if(!DainyuuTeisuu(stree, ktype, at, ofs, &castvar)) return false;
					}
				}
				if(iap[i+1] == SEMICOLON_TOKEN || iap[i+1] == SHARP_TOKEN){
					tystack.SetLength(tystack.GetLength()-2);
					if(ktype.id == FLOAT_TYPEID || ktype.id == DOUBLE_TYPEID){
						KTDrop(ktype);
					}else{
						ktype.id = VOID_TYPEID;
					}
					i++;
				}else if(iap[i+1] == NULL_TOKEN && iap[i+2] == TENDAINYUU_TOKEN){
					tystack.SetLength(tystack.GetLength()-2);
					if(ktype.id == FLOAT_TYPEID || ktype.id == DOUBLE_TYPEID){
						KTDrop(ktype);
					}else{
						ktype.id = VOID_TYPEID;
					}
					i += 2;
					if(!Append(stree, iap, i, tystack, ktype, oktype, at, ofs)) return false;
				}else if(iap[i+1] == NULL_TOKEN && (DAINYUU_TOKEN <= iap[i+2] && iap[i+2] <= RSHIFTDAINYUU_TOKEN)){
					tystack.SetLength(tystack.GetLength()-2);
					if(ktype.id == FLOAT_TYPEID || ktype.id == DOUBLE_TYPEID){
						KTDrop(ktype);
					}else{
						ktype.id = VOID_TYPEID;
					}
					i += 2;
					if(!Dainyuu(stree, iap, i, tystack, ktype, oktype, at, ofs)) return false;
				}else if(
					(iap[i+1] == NULL_TOKEN && (iap[i+2] == PLSPLS_TOKEN || iap[i+2] == MNSMNS_TOKEN))
					|| iap[i+1] == PLSPLS_TOKEN || iap[i+1] == MNSMNS_TOKEN)
				{
					tystack.SetLength(tystack.GetLength()-2);
					if(ktype.id == FLOAT_TYPEID || ktype.id == DOUBLE_TYPEID){
						KTDrop(ktype);
					}else{
						ktype.id = VOID_TYPEID;
					}
					i++;
					if(!IncDec(stree, iap, i, tystack, ktype, oktype, at, ofs)) return false;
				}else{
					if(ktype.id == REF_TYPEID || ktype.id == LIST_TYPEID){
						if(!PushHnsRef(at, ofs, false)) return false;
					}else if(ktype.id == DYNREF_TYPEID || ktype.id == DYNLIST_TYPEID){
						if(!PushHnsRef(at, ofs, true)) return false;
					}else if(ktype.id == DELEGATE_TYPEID){
						if(!PushHns(at, ofs+8) || !PushHns(at, ofs+4) || !PushHns(at, ofs)) return false;
					}
					tystack.Pop();
				}
				break;
			default:
				return false;
			}
			return true;
		}
		bool AppendSub(SrcTree &stree, const intptr_t *const iap, intptr_t &i, PWCArray<int32_t> &tystack, KuwashiiType &ktype, const KuwashiiType &oktype, const AddressType at, const intptr_t ofs)
		{
			if(ktype.id == REF_TYPEID || ktype.id == LIST_TYPEID){
				if(at == AT_SANSHOU) MovRegSIB(ESI, SIB(0, ESP, ESP), 12);
				if(!MovRegAdr(ESI, at, ofs)) return false;
				PushReg(ESI);
				PluginCall(ListAppendRef);
				if(at == AT_SANSHOU) AddRegImm(ESP, 4);
			}else{
				if(at == AT_SANSHOU) PopReg(ESI);
				if(0 <= ktype.id && ktype.id <= ENDCLASS_TYPEID && stree.stat->funclist.Get(ktype.id)->selftype == CLASS_BLOCK){
					if(stree.stat->funclist.Get(ktype.id)->GetMemberSize() > 0){
						if(!KTPush(ktype)) return false;
						PushImm(stree.stat->funclist.Get(ktype.id)->GetMemberSize());
						if(!MovRegAdr(ESI, at, ofs)) return false;
						PushReg(ESI);
						PluginCall(ListAppend);
					}
				}else{
					if(!KTPush(ktype)) return false;
					if(!MovRegAdr(ESI, at, ofs)) return false;
					PushReg(ESI);
					switch(stree.TypeIdtoSize(ktype.id)){
					case 1:
						PluginCall(ListAppend8);
						break;
					case 2:
						PluginCall(ListAppend16);
						break;
					case 4:
						PluginCall(ListAppend32);
						break;
					case 8:
						PluginCall(ListAppend64);
						break;
					default:
						return false;
					}
				}
			}
			if(iap[i+1] == SEMICOLON_TOKEN || iap[i+1] == SHARP_TOKEN){
				tystack.Pop();
				ktype.id = VOID_TYPEID;
				i += 1;
			}else if(iap[i+1] == NULL_TOKEN && iap[i+2] == TENDAINYUU_TOKEN){
				tystack.Pop();
				ktype.id = VOID_TYPEID;
				i += 2;
				if(!Append(stree, iap, i, tystack, ktype, oktype, at, ofs)) return false;
			}else if(iap[i+1] == NULL_TOKEN && iap[i+2] == DAINYUU_TOKEN){
				tystack.Pop();
				ktype.id = VOID_TYPEID;
				i += 2;
				if(!Dainyuu(stree, iap, i, tystack, ktype, oktype, at, ofs)) return false;
			}else{
				if(!PushHnsRef(at, ofs, false)) return false;
				ktype = oktype;
				tystack.Tail() = ktype.id;
			}
			return true;
		}
		bool Append(SrcTree &stree, const intptr_t *const iap, intptr_t &i, PWCArray<int32_t> &tystack, KuwashiiType &ktype, const KuwashiiType &oktype, const AddressType at, const intptr_t ofs)
		{
			int32_t typ;
			intptr_t idx;
			SrcTree *retcall = NULL;
			if(oktype.id != LIST_TYPEID) return false;
			if(at == AT_SANSHOU) PushReg(ESI);
			for(i++; iap[i] != TENDAINYUU_TOKEN; i++){
				if(!MainSwitch(stree, iap, i, tystack, ktype, retcall)) return false;
			}
			SoushokuTobasi(oktype.kwsk.GetConst(), idx=0);
			if(oktype.kwsk.GetConst()[idx] != LIST_TOKEN) return false;
			idx++;
			if((typ = TokenTtoTypeId(oktype.kwsk.GetConst(), idx)) == UNKNOWN_TYPEID) return false;
			if(typ < 0
				|| (typ <= ENDCLASS_TYPEID && stree.stat->funclist.Get(typ)->selftype == CLASS_BLOCK && !stree.stat->funclist.Get(typ)->IsOpen()))
			{
				pjtr->root->stat->ss->ErrorMessage.Add(*pjtr->filename, pjtr->gyousuu, L"ŃRs[łȂNXłB");
				return false;
			}
			if(ktype.id == REF_TYPEID || ktype.id == LIST_TYPEID){
				if(!stree.YuruiKataCheck(oktype.kwsk, ktype.kwsk, *pjtr->filename, pjtr->gyousuu)) return false;
			}else{
				if(!JidouCast(stree, tystack, typ, ktype.id)) return false;
				ktype.id = typ;
			}
			return AppendSub(stree, iap, i, tystack, ktype, oktype, at, ofs);
		}
		bool IncDecSub(SrcTree &stree, const intptr_t *const iap, intptr_t &i, PWCArray<int32_t> &tystack, KuwashiiType &ktype, const KuwashiiType &oktype, const AddressType at, const intptr_t ofs, bool dec, bool mae)
		{
			if(!mae || iap[i+1] == SEMICOLON_TOKEN || iap[i+1] == SHARP_TOKEN
				|| (iap[i+1] == NULL_TOKEN && (DAINYUU_TOKEN <= iap[i+2] && iap[i+2] <= RSHIFTDAINYUU_TOKEN))
				|| (iap[i+1] == NULL_TOKEN && (iap[i+2] == PLSPLS_TOKEN || iap[i+2] == MNSMNS_TOKEN))
				|| iap[i+1] == PLSPLS_TOKEN || iap[i+1] == MNSMNS_TOKEN)
			{
				if(oktype.id == LONG_TYPEID || oktype.id == ULONG_TYPEID){
					if(!MovRegHns64(EAX, EDX, at, ofs)) return false;
					(dec ? SubImm64(1) : AddImm64(1));
					if(!MovHnsReg64(at, ofs)) return false;
				}else{
					if(!MovRegHns(EAX, at, ofs, false)) return false;
					(dec ? SubRegImm(EAX, 1) : AddRegImm(EAX, 1));
					if(!MovHnsReg(at, ofs, EAX, false)) return false;
				}
				if(iap[i+1] == NULL_TOKEN && (DAINYUU_TOKEN <= iap[i+2] && iap[i+2] <= RSHIFTDAINYUU_TOKEN)){
					i += 2;
					if(!Dainyuu(stree, iap, i, tystack, ktype, oktype, at, ofs)) return false;
				}else if((iap[i+1] == NULL_TOKEN && (iap[i+2] == PLSPLS_TOKEN || iap[i+2] == MNSMNS_TOKEN))
					|| iap[i+1] == PLSPLS_TOKEN || iap[i+1] == MNSMNS_TOKEN)
				{
					i++;
					if(!IncDec(stree, iap, i, tystack, ktype, oktype, at, ofs)) return false;
				}else if(iap[i+1] != SEMICOLON_TOKEN && iap[i+1] != SHARP_TOKEN){
					ktype = oktype;
					tystack += ktype.id;
				}
			}else{
				if(oktype.id == LONG_TYPEID || oktype.id == ULONG_TYPEID){
					if(!MovRegHns64(EAX, EDX, at, ofs)) return false;
					MovRegReg(ECX, EAX);
					MovRegReg(EBX, EDX);
					(dec ? SubImm64(1) : AddImm64(1));
					if(!MovHnsReg64(at, ofs)) return false;
					MovRegReg(EAX, ECX);
					MovRegReg(EDX, EBX);
				}else{
					if(!MovRegHns(EAX, at, ofs, false)) return false;
					MovRegReg(ECX, EAX);
					(dec ? SubRegImm(ECX, 1) : AddRegImm(ECX, 1));
					if(!MovHnsReg(at, ofs, ECX, false)) return false;
				}
				ktype = oktype;
				tystack += ktype.id;
			}
			return true;
		}
		bool IncDec(SrcTree &stree, const intptr_t *const iap, intptr_t &i, PWCArray<int32_t> &tystack, KuwashiiType &ktype, const KuwashiiType &oktype, const AddressType at, const intptr_t ofs)
		{
			if(oktype.id < ADDRESS_TYPEID || BYTE_TYPEID < oktype.id) return false;
			if(!KTPush(ktype)) return false;
			ktype.id = VOID_TYPEID;
			if(iap[i] == NULL_TOKEN){
				i++;
				switch(iap[i]){
				case PLSPLS_TOKEN:
					if(!IncDecSub(stree, iap, i, tystack, ktype, oktype, at, ofs, false, true)) return false;
					break;
				case MNSMNS_TOKEN:
					if(!IncDecSub(stree, iap, i, tystack, ktype, oktype, at, ofs, true, true)) return false;
					break;
				default:
					return false;
				}
			}else{
				switch(iap[i]){
				case PLSPLS_TOKEN:
					if(!IncDecSub(stree, iap, i, tystack, ktype, oktype, at, ofs, false, false)) return false;
					break;
				case MNSMNS_TOKEN:
					if(!IncDecSub(stree, iap, i, tystack, ktype, oktype, at, ofs, true, false)) return false;
					break;
				default:
					return false;
				}
			}
			return true;
		}
		bool LoadHensuu(const SrcTree &stree, const KuwashiiType &ktype, const AddressType at, const intptr_t ofs)
		{
			switch(ktype.id){
			case BYTE_TYPEID:
			case UBYTE_TYPEID:
			case BOOL_TYPEID:
				if(!MovRegHns8(AL, at, ofs)) return false;
				break;
			case SHORT_TYPEID:
			case USHORT_TYPEID:
			case CHAR_TYPEID:
				if(!MovRegHns(EAX, at, ofs, true)) return false;
				break;
			default:
				if(ktype.id < 0 || ENDCLASS_TYPEID < ktype.id || stree.stat->funclist.Get(ktype.id)->selftype != ENUM_BLOCK) return false;
			case INT_TYPEID:
			case ADDRESS_TYPEID:
			case UINT_TYPEID:
			case FUNC_TYPEID:
			case METHOD_TYPEID:
				if(!MovRegHns(EAX, at, ofs, false)) return false;
				break;
			case LONG_TYPEID:
			case ULONG_TYPEID:
				if(!MovRegHns64(EAX, EDX, at, ofs)) return false;
				break;
			case REF_TYPEID:
			case LIST_TYPEID:
				if(!PushHnsRef(at, ofs, false)) return false;
				break;
			case DELEGATE_TYPEID:
				if(!PushHns(at, ofs+8) || !PushHns(at, ofs+4) || !PushHns(at, ofs)) return false;
				break;
			case DYNREF_TYPEID:
			case DYNLIST_TYPEID:
				if(!PushHnsRef(at, ofs, true)) return false;
				break;
			case FLOAT_TYPEID:
				if(!FldAdr(at, ofs, false)) return false;
				break;
			case DOUBLE_TYPEID:
				if(!FldAdr(at, ofs, true)) return false;
				break;
			}
			return true;
		}
		bool RefCountDown(SrcTree &stree, const AddressType at, const intptr_t ofs, const PWCArray<intptr_t> &hes, const bool copy)
		{
			SrcTree *pst;
			int32_t fi;
			PWCArray<wchar_t> name;
			intptr_t idx, bkp, tmp;
			SoushokuTobasi(hes.GetConst(), idx=0);
			if(hes.GetConst()[idx] != REF_TOKEN && hes.GetConst()[idx] != LIST_TOKEN) return false;
			if(hes.GetConst()[idx+1] == NULL_TOKEN){
				PushCadr(0);
				if(!MovRegAdr(ESI, at, ofs)) return false;
				PushReg(ESI);
				if(copy){
					PushSIB(SIB(0, ESP, ESP), 20);
					PushImm((int32_t)pjtr->root);
					PluginCall(DynRefCopy);
					AddRegImm(ESP, 4);
				}else{
					PushImm((int32_t)pjtr->root);
					PluginCall(DynRefDelete);
				}
				return true;
			}
			idx++;
			if(hes.GetConst()[idx] == CONST_TOKEN) idx++;
			if(hes.GetConst()[idx] == CLASS_TOKEN){
				pst = stree.stat->funclist.Get((int32_t)hes.GetConst()[idx+1]);
			}else{
				pst = NULL;
			}
			if(copy){
				PushReg(ESP);
				if(!MovRegAdr(EBX, at, ofs)) return false;
				PushReg(EBX);
				if(pst != NULL && pst->IsJunkanAble()){
					PushImm((int32_t)pjtr->root->stat->ss);
					PluginCall(CircRefCopy);
				}else{
					PluginCall(RefCopy);
				}
				MovRegReg(ESI, ESP);
			}else{
				if(!MovRegAdr(ESI, at, ofs)) return false;
				PushReg(ESI);
				if(pst != NULL && pst->IsJunkanAble()){
					PushImm((int32_t)pjtr->root->stat->ss);
					PluginCall(CircRefCntDwn);
				}else{
					PluginCall(RefCntDwn);
				}
			}
			bkp = FalseJump(0);
			if(hes.GetConst()[idx] == REF_TOKEN || hes.GetConst()[idx] == LIST_TOKEN){
				idx++;
				tmp = 0;
				while(hes.GetConst()[idx+tmp] == REF_TOKEN || hes.GetConst()[idx+tmp] == LIST_TOKEN) tmp++;
				idx += tmp;
				PushReg(ESI);
				switch(hes.GetConst()[idx]){
				case NULL_TOKEN:
					PushImm(tmp-1);
					PushCadr(0);
					PushImm((int32_t)pjtr->root);
					PluginCall(RefDynRefDel);
					break;
				case THREAD_TOKEN:
					PushImm(tmp);
					PluginCall(RefRefThreadWait);
					break;
				case CLASS_TOKEN:
					pst = stree.stat->funclist.Get((int32_t)hes.GetConst()[idx+1]);
					name = L"break";
					if((fi = pst->GetFuncId(name, false)) >= 0 && stree.stat->funclist.Get(fi)->token.GetLength() > 0){
						PushImm(tmp);
						PushImm(pst->GetMemberSize());
						PushFadr(*stree.stat->funclist.Get(fi));
						if(pst->IsJunkanAble()){
							PushImm((int32_t)pjtr->root->stat->ss);
							PluginCall(RefCircRefClassDel);
						}else{
							PluginCall(RefRefClassDel);
						}
						break;
					}
					pst = NULL;
				default:
					PushImm(tmp);
					PluginCall(RefRefDel);
					break;
				}
			}else if(hes.GetConst()[idx] == THREAD_TOKEN){
				PushReg(ESI);
				PluginCall(RefThreadWait);
			}else if(pst != NULL && (name = L"break", fi = pst->GetFuncId(name, false)) >= 0 && stree.stat->funclist.Get(fi)->token.GetLength() > 0){
				PushReg(ESI);
				PushImm(pst->GetMemberSize());
				PushFadr(*stree.stat->funclist.Get(fi));
				PluginCall(RefClassDel);
			}
			PushReg(ESI);
			if(pst != NULL && pst->IsJunkanAble()){
				PushImm((int32_t)pjtr->root->stat->ss);
				PluginCall(CircRefDel);
			}else{
				PluginCall(RefDel);
			}
			*(int32_t *)(pjtr->ntvcode.GetConst()+bkp) += pjtr->ntvcode.GetLength();
			if(copy){
				MovRegReg(ESI, EBX);
				AddRegImm(ESP, 12);
			}
			return true;
		}
		bool RefNew(SrcTree &stree, const intptr_t *const iap, intptr_t &i, PWCArray<int32_t> &tystack, KuwashiiType &ktype, const AddressType at, const intptr_t ofs, bool list, const PWCArray<intptr_t> &hes)
		{
			SrcTree *pst;
			SrcTree *retcall = NULL;
			int32_t fi;
			intptr_t idx;
			PWCArray<intptr_t> type;
			PWCArray<wchar_t> name;
			KuwashiiType oldtype;
			SoushokuTobasi(hes.GetConst(), idx=0);
			if(hes.GetConst()[idx] != REF_TOKEN && hes.GetConst()[idx] != LIST_TOKEN) return false;
			idx++;
			if(hes.GetConst()[idx] == CONST_TOKEN) idx++;
			if(hes.GetConst()[idx] == CLASS_TOKEN){
				pst = stree.stat->funclist.Get((int32_t)hes.GetConst()[idx+1]);
			}else{
				pst = NULL;
			}
			oldtype = ktype;
			if(at == AT_SANSHOU) PushReg(ESI);
			tystack += ADDRESS_TYPEID;
			do{
				if(!MainSwitch(stree, iap, i, tystack, ktype, retcall)) return false;
				i++;
			}while(iap[i] != SHOUKAKKOCLOSE_TOKEN);
			if(!JidouCast(stree, tystack, ADDRESS_TYPEID, ktype.id)) return false;
			tystack.Pop();
			if(at == AT_SANSHOU) PopReg(ESI);
			ktype.id = ADDRESS_TYPEID;
			if(pst != NULL){
				PushImm(pst->GetMemberSize());
			}else{
				type.Clear();
				type.AddTail(hes.GetConst()+idx, hes.GetLength()-idx);
				PushImm(stree.GetTypeSize(type));
			}
			PushReg(EAX);
			if(!MovRegAdr(ESI, at, ofs)) return false;
			PushReg(ESI);
			if(pst != NULL && pst->IsJunkanAble()){
				PushImm(pst->sonota.junkanid);
				if(list){
					PushImm((int32_t)pjtr->root->stat->ss);
					PluginCall(CircListNew);
				}else{
					PushImm((int32_t)pjtr->root->stat->ss);
					PluginCall(CircRefeNew);
				}
			}else{
				if(list){
					PluginCall(ListNew);
				}else{
					PluginCall(RefeNew);
				}
			}
			tystack.Pop();
			if(hes.GetConst()[idx] == REF_TOKEN || hes.GetConst()[idx] == LIST_TOKEN){
				PushReg(ESI);
				if(hes.GetConst()[idx+1] == NULL_TOKEN){
					PluginCall(RefDynRefInit);
				}else{
					PluginCall(RefZeroClear);
				}
			}else if(hes.GetConst()[idx] == THREAD_TOKEN){
				PushReg(ESI);
				PluginCall(RefZeroClear);
			}else if(pst != NULL && (name = L"default", fi = pst->GetFuncId(name, false)) >= 0 && stree.stat->funclist.Get(fi)->token.GetLength() > 0){
				PushReg(ESI);
				PushImm(pst->GetMemberSize());
				PushFadr(*stree.stat->funclist.Get(fi));
				PluginCall(RefClassNew);
			}
			ktype.id = VOID_TYPEID;
			if(tystack.GetLength() > 0 && !KTPop(oldtype)) return false;
			tystack += ktype.id;
			return true;
		}
		bool RefIdxNew(SrcTree &stree, const intptr_t *const iap, intptr_t &i, PWCArray<int32_t> &tystack, KuwashiiType &ktype, const AddressType at, const intptr_t ofs, const PWCArray<intptr_t> &hes)
		{
			SrcTree *pst;
			SrcTree *retcall = NULL;
			int32_t fi;
			intptr_t idx;
			PWCArray<intptr_t> type;
			PWCArray<wchar_t> name;
			KuwashiiType oldtype;
			SoushokuTobasi(hes.GetConst(), idx=0);
			if(hes.GetConst()[idx] != LIST_TOKEN) return false;
			idx++;
			if(hes.GetConst()[idx] == CONST_TOKEN) idx++;
			if(hes.GetConst()[idx] == CLASS_TOKEN){
				pst = stree.stat->funclist.Get((int32_t)hes.GetConst()[idx+1]);
			}else{
				pst = NULL;
			}
			oldtype = ktype;
			if(at == AT_SANSHOU) PushReg(ESI);
			tystack += ADDRESS_TYPEID;
			do{
				if(!MainSwitch(stree, iap, i, tystack, ktype, retcall)) return false;
				i++;
			}while(iap[i] != DAIKAKKOCLOSE_TOKEN);
			if(!JidouCast(stree, tystack, ADDRESS_TYPEID, ktype.id)) return false;
			tystack.Pop();
			if(at == AT_SANSHOU) PopReg(ESI);
			ktype.id = ADDRESS_TYPEID;
			if(pst != NULL){
				PushImm(pst->GetMemberSize());
			}else{
				type.Clear();
				type.AddTail(hes.GetConst()+idx, hes.GetLength()-idx);
				PushImm(stree.GetTypeSize(type));
			}
			PushReg(EAX);
			if(!MovRegAdr(ESI, at, ofs)) return false;
			PushReg(ESI);
			switch(hes.GetConst()[idx]){
			case NULL_TOKEN:
				return false;
			case REF_TOKEN:
			case LIST_TOKEN:
				if(hes.GetConst()[idx+1] == NULL_TOKEN){
					PluginCall(ListIdxNewDynRefInit);
					break;
				}
			case THREAD_TOKEN:
				PluginCall(ListIdxNewZeroClear);
				break;
			case CLASS_TOKEN:
				name = L"default";
				if((fi = pst->GetFuncId(name, false)) >= 0 && stree.stat->funclist.Get(fi)->token.GetLength() > 0){
					PushFadr(*stree.stat->funclist.Get(fi));
					if(pst->IsJunkanAble()){
						PushImm(pst->sonota.junkanid);
						PushImm((int32_t)pjtr->root->stat->ss);
						PluginCall(CircListIdxNewClass);
					}else{
						PluginCall(ListIdxNewClass);
					}
					break;
				}
			default:
				PluginCall(ListIdxNew);
				break;
			}
			tystack.Pop();
			MovRegReg(ESI, EAX);
			ktype = oldtype;
			if(tystack.GetLength() > 0 && !KTPop(ktype)) return false;
			return true;
		}
		bool Hensuu(SrcTree &stree, const intptr_t *const iap, intptr_t &i, PWCArray<int32_t> &tystack, KuwashiiType &ktype, const AddressType at, intptr_t ofs, SrcTree *const pst, const intptr_t indt, const PWCArray<intptr_t> &ty, const bool cnstf)
		{
			KuwashiiType typ;
			intptr_t idx;
			bool tmpb;
			PWCArray<intptr_t> type;
			PWCArrayQuad< PWCArray<intptr_t> > waketa;
			SoushokuTobasi(ty.GetConst(), idx=0);
			if(iap[i+1] == VOID_TOKEN){
				i++;
				if(ty.GetConst()[idx] == THREAD_TOKEN){
					if(!MovHnsImm(at, ofs, 0, false)) return false;
				}else if(ty.GetConst()[idx] == REF_TOKEN || ty.GetConst()[idx] == LIST_TOKEN){
					if(ty.GetConst()[idx+1] != OTHERKIND_TOKEN){
						if(!MovHnsImm(at, ofs, 0, false)) return false;
						if(!MovHnsImm(at, ofs+4, 0, false)) return false;
						if(!MovHnsImm(at, ofs+8, 0, false)) return false;
						if(ty.GetConst()[idx+1] == NULL_TOKEN && !MovHnsImm(at, ofs+12, VOID_TYPEID, false)) return false;
					}
				}else{
					return false;
				}
				i++;//Z~R΂
				if(iap[i] != SEMICOLON_TOKEN) return false;
				return true;
			}
			if(iap[i+1] == DELETE_TOKEN || iap[i+1] == NEW_TOKEN){
				if(cnstf) return false;
				i++;
				if(ty.GetConst()[idx] == THREAD_TOKEN){
					if(!MovRegAdr(ESI, at, ofs)) return false;
					PushReg(ESI);
					PluginCall(ThreadWait);
				}else if(ty.GetConst()[idx] == REF_TOKEN || ty.GetConst()[idx] == LIST_TOKEN){
					if(ty.GetConst()[idx+1] != OTHERKIND_TOKEN && (iap[i] != NEW_TOKEN || iap[i+1] != DAIKAKKOOPEN_TOKEN)){
						if(tystack.GetLength() > 0 && !KTPush(ktype)) return false;
						if(!RefCountDown(stree, at, ofs, ty, false)) return false;
						if(tystack.GetLength() > 0 && !KTPop(ktype)) return false;
					}
				}else{
					return false;
				}
				if(iap[i] == NEW_TOKEN){
					i++;
					if(ty.GetConst()[idx+1] == CONST_TOKEN || ty.GetConst()[idx+1] == OTHERKIND_TOKEN) return false;
					if(iap[i] == SHOUKAKKOOPEN_TOKEN){
						i++;
						if(!RefNew(stree, iap, i, tystack, ktype, at, ofs, ty.GetConst()[idx] == LIST_TOKEN, ty)) return false;
					}else if(iap[i] == DAIKAKKOOPEN_TOKEN){
						i++;
						if(ty.GetConst()[idx] != LIST_TOKEN) return false;
						if(!RefIdxNew(stree, iap, i, tystack, ktype, at, ofs, ty)) return false;
						idx++;
						type.Clear();
						type.AddTail(ty.GetConst()+idx, ty.GetLength()-idx);
						if(!Sanshou(stree, iap, i, tystack, ktype, type, false)) return false;
					}else{
						return false;
					}
				}else{
					i++;
					if(iap[i] != SEMICOLON_TOKEN) return false;
				}
				return true;
			}
			if(iap[i+1] == SHOUKAKKOOPEN_TOKEN && iap[i+2] == TENTEN_TOKEN){
				if(cnstf) return false;
				i += 3;
				if(ty.GetConst()[idx] != THREAD_TOKEN) return false;
				idx++;
				if(!MovRegAdr(ESI, at, ofs)) return false;
				PushReg(ESI);
				if(Kansuu(stree, iap, i, tystack, ktype, *stree.stat->funclist.Get((int32_t)ty.GetConst()[idx]), true) < 0) return false;
				return true;
			}
			tmpb = ty.GetConst()[idx] == CLASS_TOKEN;
			if((typ.id = TokenTtoTypeId(ty.GetConst(), idx=0)) == UNKNOWN_TYPEID){
				if(ty.GetConst()[0] != PLUGIN_TOKEN || iap[i+1] != KAKKOCOLOOPEN_TOKEN) return false;
				i += 2;
				if(!KTPush(ktype)) return false;
				ktype.id = VOID_TYPEID;
				SubRegImm(ESP, Aliszof<int64_t>());
				PushImm((int32_t)sszrefdeletefunc);
				PushImm((int32_t)sszrefnewfunc);
				PushImm((int32_t)CallBack);
				LeaSIB(EAX, SIB(0, ESP, ESP), 12);
				PushReg(EAX);
				ktype.kwsk = ty;///
				if((idx = KansuuPointer(stree, iap, i, tystack, ktype, pst->frp, waketa)) < 0) return false;
				if(stree.frp->rettype.GetConst()[0] == CONST_TOKEN && waketa.GetConst()[0].GetConst()[0] != CONST_TOKEN) return false;
				if(cnstf && !IsReadOnlyToken((TokenKind)waketa.GetConst()[0].GetConst()[0])) return false;
				LeaSIB(EAX, SIB(0, ESP, ESP), idx);
				PushReg(EAX);
				PluginCall((void*)ty.GetTail());
				AddRegImm(ESP, 16+Aliszof<int64_t>());
				return true;
			}
			typ.pstre = pst;
			typ.kwsk = ty;
			if(iap[i+1] == NULL_TOKEN && iap[i+2] == TENDAINYUU_TOKEN){
				if(cnstf) return false;
				i += 2;
				return Append(stree, iap, i, tystack, ktype, typ, at, ofs);
			}
			if(iap[i+1] == NULL_TOKEN && (DAINYUU_TOKEN <= iap[i+2] && iap[i+2] <= RSHIFTDAINYUU_TOKEN)){
				if(cnstf) return false;
				i += 2;
				return Dainyuu(stree, iap, i, tystack, ktype, typ, at, ofs);
			}
			if((iap[i+1] == NULL_TOKEN && (iap[i+2] == PLSPLS_TOKEN || iap[i+2] == MNSMNS_TOKEN))
				|| iap[i+1] == PLSPLS_TOKEN || iap[i+1] == MNSMNS_TOKEN)
			{
				if(cnstf) return false;
				i++;
				return IncDec(stree, iap, i, tystack, ktype, typ, at, ofs);
			}
			if(cnstf && ENDTHREAD_TYPEID <= typ.id && typ.id < 0) return false;
			if(typ.id != VOID_TYPEID){
				if(ty.GetConst()[0] == CONST_TOKEN){
					if(!KTPush(ktype)) return false;
					ktype = typ;
					if(ktype.id == FUNC_TYPEID){
						if(!stree.stat->funclist.Get((int32_t)ty.GetTail())->kakutei) return false;
						MovRegFun(EAX, *stree.stat->funclist.Get((int32_t)ty.GetTail()));
					}else if(ktype.id == REF_TYPEID){
						(bool)PushHnsRef(AT_GLOBAL, ty.GetTail(), false);
					}else{
						if(!Teisuu(stree, ktype, ty.GetConst()+idx)) return false;
					}
				}else{
					if(tmpb || (ENDTHREAD_TYPEID <= typ.id && typ.id < 0)){
						if(!KTPush(ktype)) return false;
						ktype = typ;
						if(!MovRegAdr(EAX, at, ofs)) return false;
					}else{
						if(typ.id == ktype.id
							&& KAKERU_TOKEN <= iap[i+1] && iap[i+1] <= RSHIFTDAINYUU_TOKEN
							&& iap[i+1] != DAINYUU_TOKEN && iap[i+1] != QUESTION_TOKEN){
							if(!HensuuEnzan(stree, tystack, ktype, at, ofs, (TokenKind)iap[i+1])) return false;
							if(KAKERU_TOKEN <= iap[i+1] && iap[i+1] <= OR_TOKEN){
								i++;
							}else{
								ktype.pstre = (SrcTree*)~NULL;
								return true;
							}
							tystack.Pop();
						}else{
							if(!KTPush(ktype)) return false;
							ktype = typ;
							if(!LoadHensuu(stree, ktype, at, ofs)) return false;
						}
					}
				}
				if(ktype.id == METHOD_TYPEID && iap[i+1] == KAKKOCOLOOPEN_TOKEN){
					i += 2;
					if(at == AT_SANSHOU){
						SubRegImm(ESI, pst->GetMemberOffset(indt));
					}else{
						ofs -= (pst == stree.frp ? stree.crp->GetMemberOffset(indt) : pst->GetMemberOffset(indt));
					}
					if(!KTPush(ktype)) return false;
					ktype.id = VOID_TYPEID;
					if(at == AT_SANSHOU) PushReg(ESI);
					if(!pst->frp->touka) PushReg(EDI);
					if((idx = KansuuPointer(stree, iap, i, tystack, ktype, pst->frp, waketa)) < 0) return false;
					if(stree.frp->rettype.GetConst()[0] == CONST_TOKEN && waketa.GetConst()[0].GetConst()[0] != CONST_TOKEN) return false;
					if(cnstf && !IsReadOnlyToken((TokenKind)waketa.GetConst()[0].GetConst()[0])) return false;
					if(at == AT_SANSHOU){
						MovRegSIB(EDI, SIB(0, ESP, ESP), idx+4);
						MovRegSIB(EAX, SIB(0, ESP, ESP), idx+8);
					}else{
						if(!pst->frp->touka){
							if(!MovRegAdr(EDI, at, ofs)) return false;
							MovRegSIB(EAX, SIB(0, ESP, ESP), idx+4);
						}else{
							MovRegSIB(EAX, SIB(0, ESP, ESP), idx);
						}
					}
					CallReg(EAX);
					if(!pst->frp->touka) PopReg(EDI);
					AddRegImm(ESP, (at == AT_SANSHOU ? 8 : 4));
				}
			}
			tystack += ktype.id;
			return true;
		}
		bool Sanshou(SrcTree &stree, const intptr_t *const iap, intptr_t &i, PWCArray<int32_t> &tystack, KuwashiiType &ktype, const PWCArray<intptr_t> &rtype, const bool supercnst)
		{
			SrcTree *pst = NULL;
			int32_t tyki;
			intptr_t indt = 0, idx, tmpi, asize;
			PWCArray<intptr_t> typer;
			tmpi = 0;
			bool cnstf, tendeta;
			if(IsReadOnlyToken((TokenKind)rtype.GetConst()[0])){
				typer.Clear();
				typer.AddTail(rtype.GetConst()+1, rtype.GetLength()-1);
				cnstf = true;
			}else{
				typer = rtype;
				cnstf = supercnst;
			}
			tendeta = false;
			while(iap[i+1] == POINT_TOKEN){
				tendeta = true;
				SoushokuTobasi(typer.GetConst(), idx=0);
				if(typer.GetConst()[idx] != CLASS_TOKEN && typer.GetConst()[idx] != ENUM_TOKEN) return false;
				idx++;
				tyki = (int32_t)typer.GetConst()[idx];
				i += 2;
				if(iap[i] == MBR_TOKEN) i++;
				pst = stree.stat->funclist.Get(tyki);
				if(iap[i] == SHOUKAKKOOPEN_TOKEN){
					i++;
					if(iap[i] >= 0) return false;
					pst = stree.stat->funclist.Get((int32_t)~iap[i]);
					i++;
					if(!pst->kakutei && (pst = pst->GetIjousaki(tmpi, stree, iap+i)) == NULL) return false;
					if(stree.frp->rettype.GetConst()[0] == CONST_TOKEN && pst->rettype.GetConst()[0] != CONST_TOKEN) return false;
					if(cnstf && !IsReadOnlyToken((TokenKind)pst->rettype.GetConst()[0])) return false;
					if(!KTPush(ktype)) return false;
					ktype.id = VOID_TYPEID;
					PushReg(EDI);
					AddRegImm(ESI, tmpi);
					PushReg(ESI);
					if((asize = Kansuu(stree, iap, i, tystack, ktype, *pst, false)) < 0) return false;
					MovRegSIB(EDI, SIB(0, ESP, ESP), asize);
					FuncCall(*pst);
					AddRegImm(ESP, 4);
					PopReg(EDI);
					break;
				}
				if(iap[i] >= 0) return false;
				indt = ~iap[i];
				tmpi += pst->GetMemberOffset(indt);
				typer = pst->funchensuu.GetConst()[indt].type;
				cnstf = cnstf || IsReadOnlyToken((TokenKind)typer.GetConst()[0]);
			}
			if(iap[i] >= 0 && iap[i] != DIA_TOKEN && iap[i] != DAIKAKKOCLOSE_TOKEN) return true;
			if((!tendeta || typer.GetConst()[0] != CONST_TOKEN) && tmpi != 0) AddRegImm(ESI, tmpi);
			return Hensuu(stree, iap, i, tystack, ktype, AT_SANSHOU, 0, pst, indt, typer, cnstf);
		}
		bool IsVoidHikinashiRet(SrcTree &stree, const intptr_t *const iap, intptr_t &i, const SrcTree &st)
		{
			intptr_t oi;
			const PWCArray<intptr_t> *pty;
			if(iap[i] != SHOUKAKKOCLOSE_TOKEN){
				if(st.hikisuucount != 0) return false;
				oi = i;
				if(stree.frp == stree.root){
					if(iap[i] != TILDE_TOKEN) return false;
					i++;
				}
				if(iap[i] >= 0){
					i = oi;
					return false;
				}
				pty = &stree.frp->funchensuu.GetConst()[~iap[i]].type;
				if(pty->GetConst()[0] == REF_TOKEN && pty->GetConst()[1] == OTHERKIND_TOKEN){
					i++;
					i += (iap[i] == VOID_TOKEN ? 2 + (stree.frp == stree.root ? 2 : 1) : 0);//VOID_TOKEN,SEMICOLON_TOKEN
					i += 3;//NULL_TOKEN,DAINYUU_TOKEN,COMMA_TOKEN
				}else{
					i = oi;
					return false;
				}
				if(iap[i] != SHOUKAKKOCLOSE_TOKEN){
					i = oi;
					return false;
				}
			}
			if(iap[i+1] != NULL_TOKEN) return false;
			if(iap[i+2] != RETURN_TOKEN){
				if(iap[i+2] != SHARP_TOKEN) return false;
				oi = i;
				pty = &stree.frp->funchensuu.GetConst()[~iap[i+3+(stree.frp == stree.root ? 1 : 0)]].type;
				if(pty->GetConst()[0] == REF_TOKEN && pty->GetConst()[1] == OTHERKIND_TOKEN){
					i += 2 + (stree.frp == stree.root ? 2 : 1);
				}else{
					return false;
				}
				if(iap[i+1] != NULL_TOKEN || iap[i+2] != RETURN_TOKEN){
					i = oi;
					return false;
				}
				i = oi;
			}
			return true;
		}
		bool MainSwitch(SrcTree &stree, const intptr_t *const iap, intptr_t &i, PWCArray<int32_t> &tystack, KuwashiiType &ktype, SrcTree *&retcall)
		{
			static intptr_t glbbp;
			SrcTree *pst;
			KuwashiiType typ;
			intptr_t idx, indt, tmpi, bp1, bp2;
			TokenKind tmptk;
			PWCArray<intptr_t> type;
			const PWCArray<intptr_t> *pty;
			bool tmpb, cnstf;
			PWCArrayQuad< PWCArray<intptr_t> > waketa;
			ktype.pstre = NULL;
			switch(iap[i]){
			case CONST_TOKEN:
				i++;
				if((typ.id = TokenTtoTypeId(iap, i)) == UNKNOWN_TYPEID) return false;
				if(typ.id == REF_TYPEID){
					if(!KTPush(ktype)) return false;
					ktype = typ;
					ktype.kwsk = REF_TOKEN;
					if(!RefToken(ktype.kwsk, iap, i)) return false;
					(bool)PushHnsRef(AT_GLOBAL, iap[i], false);
				}else if(typ.id == FUNC_TYPEID || typ.id == METHOD_TYPEID){
					if(!KTPush(ktype)) return false;
					ktype = typ;
					ktype.kwsk = (ktype.id == FUNC_TYPEID ? FUNC_TOKEN : METHOD_TOKEN);
					if(ktype.id == METHOD_TYPEID) ktype.kwsk += iap[i++];
					if(!FuncToken(ktype.kwsk, iap, i)) return false;
					if(!stree.stat->funclist.Get((int32_t)iap[i])->kakutei) return false;
					MovRegFun(EAX, *stree.stat->funclist.Get((int32_t)iap[i]));
				}else{
					idx = i + (stree.TypeIdtoSize(typ.id)+sizeof(intptr_t)-1)/sizeof(intptr_t);
					if(tystack.GetTail() != WILDCARD_TYPEID
						&& ((KAKERU_TOKEN <= iap[idx] && iap[idx] <= RSHIFTDAINYUU_TOKEN)
						|| iap[idx] == COMMA_TOKEN || iap[idx] == SHOUKAKKOCLOSE_TOKEN || iap[idx] == COLON_TOKEN
						|| iap[idx] == DAIKAKKOCLOSE_TOKEN || iap[idx] == TENTEN_TOKEN
						|| (iap[idx] == NULL_TOKEN && iap[idx+1] == TENTEN_TOKEN))){
						if(stree.CastConst(typ.id, iap+i, tystack.GetTail(), &castvar) < 0){
							pjtr->root->stat->ss->ErrorMessage.Add(*pjtr->filename, pjtr->gyousuu, L"^G[łB");
							return false;
						}
						if((KAKERU_TOKEN <= iap[idx] && iap[idx] <= OR_TOKEN) || (PULUSDAINYUU_TOKEN <= iap[idx] && iap[idx] <= RSHIFTDAINYUU_TOKEN)){
							ktype.id = tystack.GetTail();
							if(!ConstEnzan(stree, tystack, ktype, castvar, (TokenKind)iap[idx])) return false;
							if(KAKERU_TOKEN <= iap[idx] && iap[idx] <= OR_TOKEN){
								idx++;
							}else{
								ktype.pstre = (SrcTree*)~NULL;
								i = idx - 1;
								break;
							}
							tystack.Pop();
						}else if(iap[idx] == DAINYUU_TOKEN){
							ktype.id = tystack.GetTail();
							tystack += ktype.id;
							ktype.pstre = (SrcTree*)~NULL;
							i = idx - 1;
							break;
						}else{
							if(!KTPush(ktype)) return false;
							ktype.id = tystack.GetTail();
							if(!Teisuu(stree, ktype, (int32_t*)&castvar)) return false;
						}
					}else{
						if(!KTPush(ktype)) return false;
						ktype = typ;
						if(!Teisuu(stree, ktype, iap+i)) return false;
					}
					i = idx - 1;
				}
				ktype.pstre = &stree;
				tystack += ktype.id;
				break;
			case DELEGATE_TOKEN:
				i++;
				PushReg(EDI);
				PushReg(EBP);
				ktype.id = DELEGATE_TYPEID;
				ktype.kwsk = DELEGATE_TOKEN;
				if(!FuncToken(ktype.kwsk, iap, i)) return false;
				PushFadr(*(SrcTree*)iap[i]);
				tystack += ktype.id;
				break;
			case PULUS_TOKEN:
			case MINUS_TOKEN:
			case KAKERU_TOKEN:
			case WARU_TOKEN:
			case AMARI_TOKEN:
			case AND_TOKEN:
			case XOR_TOKEN:
			case OR_TOKEN:
			case LSHIFT_TOKEN:
			case RSHIFT_TOKEN:
			case EQUAL_TOKEN:
			case NOTEQUAL_TOKEN:
			case SHOU_TOKEN:
			case SHOUOREQUAL_TOKEN:
			case DAI_TOKEN:
			case DAIOREQUAL_TOKEN:
				if(!StackEnzan(stree, tystack, ktype, (TokenKind)iap[i])) return false;
				break;
			case EXCLAMATION_TOKEN:
				switch(ktype.id){
				case BYTE_TYPEID: case UBYTE_TYPEID: case SHORT_TYPEID: case USHORT_TYPEID: case CHAR_TYPEID:
				case INT_TYPEID: case ADDRESS_TYPEID: case UINT_TYPEID:
					NotReg(EAX);
					break;
				case LONG_TYPEID: case ULONG_TYPEID:
					NotReg(EAX);
					NotReg(EDX);
					break;
				case BOOL_TYPEID:
					XorRegImm(EAX, 1);
					break;
				default:
					return false;
				}
				break;
			case DIA_TOKEN:
				if(ktype.id != REF_TYPEID && ktype.id != LIST_TYPEID) return false;
				SoushokuTobasi(ktype.kwsk.GetConst(), idx=0);
				if(ktype.kwsk.GetConst()[idx] != REF_TOKEN && ktype.kwsk.GetConst()[idx] != LIST_TOKEN) return false;
				idx++;
				type.Clear();
				type.AddTail(ktype.kwsk.GetConst()+idx, ktype.kwsk.GetLength()-idx);
				PluginCall(RefPos);
				MovRegReg(ESI, EAX);
				tystack.Pop();
				ktype.id = VOID_TYPEID;
				if(!Sanshou(stree, iap, i, tystack, ktype, type, false)) return false;
				break;
			case DAIKAKKOOPEN_TOKEN:
				if(ktype.id != REF_TYPEID && ktype.id != LIST_TYPEID) return false;
				SoushokuTobasi(ktype.kwsk.GetConst(), idx=0);
				if(ktype.kwsk.GetConst()[idx] != REF_TOKEN && ktype.kwsk.GetConst()[idx] != LIST_TOKEN) return false;
				tmpb = ktype.id == LIST_TYPEID;
				idx++;
				type.Clear();
				type.AddTail(ktype.kwsk.GetConst()+idx, ktype.kwsk.GetLength()-idx);
				i++;
				tystack += ADDRESS_TYPEID;
				do{
					if(!MainSwitch(stree, iap, i, tystack, ktype, retcall)) return false;
					i++;
				}while(iap[i] != DAIKAKKOCLOSE_TOKEN && iap[i] != TENTEN_TOKEN);
				if(!JidouCast(stree, tystack, ADDRESS_TYPEID, ktype.id)) return false;
				tystack.Pop();
				ktype.id = ADDRESS_TYPEID;
				if(iap[i] == TENTEN_TOKEN){
					i++;
					if(iap[i] != DAIKAKKOCLOSE_TOKEN) return false;
					(bool)KTPush(ktype);
					LeaSIB(EAX, SIB(0, ESP, ESP), 8);
					PushReg(EAX);
					switch(stree.GetTypeSize(type)){
					case 1: PluginCall(RefSliceS1); break;
					case 2: PluginCall(RefSliceS2); break;
					case 3: PluginCall(RefSliceS3); break;
					case 4: PluginCall(RefSliceS4); break;
					case 5: PluginCall(RefSliceS5); break;
					case 6: PluginCall(RefSliceS6); break;
					case 7: PluginCall(RefSliceS7); break;
					case 8: PluginCall(RefSliceS8); break;
					case 9: PluginCall(RefSliceS9); break;
					case 10: PluginCall(RefSliceS10); break;
					case 11: PluginCall(RefSliceS11); break;
					case 12: PluginCall(RefSliceS12); break;
					case 13: PluginCall(RefSliceS13); break;
					case 14: PluginCall(RefSliceS14); break;
					case 15: PluginCall(RefSliceS15); break;
					case 16: PluginCall(RefSliceS16); break;
					default:
						PushImm(stree.GetTypeSize(type));
						PluginCall(RefSlice);
						break;
					}
					ktype.id = REF_TYPEID;
					ktype.kwsk = REF_TOKEN;
					ktype.kwsk += type;
					tystack.SetLength(tystack.GetLength()-2);
					tystack.Tail() = ktype.id;
				}else{
					(bool)KTPush(ktype);
					switch(stree.GetTypeSize(type)){
					case 1: (tmpb ? PluginCall(ListIdxS1) : PluginCall(RefIdxS1)); break;
					case 2: (tmpb ? PluginCall(ListIdxS2) : PluginCall(RefIdxS2)); break;
					case 3: (tmpb ? PluginCall(ListIdxS3) : PluginCall(RefIdxS3)); break;
					case 4: (tmpb ? PluginCall(ListIdxS4) : PluginCall(RefIdxS4)); break;
					case 5: (tmpb ? PluginCall(ListIdxS5) : PluginCall(RefIdxS5)); break;
					case 6: (tmpb ? PluginCall(ListIdxS6) : PluginCall(RefIdxS6)); break;
					case 7: (tmpb ? PluginCall(ListIdxS7) : PluginCall(RefIdxS7)); break;
					case 8: (tmpb ? PluginCall(ListIdxS8) : PluginCall(RefIdxS8)); break;
					case 9: (tmpb ? PluginCall(ListIdxS9) : PluginCall(RefIdxS9)); break;
					case 10: (tmpb ? PluginCall(ListIdxS10) : PluginCall(RefIdxS10)); break;
					case 11: (tmpb ? PluginCall(ListIdxS11) : PluginCall(RefIdxS11)); break;
					case 12: (tmpb ? PluginCall(ListIdxS12) : PluginCall(RefIdxS12)); break;
					case 13: (tmpb ? PluginCall(ListIdxS13) : PluginCall(RefIdxS13)); break;
					case 14: (tmpb ? PluginCall(ListIdxS14) : PluginCall(RefIdxS14)); break;
					case 15: (tmpb ? PluginCall(ListIdxS15) : PluginCall(RefIdxS15)); break;
					case 16: (tmpb ? PluginCall(ListIdxS16) : PluginCall(RefIdxS16)); break;
					default:
						PushImm(stree.GetTypeSize(type));
						PluginCall(RefIdx);
						break;
					}
					tystack.Pop();
					MovRegReg(ESI, EAX);
					tystack.Pop();
					ktype.id = VOID_TYPEID;
					if(!Sanshou(stree, iap, i, tystack, ktype, type, false)) return false;
				}
				break;
			case NULL_TOKEN:
				i++;
				switch(iap[i]){
				case PULUS_TOKEN:
					switch(ktype.id){
					case BYTE_TYPEID: case UBYTE_TYPEID: case SHORT_TYPEID: case USHORT_TYPEID: case CHAR_TYPEID:
					case INT_TYPEID: case ADDRESS_TYPEID: case UINT_TYPEID: case BOOL_TYPEID:
					case LONG_TYPEID: case ULONG_TYPEID:
						break;
					default:
						return false;
					}
					break;
				case MINUS_TOKEN:
					switch(ktype.id){
					case BYTE_TYPEID: case UBYTE_TYPEID: case SHORT_TYPEID: case USHORT_TYPEID: case CHAR_TYPEID:
					case INT_TYPEID: case ADDRESS_TYPEID: case UINT_TYPEID: case BOOL_TYPEID:
						NegReg(EAX);
						break;
					case LONG_TYPEID: case ULONG_TYPEID:
						NotReg(EAX);
						NotReg(EDX);
						AddImm64(1);
						break;
					case FLOAT_TYPEID: case DOUBLE_TYPEID:
						Fchs();
						break;
					default:
						return false;
					}
					break;
				case ANDAND_TOKEN:
				case OROR_TOKEN:
					if(!AAOO(stree, iap, i, tystack, ktype)) return false;
					break;
				case QUESTION_TOKEN:
					if(!Sankou(stree, iap, i, tystack, ktype)) return false;
					break;
				case MBR_TOKEN:
					if(iap[i+1] == NULL_TOKEN && iap[i+2] == DAINYUU_TOKEN){
						if(IsReadOnlyToken((TokenKind)stree.frp->rettype.GetConst()[0])) return false;
						i += 2;
						typ.id = stree.frp->parent->funcid;
						return Dainyuu(stree, iap, i, tystack, ktype, typ, AT_MEMBER, 0);
					}else{
						if(!KTPush(ktype)) return false;
						MovRegAdr(EAX, AT_MEMBER, 0);
						ktype.id = stree.frp->parent->funcid;
						tystack += ktype.id;
					}
					break;
				case TENTEN_TOKEN:
					if(!JidouCast(stree, tystack, ADDRESS_TYPEID, ktype.id)) return false;
					ktype.id = ADDRESS_TYPEID;
					break;
				case SHARP_TOKEN:
					pty = &stree.frp->funchensuu.GetConst()[~iap[i+(stree.frp == stree.root ? 2 : 1)]].type;
					if(pty->GetConst()[0] == REF_TOKEN && pty->GetConst()[1] == OTHERKIND_TOKEN){
						i += (stree.frp == stree.root ? 2 : 1);
					}else{
						tystack.Pop();
					}
					break;
				case RETURN_TOKEN:
					if((typ.id = TokenTtoTypeId(stree.crp->rettype.GetConst(), idx=0)) == UNKNOWN_TYPEID) return false;
					if(!JidouCast(stree, tystack, typ.id, ktype.id)) return false;
					ktype.id = typ.id;
					if(tystack.GetLength() > 0){
						if(ktype.id == VOID_TYPEID) return false;
						tystack.Pop();
					}
					if(iap[i+1] != RETURN_TOKEN){
						if(stree.frp == stree.root){
							bp1 = PushCadr(0);
							PushImm((int32_t)pjtr->root->stat->ss);
							PluginCall(PutGbld);
							glbbp = Jump(0);
							*(int32_t *)(pjtr->ntvcode.GetConst()+bp1) += pjtr->ntvcode.GetLength();
							PushReg(ESI);
							PushReg(EBX);
						}else{
							if(!KTPush(ktype)) return false;
							ktype.id = VOID_TYPEID;
						}
					}
					break;
				default:
					return false;
				}
				break;
			case RETURN_TOKEN:
				ktype.id = TokenTtoTypeId(stree.crp->rettype.GetConst(), idx=0);
				if(iap[i-1] != RETURN_TOKEN){
					if(stree.frp == stree.root){
						*(int32_t*)(pjtr->ntvcode.GetConst()+glbbp) += pjtr->ntvcode.GetLength();
					}else{
						if(!KTPop(ktype)) return false;
					}
				}
				if(stree.frp == stree.root || (stree.frp->parent == stree.root && stree.crp->selftype != DELEGATE_BLOCK)){
					PopReg(EBX);
					PopReg(ESI);
				}
				if(stree.frp != stree.root && stree.crp->selftype != DELEGATE_BLOCK){
					if(retcall == NULL){
						Return(Aligner(stree.GetMemberSize()), true);
					}else{
						KansuStackClear(stree);
						if(retcall->byteadress == 0){
							retcall->backpatch += Jump(0);
						}else{
							Jump(retcall->byteadress);
						}
					}
				}else{
					if(stree.crp->selftype == DELEGATE_BLOCK){
						PopReg(EBP);
						PopReg(EDI);
						Return(0, false);
					}else{
						Return(0, true);
					}
				}
				break;
			case SHARP_TOKEN:
			case SEMICOLON_TOKEN:
				if(!KTDrop(ktype)) return false;
				tystack.Pop();
				break;
			case LEN_TOKEN:
				switch(ktype.id){
				case REF_TYPEID:
				case LIST_TYPEID:
					SoushokuTobasi(ktype.kwsk.GetConst(), idx=0);
					if(ktype.kwsk.GetConst()[idx] != REF_TOKEN && ktype.kwsk.GetConst()[idx] != LIST_TOKEN) return false;
					idx++;
					type.Clear();
					type.AddTail(ktype.kwsk.GetConst()+idx, ktype.kwsk.GetLength()-idx);
					switch(stree.GetTypeSize(type)){
					case 1: PluginCall(RefLenS1); break;
					case 2: PluginCall(RefLenS2); break;
					case 3: PluginCall(RefLenS3); break;
					case 4: PluginCall(RefLenS4); break;
					case 5: PluginCall(RefLenS5); break;
					case 6: PluginCall(RefLenS6); break;
					case 7: PluginCall(RefLenS7); break;
					case 8: PluginCall(RefLenS8); break;
					case 9: PluginCall(RefLenS9); break;
					case 10: PluginCall(RefLenS10); break;
					case 11: PluginCall(RefLenS11); break;
					case 12: PluginCall(RefLenS12); break;
					case 13: PluginCall(RefLenS13); break;
					case 14: PluginCall(RefLenS14); break;
					case 15: PluginCall(RefLenS15); break;
					case 16: PluginCall(RefLenS16); break;
					default:
						PushImm(stree.GetTypeSize(type));
						PluginCall(RefLen);
						break;
					}
					break;
				case DYNREF_TYPEID:
				case DYNLIST_TYPEID:
					PushImm((int32_t)pjtr->root);
					PluginCall(DynRefLen);
					break;
				default:
					return false;
				}
				ktype.id = ADDRESS_TYPEID;
				tystack.Tail() = ktype.id;
				break;
			case IDNAME_TOKEN:
				if(!JidouCast(stree, tystack, INT_TYPEID, ktype.id)) return false;
				KTPush(ktype);
				i++;
				(bool)MovRegAdr(EAX, (stree.frp == stree.root ? AT_GLOBAL : AT_LOCAL),
					(stree.frp == stree.root ? stree.sonota.golbalgeta : 0) + stree.crp->GetMemberOffset(iap[i]));
				PushReg(EAX);
				PushImm((int32_t)pjtr->root);
				PluginCall(IdName);
				(bool)PushHnsRef((stree.frp == stree.root ? AT_GLOBAL : AT_LOCAL),
					(stree.frp == stree.root ? stree.sonota.golbalgeta : 0) + stree.crp->GetMemberOffset(iap[i]), false);
				ktype.id = REF_TYPEID;
				ktype.kwsk = REF_TOKEN;
				ktype.kwsk += CHAR_TOKEN;
				tystack.Tail() = ktype.id;
				break;
			case TYPESIZE_TOKEN:
				if(tystack.GetTail() == UNKNOWN_TYPEID || (ktype.id != DYNREF_TYPEID && ktype.id != DYNLIST_TYPEID)){
					return false;
				}
				PushImm((int32_t)pjtr->root);
				PluginCall(DynRefTypeSize);
				tystack.Tail() = ktype.id = ADDRESS_TYPEID;
				break;
			case TYPEID_TOKEN:
				if(tystack.GetTail() == UNKNOWN_TYPEID || (ktype.id != DYNREF_TYPEID && ktype.id != DYNLIST_TYPEID)){
					return false;
				}
				AddRegImm(ESP, 12);
				PopReg(EAX);
				tystack.Tail() = ktype.id = INT_TYPEID;
				break;
			case CAST_TOKEN:
				if(tystack.GetTail() == UNKNOWN_TYPEID || (ktype.id != DYNREF_TYPEID && ktype.id != DYNLIST_TYPEID)){
					return false;
				}
				typ.id = ktype.id;
				i++;
				if(iap[i] != SHOUKAKKOOPEN_TOKEN) return false;
				i++;
				do{
					if(!MainSwitch(stree, iap, i, tystack, ktype, retcall)) return false;
					i++;
					if(iap[i] == SHOUKAKKOCLOSE_TOKEN) return false;
				}while(iap[i] != COMMA_TOKEN);
				i++;
				if(iap[i] != SHOUKAKKOCLOSE_TOKEN) return false;
				if(tystack.GetTail() != UNKNOWN_TYPEID || (ktype.id != REF_TYPEID && (typ.id == DYNREF_TYPEID || ktype.id != LIST_TYPEID))){
					return false;
				}
				SoushokuTobasi(ktype.kwsk.GetConst(), idx=0);
				if(ktype.kwsk.GetConst()[idx] != REF_TOKEN && ktype.kwsk.GetConst()[idx] != LIST_TOKEN) return false;
				idx++;
				if((typ.id = TokenTtoTypeId(ktype.kwsk.GetConst(), idx)) == UNKNOWN_TYPEID) return false;
				PushCadr(0);
				PushImm(typ.id);
				PushImm((int32_t)pjtr->root);
				PluginCall(DynRefGet);
				tystack.Pop();
				tystack.Tail() = ktype.id = BOOL_TYPEID;
				break;
			case WAIT_TOKEN:
				i++;
				if(iap[i] != SHOUKAKKOOPEN_TOKEN) return false;
				do{
					i++;
					tystack += UNKNOWN_TYPEID;
					do{
						if(!MainSwitch(stree, iap, i, tystack, ktype, retcall)) return false;
						i++;
					}while(iap[i] != SHOUKAKKOCLOSE_TOKEN && iap[i] != COMMA_TOKEN);
					if(tystack.GetTail() == UNKNOWN_TYPEID) return false;
					if(ktype.id == REF_TYPEID || ktype.id == LIST_TYPEID || ktype.id == DYNREF_TYPEID || ktype.id == DYNLIST_TYPEID){
						PushReg(ESP);
						PluginCall(RefLock);
						PushReg(ESP);
						PluginCall(RefUnlock);
						if(ktype.id == REF_TYPEID || ktype.id == LIST_TYPEID){
							AddRegImm(ESP, 12);
						}else{
							AddRegImm(ESP, 16);
						}
					}else if(ENDTHREAD_TYPEID <= ktype.id && ktype.id < 0){
						PushReg(EAX);
						PluginCall(ThreadWait);
					}else{
						return false;
					}
					tystack.SetLength(tystack.GetLength()-2);
					ktype.id = VOID_TYPEID;
				}while(iap[i] != SHOUKAKKOCLOSE_TOKEN);
				break;
			case CONSTEVAL_TOKEN:
				i++;
				if(iap[i] != SHOUKAKKOOPEN_TOKEN) return false;
				i++;
				tystack += UNKNOWN_TYPEID;
				do{
					if(!MainSwitch(stree, iap, i, tystack, ktype, retcall)) return false;
					i++;
					if(iap[i] == SHOUKAKKOCLOSE_TOKEN) return false;
				}while(iap[i] != COMMA_TOKEN);
				i++;
				if(iap[i] != COMMA_TOKEN) return false;
				i++;
				if(tystack.GetTail() != UNKNOWN_TYPEID) return false;
				typ = ktype;
				ktype.id = VOID_TYPEID;
				do{
					if(!MainSwitch(stree, iap, i, tystack, ktype, retcall)) return false;
					i++;
				}while(iap[i] != SHOUKAKKOCLOSE_TOKEN);
				type = REF_TOKEN;
				type += CONST_TOKEN;
				type += CHAR_TOKEN;
				if(!stree.YuruiKataCheck(ktype.kwsk, type, *pjtr->filename, pjtr->gyousuu)) return false;
				SoushokuTobasi(typ.kwsk.GetConst(), idx=0);
				indt = idx;
				switch(TokenTtoTypeId(typ.kwsk.GetConst(), idx)){
				case REF_TYPEID:
				case LIST_TYPEID:
				case DYNREF_TYPEID:
				case DYNLIST_TYPEID:
					pjtr->root->stat->ss->ErrorMessage.Add(*pjtr->filename, pjtr->gyousuu, L"constevalɎQƌ^͎g܂B");
					return false;
				case METHOD_TYPEID:
					idx++;
				case FUNC_TYPEID:
				case DELEGATE_TYPEID:
					type.Clear();
					if(!FuncToken(type, typ.kwsk.GetConst(), idx)) return false;
					break;
				case UNKNOWN_TYPEID:
					return false;
				}
				tmpi = idx - indt;
				for(idx--; idx >= indt; idx--) PushImm(typ.kwsk.GetConst()[idx]);
				PushImm((intptr_t)&stree);
				PushCadr(0);
				PluginCall(ConstEval);
				AddRegImm(ESP, 4 + 4 + tmpi*4 + 12 + 4);
				tystack.SetLength(tystack.GetLength()-2);
				tystack.Tail() = ktype.id = BOOL_TYPEID;
				break;
			case CHUUKAKKOOPEN_TOKEN:
				i++;
				pst = stree.children.GetConst()[iap[i]];
				switch(pst->selftype){
				case NORMAL_BLOCK:
					if(!pjtr->ncom.FuncTreeCompile(*pst)) return false;
					break;
				case BRANCH_BLOCK:
					if(!pjtr->brcom.FuncTreeCompile(*pst)) return false;
					break;
				case LOOP_BLOCK:
					if(!pjtr->lpcom.FuncTreeCompile(*pst)) return false;
					break;
				case LOCK_BLOCK:
					i++;
					if(iap[i] != SHOUKAKKOOPEN_TOKEN) return false;
					indt = 0;
					do{
						i++;
						tystack += UNKNOWN_TYPEID;
						do{
							if(!MainSwitch(stree, iap, i, tystack, ktype, retcall)) return false;
							i++;
						}while(iap[i] != SHOUKAKKOCLOSE_TOKEN && iap[i] != COMMA_TOKEN);
						if(
							tystack.GetTail() == UNKNOWN_TYPEID || tystack.GetTail() == BOOL_TYPEID
							|| (ktype.id != REF_TYPEID && ktype.id != LIST_TYPEID && ktype.id != DYNREF_TYPEID && ktype.id != DYNLIST_TYPEID))
						{
							return false;
						}
						tystack.Pop();
						tystack.Tail() = ktype.id;
						if(ktype.id == DYNREF_TYPEID || ktype.id == DYNLIST_TYPEID){
							return false;
						}else{
							PushReg(ESP);
							PluginCall(RefLock);
							PushReg(ESP);
							PluginCall(RefCntUp);
							bp1 = PushCadr(0);
							bp2 = Jump(0);
							*(int32_t *)(pjtr->ntvcode.GetConst()+bp1) += pjtr->ntvcode.GetLength();
							LeaSIB(ESI, SIB(0, ESP, ESP), 4);//4̓^[AhX
							PushReg(ESI);
							PluginCall(RefUnlock);
							if(!RefCountDown(stree, AT_SANSHOU, 0, ktype.kwsk, false)) return false;
							Return(12, false);
							*(int32_t *)(pjtr->ntvcode.GetConst()+bp2) += pjtr->ntvcode.GetLength();
						}
						indt++;
					}while(iap[i] != SHOUKAKKOCLOSE_TOKEN);
					pst->hikisuucount = (int)indt;
					if(!pjtr->lkcom.FuncTreeCompile(*pst)) return false;
					tystack.SetLength(tystack.GetLength()-indt);
					break;
				case SWITCH_BLOCK:
					i++;
					if(iap[i] != SHOUKAKKOOPEN_TOKEN) return false;
					i++;
					tystack += WILDCARD_TYPEID;
					do{
						if(!MainSwitch(stree, iap, i, tystack, ktype, retcall)) return false;
						i++;
					}while(iap[i] != SHOUKAKKOCLOSE_TOKEN);
					if(ktype.id == VOID_TYPEID) return false;
					tystack.Pop();
					tystack.Tail() = ktype.id;
					if(ktype.id < 0 || (ktype.id <= ENDCLASS_TYPEID && stree.stat->funclist.Get(ktype.id)->selftype != ENUM_BLOCK)) return false;
					pst->extswitch->swtype = ktype.id;
					(bool)KTPush(ktype);
					ktype.id = VOID_TYPEID;
					if(!pjtr->swcom.FuncTreeCompile(*pst)) return false;
					tystack.Pop();
					break;
				case DELEGATE_BLOCK:
					bp1 = Jump(0);
					if(!pjtr->dgcom.FuncTreeCompile(*pst)) return false;
					*(intptr_t *)(pjtr->ntvcode.GetConst()+bp1) += pjtr->ntvcode.GetLength();
					ktype.pstre = &stree;
					break;
				default:
					return false;
				}
				i++;
				if(iap[i] != CHUUKAKKOCLOSE_TOKEN) return false;
				break;
			case SHOUKAKKOOPEN_TOKEN:
				i++;
				if(iap[i] < 0){
					pst = stree.stat->funclist.Get((int32_t)~iap[i]);
					i++;
					tmpb = stree.frp != stree.root && !stree.frp->touka;
					if(tmpb){
						if(!KTPush(ktype)) return false;
						ktype.id = VOID_TYPEID;
						PushReg(EDI);
					}
					if(Kansuu(stree, iap, i, tystack, ktype, *pst, false) < 0) return false;
					if(tmpb) (bool)MovRegAdr(EDI, AT_LOCAL, 0);
					FuncCall(*pst);
					if(tmpb) PopReg(EDI);
				}else{
					typ.id = TokenTtoTypeId(iap, i);
					if(!Cast(stree, tystack, typ.id, ktype.id)) return false;
				}
				break;
			case KAKKOCOLOOPEN_TOKEN:
				i++;
				tmpb = ktype.id == DELEGATE_TYPEID;
				tystack.Pop();
				if((tmpi = KansuuPointer(stree, iap, i, tystack, ktype, stree.frp, waketa)) < 0) return false;
				if(stree.glbconstant && waketa.GetConst()[0].GetConst()[0] != CONST_TOKEN) return false;
				if(stree.frp->rettype.GetConst()[0] == PROPERTY_TOKEN && !IsReadOnlyToken((TokenKind)waketa.GetConst()[0].GetConst()[0])) return false;
				if(tmpi > 0){
					if(tmpb){
						MovRegSIB(EAX, SIB(0, ESP, ESP), tmpi+Aliszof<intptr_t>());
						PushReg(EAX);
						MovRegSIB(EAX, SIB(0, ESP, ESP), tmpi+Aliszof<intptr_t>());
					}else{
						MovRegSIB(EAX, SIB(0, ESP, ESP), tmpi);
					}
					CallReg(EAX);
					if(!tmpb) AddRegImm(ESP, 4);
				}else{
					CallStk();
				}
				break;
			case LIB_TOKEN:
			case TILDE_TOKEN:
				tmptk = (TokenKind)iap[i];
				i++;
				if(tmptk == LIB_TOKEN) i += 2;
				if(iap[i] == SHOUKAKKOOPEN_TOKEN){
					i++;
					if(iap[i] >= 0) return false;
					pst = stree.stat->funclist.Get((int32_t)~iap[i]);
					i++;
					if(stree.glbconstant && pst->rettype.GetConst()[0] != CONST_TOKEN) return false;
					if((typ.id = TokenTtoTypeId(pst->rettype.GetConst(), idx=0)) == UNKNOWN_TYPEID) return false;
					if(stree.frp != stree.root && typ.id == VOID_TYPEID && IsVoidHikinashiRet(stree, iap, i, *pst)){
						if(tystack.GetLength() > 0) return false;
						if(TokenTtoTypeId(stree.frp->rettype.GetConst(), idx=0) != VOID_TYPEID) return false;
						retcall = pst;
					}else{
						if(Kansuu(stree, iap, i, tystack, ktype, *pst, false) < 0) return false;
						FuncCall(*pst);
					}
				}else{
					if(iap[i] >= 0) return MainSwitch(stree, iap, i, tystack, ktype, retcall);
					indt = ~iap[i];
					pst = (tmptk == LIB_TOKEN ? (SrcTree*)iap[i-2] : stree.root);
					cnstf = stree.glbconstant || (tmptk == LIB_TOKEN ? IsReadOnlyToken((TokenKind)pst->funchensuu.GetConst()[indt].type.GetConst()[0]) : false);
					tmpi = pst->sonota.golbalgeta;
					for(;;){
						tmpi += pst->GetMemberOffset(indt);
						if(iap[i+1] != POINT_TOKEN) break;
						i += 2;
						if(iap[i] == SHOUKAKKOOPEN_TOKEN){
							i++;
							if(iap[i] >= 0) return false;
							pst = stree.stat->funclist.Get((int32_t)~iap[i]);
							i++;
							if(!pst->kakutei && (pst = pst->GetIjousaki(tmpi, stree, iap+i)) == NULL) return false;
							if(stree.frp->rettype.GetConst()[0] == CONST_TOKEN && pst->rettype.GetConst()[0] != CONST_TOKEN) return false;
							if(cnstf && !IsReadOnlyToken((TokenKind)pst->rettype.GetConst()[0])) return false;
							if(!KTPush(ktype)) return false;
							ktype.id = VOID_TYPEID;
							PushReg(EDI);
							if(Kansuu(stree, iap, i, tystack, ktype, *pst, false) < 0) return false;
							(bool)MovRegAdr(EDI, AT_GLOBAL, tmpi);
							FuncCall(*pst);
							PopReg(EDI);
							break;
						}
						if(iap[i] >= 0) return false;
						SoushokuTobasi(pst->funchensuu.GetConst()[indt].type.GetConst(), idx=0);
						if(pst->funchensuu.GetConst()[indt].type.GetConst()[idx] != CLASS_TOKEN
							&& pst->funchensuu.GetConst()[indt].type.GetConst()[idx] != ENUM_TOKEN) return false;
						idx++;
						typ.id = (int32_t)pst->funchensuu.GetConst()[indt].type.GetConst()[idx];
						pst = stree.stat->funclist.Get(typ.id);
						indt = ~iap[i];
						cnstf = cnstf || IsReadOnlyToken((TokenKind)pst->funchensuu.GetConst()[indt].type.GetConst()[0]);
					}
					if(iap[i] >= 0) break;
					if(!Hensuu(stree, iap, i, tystack, ktype, AT_GLOBAL, tmpi, pst, indt, pst->funchensuu.GetConst()[indt].type, cnstf)) return false;
					break;
				}
				break;
			case MBR_TOKEN:
				i++;
				if(iap[i] == SHOUKAKKOOPEN_TOKEN){
					i++;
					if(iap[i] >= 0) return false;
					pst = stree.stat->funclist.Get(~iap[i]);
					i++;
					if(stree.glbconstant && pst->rettype.GetConst()[0] != CONST_TOKEN) return false;
					if(stree.frp->rettype.GetConst()[0] == PROPERTY_TOKEN && !IsReadOnlyToken((TokenKind)pst->rettype.GetConst()[0])) return false;
					if((typ.id = TokenTtoTypeId(pst->rettype.GetConst(), idx=0)) == UNKNOWN_TYPEID) return false;
					if(stree.frp != stree.root && typ.id == VOID_TYPEID && IsVoidHikinashiRet(stree, iap, i, *pst)){
						if(tystack.GetLength() > 0) return false;
						if(TokenTtoTypeId(stree.frp->rettype.GetConst(), idx=0) != VOID_TYPEID) return false;
						retcall = pst;
					}else{
						if(Kansuu(stree, iap, i, tystack, ktype, *pst, false) < 0) return false;
						FuncCall(*pst);
					}
				}else{
					if(iap[i] >= 0) return MainSwitch(stree, iap, i, tystack, ktype, retcall);
					indt = ~iap[i];
					pst = stree.frp->parent;
					cnstf = IsReadOnlyToken((TokenKind)stree.frp->rettype.GetConst()[0]);
					if(pst->tpcount <= indt && indt < pst->tpcount+pst->hikisuucount
						&& pst->funchensuu.GetConst()[indt].type.GetTail() == ~DAINYUU_TOKEN)
					{
						(bool)MovRegHns(ESI, AT_MEMBER, pst->GetMemberOffset(indt), false);
						type = pst->funchensuu.GetConst()[indt].type;
						type.Pop();
						if(!Sanshou(stree, iap, i, tystack, ktype, type, cnstf)) return false;
					}else{
						cnstf = cnstf || indt < pst->tpcount+pst->hikisuucount;
						tmpi = 0;
						for(;;){
							tmpi += pst->GetMemberOffset(indt);
							if(iap[i+1] != POINT_TOKEN) break;
							i += 2;
							if(iap[i] == SHOUKAKKOOPEN_TOKEN){
								i++;
								if(iap[i] >= 0) return false;
								pst = stree.stat->funclist.Get(~iap[i]);
								i++;
								if(!pst->kakutei && (pst = pst->GetIjousaki(tmpi, stree, iap+i)) == NULL) return false;
								if(stree.frp->rettype.GetConst()[0] == CONST_TOKEN && pst->rettype.GetConst()[0] != CONST_TOKEN) return false;
								if(cnstf && !IsReadOnlyToken((TokenKind)pst->rettype.GetConst()[0])) return false;
								if(Kansuu(stree, iap, i, tystack, ktype, *pst, false) < 0) return false;
								if(tmpi > 0) AddRegImm(EDI, tmpi);
								FuncCall(*pst);
								if(tmpi > 0) SubRegImm(EDI, tmpi);
								break;
							}
							if(iap[i] >= 0) return false;
							SoushokuTobasi(pst->funchensuu.GetConst()[indt].type.GetConst(), idx=0);
							if(pst->funchensuu.GetConst()[indt].type.GetConst()[idx] != CLASS_TOKEN
								&& pst->funchensuu.GetConst()[indt].type.GetConst()[idx] != ENUM_TOKEN) return false;
							idx++;
							typ.id = (int32_t)pst->funchensuu.GetConst()[indt].type.GetConst()[idx];
							pst = stree.stat->funclist.Get(typ.id);
							indt = ~iap[i];
							cnstf = cnstf || IsReadOnlyToken((TokenKind)pst->funchensuu.GetConst()[indt].type.GetConst()[0]);
						}
						if(iap[i] >= 0) break;
						if(!Hensuu(stree, iap, i, tystack, ktype, AT_MEMBER, tmpi, pst, indt, pst->funchensuu.GetConst()[indt].type, cnstf)) return false;
					}
				}
				break;
			default:
				if(iap[i] >= 0) return false;
				indt = ~iap[i];
				pst = &stree;
				cnstf = false;
				if((indt < stree.frp->tpcount+stree.frp->hikisuucount || (stree.crp->tpcount <= indt && indt < stree.crp->tpcount+stree.crp->hikisuucount))
					&& stree.frp->funchensuu.GetConst()[indt].type.GetTail() == ~DAINYUU_TOKEN)
				{
					(bool)MovRegHns(ESI, AT_LOCAL, stree.crp->GetMemberOffset(indt), false);
					type = stree.frp->funchensuu.GetConst()[indt].type;
					type.Pop();
					if(!Sanshou(stree, iap, i, tystack, ktype, type, cnstf)) return false;
				}else{
					cnstf = cnstf || indt < stree.frp->tpcount+stree.frp->hikisuucount || (stree.crp->tpcount <= indt && indt < stree.crp->tpcount+stree.crp->hikisuucount);
					indt = ~iap[i];
					tmpi = stree.crp->GetMemberOffset(indt);
					for(;;){
						if(iap[i+1] != POINT_TOKEN) break;
						i += 2;
						if(iap[i] == SHOUKAKKOOPEN_TOKEN){
							i++;
							if(iap[i] >= 0) return false;
							pst = stree.stat->funclist.Get(~iap[i]);
							i++;
							if(!pst->kakutei && (pst = pst->GetIjousaki(tmpi, stree, iap+i)) == NULL) return false;
							if(stree.frp->rettype.GetConst()[0] == CONST_TOKEN && pst->rettype.GetConst()[0] != CONST_TOKEN) return false;
							if(cnstf && !IsReadOnlyToken((TokenKind)pst->rettype.GetConst()[0])) return false;
							if(!KTPush(ktype)) return false;
							ktype.id = VOID_TYPEID;
							PushReg(EDI);
							if(Kansuu(stree, iap, i, tystack, ktype, *pst, false) < 0) return false;
							(bool)MovRegAdr(EDI, AT_LOCAL, tmpi);
							FuncCall(*pst);
							PopReg(EDI);
							break;
						}
						if(iap[i] >= 0) return false;
						SoushokuTobasi(pst->frp->funchensuu.GetConst()[indt].type.GetConst(), idx=0);
						if(pst->frp->funchensuu.GetConst()[indt].type.GetConst()[idx] != CLASS_TOKEN
							&& pst->frp->funchensuu.GetConst()[indt].type.GetConst()[idx] != ENUM_TOKEN) return false;
						idx++;
						typ.id = (int32_t)pst->frp->funchensuu.GetConst()[indt].type.GetConst()[idx];
						pst = stree.stat->funclist.Get(typ.id);
						indt = ~iap[i];
						cnstf = cnstf || IsReadOnlyToken((TokenKind)pst->funchensuu.GetConst()[indt].type.GetConst()[0]);
						tmpi += pst->GetMemberOffset(indt);
					}
					if(iap[i] >= 0) break;
					if(!Hensuu(stree, iap, i, tystack, ktype, AT_LOCAL, tmpi, pst, indt, pst->frp->funchensuu.GetConst()[indt].type, cnstf)) return false;
				}
				break;
			}
			return true;
		}
		bool If(SrcTree &stree, intptr_t &j)
		{
			intptr_t len, bp1, i;
			const intptr_t *iap;
			KuwashiiType ktype;
			PWCArray<int32_t> tystack;
			SrcTree *retcall = NULL;
			tystack.Clear();
			iap = stree.token.GetConst()[j].GetConst();
			pjtr->gyousuu = stree.gyo.GetConst()[j];
			ktype.id = VOID_TYPEID;
			i = 1;
			if(iap[i] != SHOUKAKKOOPEN_TOKEN) return false;
			i++;
			tystack += BOOL_TYPEID;
			do{
				if(!MainSwitch(stree, iap, i, tystack, ktype, retcall)) return false;
				i++;
			}while(iap[i] != SHOUKAKKOCLOSE_TOKEN);
			if(ktype.id != BOOL_TYPEID) return false;
			bp1 = FalseJump(0);
			tystack.SetLength(tystack.GetLength()-2);
			j++;
			iap = stree.token.GetConst()[j].GetConst();
			len = stree.token.GetConst()[j].GetLength();
			pjtr->gyousuu = stree.gyo.GetConst()[j];
			ktype.id = VOID_TYPEID;
			if(!KoubunSwitch(stree, iap, len, j)) return false;
			*(int32_t *)(pjtr->ntvcode.GetConst()+bp1) += pjtr->ntvcode.GetLength();
			return true;
		}
		void YobunPoper()
		{
			if(pjtr->yobunipop == 0) return;
			AddRegImm(ESP, pjtr->yobunipop);
			pjtr->yobunipop = 0;
		}
		virtual bool MainLoop(SrcTree &stree, const intptr_t *const iap, const intptr_t len, intptr_t &i, SrcTree *&retcall)
		{
			KuwashiiType ktype;
			PWCArray<int32_t> tystack;
			tystack.Clear();
			ktype.id = VOID_TYPEID;
			for(; i < len; i++){
				if(!MainSwitch(stree, iap, i, tystack, ktype, retcall)) return false;
			}
			return true;
		}
		virtual bool DefDel(SrcTree &stree)
		{
			intptr_t i;
			KuwashiiType ktype;
			PWCArray<int32_t> tystack;
			SrcTree *retcall = NULL;
			ktype.id = VOID_TYPEID;
			for(i = 0; i < stree.defdel.GetLength(); i++){
				if(!MainSwitch(stree, stree.defdel.GetConst(), i, tystack, ktype, retcall)) return false;
			}
			return true;
		}
		virtual bool KoubunSwitch(SrcTree &stree, const intptr_t *const iap, const intptr_t len, intptr_t &j)
		{
			intptr_t i;
			SrcTree *retcall = NULL;
			if(iap[0] == IF_TOKEN){
				if(!If(stree, j)) return false;
			}else{
				i = 0;
				if(!MainLoop(stree, iap, len, i, retcall)) return false;
			}
			return true;
		}
	};
	class FuncCompi : public Compi
	{
	public:
		bool FuncTreeCompile(SrcTree &stree)
		{
			intptr_t i, j, len, glbbp, bp;
			KuwashiiType ktype;
			PWCArray<int32_t> tystack;
			PWCArray<wchar_t> tmps;
			const intptr_t *iap;
			if(!stree.kakutei){
				if(stree.GetIjousaki(len, stree, NULL) != NULL){
					for(i = 0; i < stree.subfunc.GetLength(); i++){
						if(!FuncTreeCompile(*stree.subfunc.GetConst()[i])) return false;
					}
					return true;
				}
				pjtr->root->stat->ss->ErrorMessage.Add(stree.srce->filename, stree.topsrcgyo, L"`łB");
				return false;
			}
			if(stree.selftype == ENUM_BLOCK) return true;
			if(stree.selftype == CLASS_BLOCK || (stree.tpcount > 0 && stree.funchensuu.GetConst()[stree.tpcount-1].type.GetLength() <= 1)){
				for(i = 0; i < stree.subfunc.GetLength(); i++){
					if(!FuncTreeCompile(*stree.subfunc.GetConst()[i])) return false;
				}
				return true;
			}
			pjtr->filename = &stree.srce->filename;
			stree.byteadress = pjtr->ntvcode.GetLength();
			if(tmps = L"break", stree.myname == tmps){
				stree.parent->deladress = stree.byteadress;
				if(&stree != stree.root && stree.parent->junkandata.GetLength() > 0){
					pjtr->root->stat->ss->CircularGC.SetPLDestructor(stree.parent->sonota.junkanid, stree.byteadress);
				}
			}
			PBackpatch(stree.backpatch, stree.byteadress);
			if(&stree != stree.root) KansuStackSet(stree);
			if(&stree == stree.root || stree.parent == stree.root){
				PushReg(ESI);
				PushReg(EBX);
			}
			for(j = 0; j < stree.token.GetLength(); j++){
				iap = stree.token.GetConst()[j].GetConst();
				len = stree.token.GetConst()[j].GetLength();
				if(len == 0) continue;
				pjtr->gyousuu = stree.gyo.GetConst()[j];
				if(!KoubunSwitch(stree, iap, len, j)){
					if(pjtr->root->stat->ss->ErrorMessage.mes.GetLength() == 1) pjtr->root->stat->ss->ErrorMessage.Add(*pjtr->filename, pjtr->gyousuu, L"RpCG[łB");
					return false;
				}
			}
			if(stree.selftype == FUNC_BLOCK && stree.rettype.GetTail() != VOID_TOKEN){
				if(stree.token.GetLength() <= 0 || stree.token.GetConst()[j-1].GetConst()[len-1] != RETURN_TOKEN
					|| (stree.token.GetLength() >= 2 && stree.token.GetConst()[j-2].GetConst()[0] == IF_TOKEN))
				{
					pjtr->root->stat->ss->ErrorMessage.Add(*pjtr->filename, pjtr->gyousuu, L"return܂B");
					return false;
				}
			}else{
				ktype.id = VOID_TYPEID;
				if(&stree == stree.root && stree.defdel.GetLength() > 0){
					bp = PushCadr(0);
					PushImm((int32_t)pjtr->root->stat->ss);
					PluginCall(PutGbld);
					glbbp = Jump(0);
					*(int32_t *)(pjtr->ntvcode.GetConst()+bp) += pjtr->ntvcode.GetLength();
					PushReg(ESI);
					PushReg(EBX);
				}
				if(!DefDel(stree)){
					pjtr->root->stat->ss->ErrorMessage.Add(*pjtr->filename, pjtr->gyousuu, L"RpCG[B");
					return false;
				}
				if(&stree == stree.root){
					if(stree.defdel.GetLength() > 0) *(int32_t*)(pjtr->ntvcode.GetConst()+glbbp) += pjtr->ntvcode.GetLength();
					PopReg(EBX);
					PopReg(ESI);
					Return(0, true);
				}else{
					if(stree.parent == stree.root){
						PopReg(EBX);
						PopReg(ESI);
					}
					Return(Aligner(stree.GetMemberSize()), true);
				}
			}
			for(i = 0; i < stree.subfunc.GetLength(); i++){
				if(!FuncTreeCompile(*stree.subfunc.GetConst()[i])) return false;
			}
			return true;
		}
	};
	class NormalCompi : public Compi
	{
	protected:
		bool Break(SrcTree &stree, const intptr_t *const iap, const intptr_t len, intptr_t &i, PWCArray<int32_t> &tystack, KuwashiiType &ktype, SrcTree *&retcall)
		{
			i++;
			if(stree.breakin) stree.breakpatch += Call(0);
			while(iap[i] < 0 || iap[i] == TILDE_TOKEN || iap[i] == MBR_TOKEN){
				for(; ; i++){
					if(!MainSwitch(stree, iap, i, tystack, ktype, retcall)) return false;
					if(iap[i] == SEMICOLON_TOKEN) break;
				}
				i++;
			}
			if(iap[i] == COMMA_TOKEN){
				i++;
				switch(stree.parent->selftype){
				case FUNC_BLOCK:
					if(!pjtr->fcom.MainLoop(*stree.parent, iap, len, i, retcall)) return false;
					break;
				case NORMAL_BLOCK:
					if(!pjtr->ncom.MainLoop(*stree.parent, iap, len, i, retcall)) return false;
					break;
				case LOCK_BLOCK:
					if(!pjtr->lkcom.MainLoop(*stree.parent, iap, len, i, retcall)) return false;
					break;
				case SWITCH_BLOCK:
					if(!pjtr->swcom.MainLoop(*stree.parent, iap, len, i, retcall)) return false;
					break;
				case BRANCH_BLOCK:
					if(!pjtr->brcom.MainLoop(*stree.parent, iap, len, i, retcall)) return false;
					break;
				case LOOP_BLOCK:
					if(!pjtr->lpcom.MainLoop(*stree.parent, iap, len, i, retcall)) return false;
					break;
				case DELEGATE_BLOCK:
					if(!pjtr->dgcom.MainLoop(*stree.parent, iap, len, i, retcall)) return false;
					break;
				default:
					return false;
				}
			}else{
				if(iap[i] != SEMICOLON_TOKEN) return false;
				i++;
			}
			YobunPoper();
			stree.backpatch += Jump(0);
			return true;
		}
	public:
		virtual bool MainLoop(SrcTree &stree, const intptr_t *const iap, const intptr_t len, intptr_t &i, SrcTree *&retcall)
		{
			KuwashiiType ktype;
			PWCArray<int32_t> tystack;
			tystack.Clear();
			ktype.id = VOID_TYPEID;
			for(; i < len; i++){
				if(iap[i] == BREAK_TOKEN){
					if(!Break(stree, iap, len, i, tystack, ktype, retcall)) return false;
				}else{
					if(!MainSwitch(stree, iap, i, tystack, ktype, retcall)) return false;
				}
			}
			return true;
		}
		virtual bool KoubunSwitch(SrcTree &stree, const intptr_t *const iap, const intptr_t len, intptr_t &j)
		{
			SrcTree *retcall = NULL;
			if(iap[0] == BREAK_TOKEN && iap[1] == COLON_TOKEN){
				stree.breakpatch += Call(0);
				if(!DefDel(stree)) return false;
				stree.backpatch += Jump(0);
				PBackpatch(stree.breakpatch, pjtr->ntvcode.GetLength());
			}else{
				if(!Compi::KoubunSwitch(stree, iap, len, j)) return false;
			}
			return true;
		}
		bool FuncTreeCompile(SrcTree &stree)
		{
			intptr_t len, j;
			PWCArray<int32_t> tystack;
			const intptr_t *iap;
			stree.byteadress = pjtr->ntvcode.GetLength();
			for(j = 0; j < stree.token.GetLength(); j++){
				iap = stree.token.GetConst()[j].GetConst();
				len = stree.token.GetConst()[j].GetLength();
				if(len == 0) continue;
				pjtr->gyousuu = stree.gyo.GetConst()[j];
				if(!KoubunSwitch(stree, iap, len, j)) return false;
			}
			if(stree.breakin){
				Return(0, false);
			}else{
				if(!DefDel(stree)) return false;
			}
			PBackpatch(stree.backpatch, pjtr->ntvcode.GetLength());
			return true;
		}
	};
	class LockCompi : public NormalCompi
	{
	public:
		virtual bool DefDel(SrcTree &stree)
		{
			intptr_t i;
			if(!NormalCompi::DefDel(stree)) return false;
			for(i = 0; i < stree.hikisuucount; i++) CallStk();
			return true;
		}
		virtual bool MainLoop(SrcTree &stree, const intptr_t *const iap, const intptr_t len, intptr_t &i, SrcTree *&retcall)
		{
			KuwashiiType ktype;
			PWCArray<int32_t> tystack;
			tystack.Clear();
			ktype.id = VOID_TYPEID;
			intptr_t j;
			for(; i < len; i++){
				if(iap[i] == BREAK_TOKEN){
					i++;
					if(stree.breakin) stree.breakpatch += Call(0);
					while(iap[i] < 0 || iap[i] == TILDE_TOKEN || iap[i] == MBR_TOKEN){
						for(; ; i++){
							if(!MainSwitch(stree, iap, i, tystack, ktype, retcall)) return false;
							if(iap[i] == SEMICOLON_TOKEN) break;
						}
						i++;
					}
					for(j = 0; j < stree.hikisuucount; j++) CallStk();
					if(iap[i] == COMMA_TOKEN){
						i++;
						if(!MainLoop(*stree.parent, iap, len, i, retcall)) return false;
					}else{
						if(iap[i] != SEMICOLON_TOKEN) return false;
						i++;
					}
					YobunPoper();
					stree.backpatch += Jump(0);
				}else{
					if(!MainSwitch(stree, iap, i, tystack, ktype, retcall)) return false;
				}
			}
			return true;
		}
	};
	class SwitchCompi : public NormalCompi
	{
		bool CaseTable(SrcTree &stree, const PWCArray<bool> &ueboo, const uint8_t ichi, const int32_t tid)
		{
			intptr_t i, j, tbli, bp;
			PWCArrayQuad< PWCArray<int> > numbn;
			PWCArray<bool> boo;
			if(ichi < 8){
				MovRegReg(ECX, EAX);
				ShrRegImm(ECX, ichi*4, false);
			}else{
				MovRegReg(ECX, EDX);
				ShrRegImm(ECX, (ichi-8)*4, false);
			}
			AndRegImm(ECX, 0xf);
			bp = JumpIdxCadr(2, ECX, 0);
			tbli = pjtr->ntvcode.GetLength();
			*(int32_t *)(pjtr->ntvcode.GetConst()+bp) += tbli;
			pjtr->ntvcode.SetLength(pjtr->ntvcode.GetLength() + 4*16);
			numbn.SetLength(16);
			for(i = 0; i < ueboo.GetLength(); i++){
				if(ueboo.GetConst()[i]) continue;
				numbn.GetData()[(*((uint8_t *)(stree.extswitch->atai.GetConst()+i)+(ichi>>1)) >> (ichi&0x01)*4) & 0x0f] += i;
			}
			for(i = 0; i < 16; i++){
				*(intptr_t *)(pjtr->ntvcode.GetConst()+tbli+4*i) = 0;
				pjtr->cadrpbp += tbli+4*i;
				if(numbn.GetConst()[i].GetLength() <= 0){
					stree.extswitch->defbp += tbli+4*i;
				}else if(numbn.GetConst()[i].GetLength() == 1){
					*(intptr_t *)(pjtr->ntvcode.GetConst()+tbli+4*i) += pjtr->ntvcode.GetLength();
					switch(tid){
					case BYTE_TYPEID: case UBYTE_TYPEID: case BOOL_TYPEID:
						CmpImm8((int8_t)stree.extswitch->atai.GetConst()[numbn.GetConst()[i].GetConst()[0]]); Equal();
						break;
					case SHORT_TYPEID: case USHORT_TYPEID: case CHAR_TYPEID:
						CmpImm((int16_t)stree.extswitch->atai.GetConst()[numbn.GetConst()[i].GetConst()[0]], true); Equal();
						break;
					default:
						if(tid < 0 || ENDCLASS_TYPEID < tid || stree.stat->funclist.Get(tid)->selftype != ENUM_BLOCK) return false;
					case INT_TYPEID: case ADDRESS_TYPEID: case UINT_TYPEID:
						CmpImm((int32_t)stree.extswitch->atai.GetConst()[numbn.GetConst()[i].GetConst()[0]], false); Equal();
						break;
					case LONG_TYPEID: case ULONG_TYPEID:
						EqualImm64(stree.extswitch->atai.GetConst()[numbn.GetConst()[i].GetConst()[0]]);
						break;
					case FLOAT_TYPEID:
						PushReg(EAX);
						FldStk(false);
						PushImm(*(int32_t*)&stree.extswitch->atai.GetConst()[numbn.GetConst()[i].GetConst()[0]]);
						FldStk(false);
						Fcomi(); Equal();
						break;
					case DOUBLE_TYPEID:
						PushReg(EDX);
						PushReg(EAX);
						FldStk(true);
						PushImm(((int32_t*)&stree.extswitch->atai.GetConst()[numbn.GetConst()[i].GetConst()[0]])[1]);
						PushImm(((int32_t*)&stree.extswitch->atai.GetConst()[numbn.GetConst()[i].GetConst()[0]])[0]);
						FldStk(true);
						Fcomi(); Equal();
						break;
					}
					stree.extswitch->ataibp[numbn.GetConst()[i].GetConst()[0]] = TrueJump(0);
					stree.extswitch->defbp += Jump(0);
				}
			}
			boo.SetLength(ueboo.GetLength());
			for(i = 0; i < boo.GetLength(); i++) boo.GetData()[i] = true;
			for(i = 0; i < 16; i++){
				if(numbn.GetConst()[i].GetLength() < 2) continue;
				for(j = 0; j < numbn.GetConst()[i].GetLength(); j++) boo.GetData()[numbn.GetConst()[i].GetConst()[j]] = false;
				*(intptr_t *)(pjtr->ntvcode.GetConst()+tbli+4*i) += pjtr->ntvcode.GetLength();
				CaseTable(stree, boo, ichi+1, tid);
				for(j = 0; j < numbn.GetConst()[i].GetLength(); j++) boo.GetData()[numbn.GetConst()[i].GetConst()[j]] = true;
			}
			return true;
		}
	public:
		virtual bool MainLoop(SrcTree &stree, const intptr_t *const iap, const intptr_t len, intptr_t &i, SrcTree *&retcall)
		{
			KuwashiiType ktype;
			PWCArray<int32_t> tystack;
			tystack.Clear();
			ktype.id = VOID_TYPEID;
			for(; i < len; i++){
				switch(iap[i]){
				case DEFAULT_TOKEN:
					i++;
					YobunPoper();
					if(stree.extswitch->def == 0){
						stree.extswitch->defbp += Jump(0);
					}else{
						Jump(stree.extswitch->def);
					}
					break;
				case BREAK_TOKEN:
					if(!Break(stree, iap, len, i, tystack, ktype, retcall)) return false;
					break;
				default:
					if(!MainSwitch(stree, iap, i, tystack, ktype, retcall)) return false;
					break;
				}
			}
			return true;
		}
		virtual bool KoubunSwitch(SrcTree &stree, const intptr_t *const iap, const intptr_t len, intptr_t &j)
		{
			intptr_t i, ii, iii, sz;
			KuwashiiType ktyp;
			int32_t typ;
			int64_t t64;
			if(iap[0] == CASE_TOKEN || (iap[0] == DEFAULT_TOKEN && (iap[1] == COLON_TOKEN || iap[1] == COLOYAJIRUSHI_TOKEN))){
				if(!stree.extswitch->teeburutukutta){
					PWCArray<bool> boo;
					for(i = 0; i < stree.token.GetLength(); i++){
						ii = 0;
						if(stree.token.GetConst()[i].GetConst()[ii] != CASE_TOKEN) continue;
						do{
							ii++;
							if((typ = TokenTtoTypeId(stree.token.GetConst()[i].GetConst(), ii)) < 0){
								pjtr->root->stat->ss->ErrorMessage.Add(*pjtr->filename, pjtr->gyousuu, L"caseɂl܂B");
								return false;
							}
							stree.extswitch->atai += (int64_t)0;
							sz = stree.CastConst(typ, stree.token.GetConst()[i].GetConst()+ii,
								stree.extswitch->swtype, &stree.extswitch->atai.Tail());
							if(sz < 0){
								pjtr->root->stat->ss->ErrorMessage.Add(*pjtr->filename, pjtr->gyousuu, L"caseɂl܂B");
								return false;
							}
							for(iii = 0; iii < stree.extswitch->atai.GetLength()-1; iii++){
								if(stree.extswitch->atai.GetConst()[iii] == stree.extswitch->atai.GetTail()){
									pjtr->root->stat->ss->ErrorMessage.Add(*pjtr->filename, pjtr->gyousuu, L"caseɓl܂B");
									return false;
								}
							}
							ii += (sz + sizeof(intptr_t)-1) / sizeof(intptr_t);
						}while(stree.token.GetConst()[i].GetConst()[ii] == COMMA_TOKEN);
					}
					boo.SetLength(stree.extswitch->atai.GetLength());
					for(ii = 0; ii < boo.GetLength(); ii++) boo.GetData()[ii] = false;
					ktyp.id = stree.extswitch->swtype;
					if(ktyp.id == FLOAT_TYPEID){
						PopReg(EAX);
					}else if(ktyp.id == DOUBLE_TYPEID){
						PopReg(EAX);
						PopReg(EDX);
					}else{
						KTPop(ktyp);
						KTDrop(ktyp);
					}
					if(!CaseTable(stree, boo, 0, stree.extswitch->swtype)) return false;
					stree.extswitch->teeburutukutta = true;
				}
				if(iap[len-1] == COLOYAJIRUSHI_TOKEN){
					PBackpatch(stree.extswitch->tgnsuruusakibp, pjtr->ntvcode.GetLength());
				}else{
					stree.extswitch->tgnsuruusakibp += Jump(0);
				}
				if(iap[0] == DEFAULT_TOKEN){
					if(stree.extswitch->def != 0) return false;
					stree.extswitch->def = pjtr->ntvcode.GetLength();
					PBackpatch(stree.extswitch->defbp, pjtr->ntvcode.GetLength());
				}else{
					ii = 0;
					do{
						ii++;
						if((typ = TokenTtoTypeId(iap, ii)) < 0) return false;
						t64 = 0;
						sz = stree.CastConst(typ, iap+ii, stree.extswitch->swtype, &t64);
						if(sz < 0) return false;
						ii += (sz + sizeof(intptr_t)-1) / sizeof(intptr_t);
						for(iii = 0; iii < stree.extswitch->atai.GetLength(); iii++){
							if(stree.extswitch->atai.GetConst()[iii] == t64){
								*(intptr_t*)(pjtr->ntvcode.GetConst()+stree.extswitch->ataibp.GetConst()[iii]) += pjtr->ntvcode.GetLength();
								break;
							}
						}
					}while(iap[ii] == COMMA_TOKEN);
				}
			}else{
				if(iap[0] == BREAK_TOKEN && iap[1] == COLON_TOKEN){
					PBackpatch(stree.extswitch->tgnsuruusakibp, pjtr->ntvcode.GetLength());
					if(stree.extswitch->def == 0) PBackpatch(stree.extswitch->defbp, pjtr->ntvcode.GetLength());
				}
				if(!NormalCompi::KoubunSwitch(stree, iap, len, j)) return false;
			}
			return true;
		}
		virtual bool DefDel(SrcTree &stree)
		{
			if(!stree.breakin){
				PBackpatch(stree.extswitch->tgnsuruusakibp, pjtr->ntvcode.GetLength());
				if(stree.extswitch->def == 0) PBackpatch(stree.extswitch->defbp, pjtr->ntvcode.GetLength());
			}
			if(!NormalCompi::DefDel(stree)) return false;
			return true;
		}
		bool FuncTreeCompile(SrcTree &stree)
		{
			KuwashiiType typ;
			if(!NormalCompi::FuncTreeCompile(stree)) return false;
			if(!stree.extswitch->teeburutukutta){
				typ.id = stree.extswitch->swtype;
				(bool)KTPop(typ);
			}
			return true;
		}
	};
	class BranchCompi : public NormalCompi
	{
		void CondTable(SrcTree &stree, const PWCArray<bool> &ueboo, const uint8_t ichi)
		{
			intptr_t i, j, tbli, bp;
			PWCArrayQuad< PWCArray<int> > numbn;
			PWCArray<bool> boo;
			MovRegReg(ECX, EAX);
			ShrRegImm(ECX, ichi*4, false);
			AndRegImm(ECX, 0xf);
			bp = JumpIdxCadr(2, ECX, 0);
			tbli = pjtr->ntvcode.GetLength();
			*(int32_t *)(pjtr->ntvcode.GetConst()+bp) += tbli;
			pjtr->ntvcode.SetLength(pjtr->ntvcode.GetLength() + 4*16);
			numbn.SetLength(16);
			for(i = 0; i < ueboo.GetLength(); i++){
				if(ueboo.GetConst()[i]) continue;
				numbn.GetData()[(*((uint8_t *)(&i)+(ichi>>1)) >> (ichi&0x01)*4) & 0x0f] += i;
			}
			for(i = 0; i < 16; i++){
				*(intptr_t *)(pjtr->ntvcode.GetConst()+tbli+4*i) = 0;
				pjtr->cadrpbp += tbli+4*i;
				if(numbn.GetConst()[i].GetLength() <= 0){
					stree.extbranch->tgnelsesakibp += tbli+4*i;
				}else if(numbn.GetConst()[i].GetLength() == 1){
					*(intptr_t *)(pjtr->ntvcode.GetConst()+tbli+4*i) += pjtr->ntvcode.GetLength();
					CmpImm(numbn.GetConst()[i].GetConst()[0], false); Equal();
					stree.extbranch->labelbp.GetData()[numbn.GetConst()[i].GetConst()[0]] = TrueJump(0);
					stree.extbranch->tgnelsesakibp += Jump(0);
				}
			}
			boo.SetLength(ueboo.GetLength());
			for(i = 0; i < boo.GetLength(); i++) boo.GetData()[i] = true;
			for(i = 0; i < 16; i++){
				if(numbn.GetConst()[i].GetLength() < 2) continue;
				for(j = 0; j < numbn.GetConst()[i].GetLength(); j++) boo.GetData()[numbn.GetConst()[i].GetConst()[j]] = false;
				*(intptr_t *)(pjtr->ntvcode.GetConst()+tbli+4*i) += pjtr->ntvcode.GetLength();
				CondTable(stree, boo, ichi+1);
				for(j = 0; j < numbn.GetConst()[i].GetLength(); j++) boo.GetData()[numbn.GetConst()[i].GetConst()[j]] = true;
			}
		}
		void MakeTable(SrcTree &stree)
		{
			intptr_t ii;
			PWCArray<bool> boo;
			stree.extbranch->labelbp.SetLength(stree.extbranch->label.GetLength());
			boo.SetLength(stree.extbranch->label.GetLength());
			for(ii = 0; ii < boo.GetLength(); ii++) boo.GetData()[ii] = false;
			MovRegSIB(EAX, SIB(0, ESP, ESP), 0);
			CondTable(stree, boo, 0);
		}
		void LabelBP(BranchExtStruct &bes)
		{
			intptr_t i;
			for(i = 0; i < bes.labelbp.GetLength(); i++){
				if(bes.labelbp.GetConst()[i] != 0){
					*(intptr_t*)(pjtr->ntvcode.GetConst()+bes.labelbp.GetConst()[i]) += pjtr->ntvcode.GetLength();
					bes.labelbp.GetData()[i] = 0;
				}
			}
		}
	public:
		virtual bool MainLoop(SrcTree &stree, const intptr_t *const iap, const intptr_t len, intptr_t &i, SrcTree *&retcall)
		{
			KuwashiiType ktype;
			PWCArray<int32_t> tystack;
			tystack.Clear();
			ktype.id = VOID_TYPEID;
			for(; i < len; i++){
				switch(iap[i]){
				case ELSE_TOKEN:
					i++;
					if(stree.extbranch->mode < 0){
						if(stree.extbranch->bunkisita != 0) AddRegImm(ESP, 4);
						PushImm(-1);
					}
					YobunPoper();
					stree.extbranch->tgnelsesakibp += Jump(0);
					break;
				case BREAK_TOKEN:
					if(stree.extbranch->mode < 0 && stree.extbranch->bunkisita != 0) pjtr->yobunipop += Aliszof<int32_t>();
					if(!Break(stree, iap, len, i, tystack, ktype, retcall)) return false;
					break;
				default:
					if(!MainSwitch(stree, iap, i, tystack, ktype, retcall)) return false;
					break;
				}
			}
			return true;
		}
		virtual bool KoubunSwitch(SrcTree &stree, const intptr_t *const iap, const intptr_t len, intptr_t &j)
		{
			KuwashiiType ktype;
			PWCArray<int32_t> tystack;
			SrcTree *retcall = NULL;
			intptr_t i;
			if(iap[0] == COND_TOKEN){
				stree.extbranch->bunkisita = 1;
				if(stree.extbranch->nextcond != 0){
					stree.extbranch->tgncommsakibp += Jump(0);
					*(intptr_t*)(pjtr->ntvcode.GetConst()+stree.extbranch->nextcond) += pjtr->ntvcode.GetLength();
					stree.extbranch->nextcond = 0;
				}
				if(stree.extbranch->mode < 0){
					i = 2;
				}else{
					i = 1;
				}
				ktype.id = VOID_TYPEID;
				tystack += BOOL_TYPEID;
				do{
					if(!MainSwitch(stree, iap, i, tystack, ktype, retcall)) return false;
					i++;
				}while(iap[i] != COLON_TOKEN);
				if(tystack.GetLength() <= 0 || tystack.GetTail() != BOOL_TYPEID) return false;
				stree.extbranch->nextcond = FalseJump(0);
				tystack.SetLength(tystack.GetLength()-2);
				ktype.id = VOID_TYPEID;
				if(stree.extbranch->mode < 0) PushImm(iap[1]);
			}else if(iap[0] == ELSE_TOKEN && iap[1] == COLON_TOKEN){
				if(stree.extbranch->commnai){
					MakeTable(stree);
					stree.extbranch->commnai = false;
				}
				stree.extbranch->tgncommsakibp += Jump(0);
				if(stree.extbranch->nextcond != 0){
					*(intptr_t *)(pjtr->ntvcode.GetConst()+stree.extbranch->nextcond) += pjtr->ntvcode.GetLength();
					stree.extbranch->nextcond = 0;
					if(stree.extbranch->mode < 0 && stree.extbranch->bunkisita > 0){
						PushImm(-1);
					}
				}
				PBackpatch(stree.extbranch->tgnelsesakibp, pjtr->ntvcode.GetLength());
			}else if(iap[0] == COMM_TOKEN && iap[1] == COLON_TOKEN){
				stree.extbranch->bunkisita = -1;
				if(stree.extbranch->nextcond != 0){
					*(intptr_t *)(pjtr->ntvcode.GetConst()+stree.extbranch->nextcond) += pjtr->ntvcode.GetLength();
					stree.extbranch->nextcond = 0;
				}
				LabelBP(*stree.extbranch);
				PBackpatch(stree.extbranch->tgnelsesakibp, pjtr->ntvcode.GetLength());
				PBackpatch(stree.extbranch->tgncommsakibp, pjtr->ntvcode.GetLength());
				stree.extbranch->commnai = true;
			}else if(iap[0] == DIFF_TOKEN && iap[2] == COLON_TOKEN){
				if(stree.extbranch->commnai){
					MakeTable(stree);
					stree.extbranch->commnai = false;
				}
				stree.extbranch->tgncommsakibp += Jump(0);
				*(intptr_t *)(pjtr->ntvcode.GetConst()+stree.extbranch->labelbp.GetConst()[iap[1]]) += pjtr->ntvcode.GetLength();
				stree.extbranch->labelbp.GetData()[iap[1]] = 0;
			}else{
				if(iap[0] == BREAK_TOKEN && iap[1] == COLON_TOKEN){
					LabelBP(*stree.extbranch);
					if(stree.extbranch->nextcond != 0){
						*(intptr_t*)(pjtr->ntvcode.GetConst()+stree.extbranch->nextcond) += pjtr->ntvcode.GetLength();
						stree.extbranch->nextcond = 0;
					}
					PBackpatch(stree.extbranch->tgnelsesakibp, pjtr->ntvcode.GetLength());
					PBackpatch(stree.extbranch->tgncommsakibp, pjtr->ntvcode.GetLength());
					if(stree.extbranch->mode < 0 && stree.extbranch->bunkisita != 0){
						AddRegImm(ESP, 4);
					}
				}
				if(!NormalCompi::KoubunSwitch(stree, iap, len, j)) return false;
			}
			return true;
		}
		virtual bool DefDel(SrcTree &stree)
		{
			if(!stree.breakin){
				LabelBP(*stree.extbranch);
				if(stree.extbranch->nextcond != 0){
					*(intptr_t*)(pjtr->ntvcode.GetConst()+stree.extbranch->nextcond) += pjtr->ntvcode.GetLength();
					stree.extbranch->nextcond = 0;
				}
				PBackpatch(stree.extbranch->tgnelsesakibp, pjtr->ntvcode.GetLength());
				PBackpatch(stree.extbranch->tgncommsakibp, pjtr->ntvcode.GetLength());
				if(stree.extbranch->mode < 0 && stree.extbranch->bunkisita != 0){
					AddRegImm(ESP, 4);
				}
			}
			if(!NormalCompi::DefDel(stree)) return false;
			return true;
		}
	};
	class LoopCompi : public NormalCompi
	{
	public:
		virtual bool MainLoop(SrcTree &stree, const intptr_t *const iap, const intptr_t len, intptr_t &i, SrcTree *&retcall)
		{
			KuwashiiType ktype;
			PWCArray<int32_t> tystack;
			tystack.Clear();
			ktype.id = VOID_TYPEID;
			for(; i < len; i++){
				switch(iap[i]){
				case DO_TOKEN:
					i++;
					YobunPoper();
					if(stree.extloop->doad == 0){
						stree.extloop->doadbp += Jump(0);
					}else{
						Jump(stree.extloop->doad);
					}
					break;
				case CONTINUE_TOKEN:
					i++;
					YobunPoper();
					if(stree.extloop->contad == 0){
						stree.extloop->contadbp += Jump(0);
					}else{
						Jump(stree.extloop->contad);
					}
					break;
				case WHILE_TOKEN:
					i++;
					YobunPoper();
					if(stree.extloop->nextad == 0){
						stree.extloop->nextadbp += Jump(0);
					}else{
						Jump(stree.extloop->nextad);
					}
					break;
				case BREAK_TOKEN:
					if(!Break(stree, iap, len, i, tystack, ktype, retcall)) return false;
					break;
				default:
					if(!MainSwitch(stree, iap, i, tystack, ktype, retcall)) return false;
					break;
				}
			}
			return true;
		}
		virtual bool KoubunSwitch(SrcTree &stree, const intptr_t *const iap, const intptr_t len, intptr_t &j)
		{
			KuwashiiType ktype;
			PWCArray<int32_t> tystack;
			SrcTree *retcall = NULL;
			intptr_t i;
			if(iap[0] == DO_TOKEN && iap[1] == COLON_TOKEN){
				stree.extloop->doad = pjtr->ntvcode.GetLength();
				PBackpatch(stree.extloop->doadbp, pjtr->ntvcode.GetLength());
			}else if(iap[0] == CONTINUE_TOKEN && iap[1] == COLON_TOKEN){
				stree.extloop->contad = pjtr->ntvcode.GetLength();
				PBackpatch(stree.extloop->contadbp, pjtr->ntvcode.GetLength());
			}else if(iap[0] == WHILE_TOKEN && iap[1] != SEMICOLON_TOKEN){
				stree.extloop->nextad = pjtr->ntvcode.GetLength();
				if(stree.extloop->contadbp.GetLength() > 0){
					pjtr->root->stat->ss->ErrorMessage.Add(*pjtr->filename, pjtr->gyousuu, L"continue:܂B");
					return false;
				}
				PBackpatch(stree.extloop->nextadbp, pjtr->ntvcode.GetLength());
				i = 1;
				ktype.id = VOID_TYPEID;
				tystack += BOOL_TYPEID;
				do{
					if(!MainSwitch(stree, iap, i, tystack, ktype, retcall)) return false;
					i++;
				}while(iap[i] != COLON_TOKEN);
				if(ktype.id != BOOL_TYPEID) return false;
				TrueJump(stree.extloop->doad);
				tystack.SetLength(tystack.GetLength()-2);
				ktype.id = VOID_TYPEID;
			}else{
				if(iap[0] == BREAK_TOKEN && iap[1] == COLON_TOKEN){
					if(stree.extloop->doadbp.GetLength() > 0){
						pjtr->root->stat->ss->ErrorMessage.Add(*pjtr->filename, pjtr->gyousuu, L"do:܂B");
						return false;
					}
					if(stree.extloop->contadbp.GetLength() > 0){
						pjtr->root->stat->ss->ErrorMessage.Add(*pjtr->filename, pjtr->gyousuu, L"continue:܂B");
						return false;
					}
					if(stree.extloop->nextadbp.GetLength() > 0){
						pjtr->root->stat->ss->ErrorMessage.Add(*pjtr->filename, pjtr->gyousuu, L"while:܂B");
						return false;
					}
				}
				if(!NormalCompi::KoubunSwitch(stree, iap, len, j)) return false;
			}
			return true;
		}
		virtual bool DefDel(SrcTree &stree)
		{
			if(!stree.breakin){
				if(stree.extloop->doadbp.GetLength() > 0){
					pjtr->root->stat->ss->ErrorMessage.Add(*pjtr->filename, pjtr->gyousuu, L"do:܂B");
					return false;
				}
				if(stree.extloop->contadbp.GetLength() > 0){
					pjtr->root->stat->ss->ErrorMessage.Add(*pjtr->filename, pjtr->gyousuu, L"continue:܂B");
					return false;
				}
				if(stree.extloop->nextadbp.GetLength() > 0){
					pjtr->root->stat->ss->ErrorMessage.Add(*pjtr->filename, pjtr->gyousuu, L"while:܂B");
					return false;
				}
			}
			if(!NormalCompi::DefDel(stree)) return false;
			return true;
		}
	};
	class DelegateCompi : public FuncCompi
	{
	public:
		bool FuncTreeCompile(SrcTree &stree)
		{
			intptr_t j;
			KuwashiiType ktype;
			const intptr_t *iap;
			intptr_t siz;
			intptr_t len;
			pjtr->filename = &stree.srce->filename;
			stree.byteadress = pjtr->ntvcode.GetLength();
			PBackpatch(stree.backpatch, pjtr->ntvcode.GetLength());
			siz = 0;
			for(j = stree.tpcount; j < stree.tpcount+stree.hikisuucount; j++){
				siz += stree.frp->funchensuu.GetConst()[j].size;
			}
			PopReg(EDX);
			if(siz > 0){
				PopReg(EAX);
				MovRegReg(ECX, EAX);
				AddRegImm(ECX, 8+stree.frp->GetMemberOffset(stree.tpcount+stree.hikisuucount-1));//^[AhXƑOEBP8
				for(j = 0; j < siz; j += 4){
					PopRadr(ECX);
					AddRegImm(ECX, 4);
				}
				AddRegImm(ESP, 8);//ŏɐς܂ꂽR[AhXEBP8
			}else{
				PopReg(EAX);
			}
			PopReg(ECX);
			PushReg(EDX);
			PushReg(EDI);
			PushReg(EBP);
			MovRegReg(EBP, EAX);
			MovRegReg(EDI, ECX);
			for(j = 0; j < stree.token.GetLength(); j++){
				iap = stree.token.GetConst()[j].GetConst();
				len = stree.token.GetConst()[j].GetLength();
				if(len == 0) continue;
				pjtr->gyousuu = stree.gyo.GetConst()[j];
				if(!KoubunSwitch(stree, iap, len, j)) return false;
			}
			if(stree.rettype.GetTail() != VOID_TOKEN){
				if(stree.token.GetLength() <= 0 || stree.token.GetConst()[j-1].GetConst()[len-1] != RETURN_TOKEN
					|| (stree.token.GetLength() >= 2 && stree.token.GetConst()[j-2].GetConst()[0] == IF_TOKEN))
				{
					pjtr->root->stat->ss->ErrorMessage.Add(*pjtr->filename, pjtr->gyousuu, L"return܂B");
					return false;
				}
			}else{
				ktype.id = VOID_TYPEID;
				if(!DefDel(stree)) return false;
				PopReg(EBP);
				PopReg(EDI);
				Return(0, false);
			}
			return true;
		}
	};
	FuncCompi fcom;
	NormalCompi ncom;
	LockCompi lkcom;
	SwitchCompi swcom;
	BranchCompi brcom;
	LoopCompi lpcom;
	DelegateCompi dgcom;
public:
	JITer(SrcTree *stroot)
	{
		root = stroot;
		yobunipop = 0;
		fcom.SetJtr(this);
		ncom.SetJtr(this);
		lkcom.SetJtr(this);
		swcom.SetJtr(this);
		brcom.SetJtr(this);
		lpcom.SetJtr(this);
		dgcom.SetJtr(this);
	}
	HANDLE Compile(MAIN_FUNC &fp, PWCArray<int8_t> &globalres)
	{
		HANDLE heap;
		SrcTree *pst;
		intptr_t i, ttl, bp;
		if(root->parent != NULL){
			root->stat->ss->ErrorMessage.Add(root->srce->filename, root->topsrcgyo, L"^̍łȂłB");
			return NULL;
		}
		ttl = root->stat->literaltotal;
		ntvcode.Clear();
		gbladrbp.Clear();
		pst = root;
		while(pst->subsrc != NULL) pst = pst->subsrc;
		while(pst->parent != NULL){
			if(pst->token.GetLength() > 0 || pst->defdel.GetLength() > 0){
				fcom.FuncCall(*pst);
			}
			pst->sonota.golbalgeta = ttl;
			bp = fcom.Jump(0);
			if(!fcom.FuncTreeCompile(*pst)) return false;
			*(intptr_t*)(ntvcode.GetData()+bp) += ntvcode.GetLength();
			ttl += pst->GetMemberSize();
			pst = pst->parent;
		}
		fcom.FuncCall(*root);
		fcom.PushImm((int32_t)root->stat->ss);
		fcom.PluginCall(fcom.RunGbld);
		fcom.Return(0, true);
		root->sonota.golbalgeta = ttl;
		if(!fcom.FuncTreeCompile(*root)) return false;
		ttl += root->GetMemberSize();
		globalres.SetLength(ttl);
		ttl = 0;
		for(i = 0; i < root->stat->literallist.GetLength(); i++){
			memcpy(globalres.GetData()+ttl, root->stat->literallist.GetConst()[i].GetConst(), root->stat->literallist.GetConst()[i].GetLength());
			if(root->stat->literallist.GetConst()[i].GetLength() > sizeof(Reference)+sizeof(HeapObjHead)){
				((Reference*)(globalres.GetData()+ttl))->pointer = (HeapObj*)((intptr_t)(globalres.GetData()+ttl+sizeof(Reference)) | INTPTR_MIN);
			}else{
				((Reference*)(globalres.GetData()+ttl))->pointer = NULL;
			}
			((HeapObjHead*)(globalres.GetData()+ttl+sizeof(Reference)))->data = (int8_t*)(globalres.GetData()+ttl+sizeof(Reference)+sizeof(HeapObjHead));
			ttl += root->stat->literallist.GetConst()[i].GetLength();
		}
		fcom.PBackpatch(gbladrbp, (intptr_t)globalres.GetConst());
		heap = HeapCreate(HEAP_NO_SERIALIZE | HEAP_CREATE_ENABLE_EXECUTE, 0, 0);
		fp = (MAIN_FUNC)HeapAlloc(heap, 0, ntvcode.GetLength());
		fcom.PBackpatch(cadrpbp, (intptr_t)fp);
		fcom.MBackpatch(cadrmbp, (intptr_t)fp);
		memcpy(fp, ntvcode.GetConst(), ntvcode.GetLength());
		ntvcode.Clear();
		return heap;
	}
};

